
#include "rb_plugin.h"
#ifdef TARGET_WIN32
	
#else
	#include <Movies.h>
	#include <ImageCompression.h>
	#include <ImageCodec.h>
	#include <Components.h>
	#include <QuickTimeComponents.h>
	#include <QuickTimeVR.h>
	#include <QuickTimeVRFormat.h>
	#include <MediaHandlers.h>
	#define QT					// Jan 17 2001 -- GCC (1)
	#if !CARBON		
		#include "carbonLayer.h"
	#endif
#endif



// Prototypes
static void captureOpen(REALcontrolInstance instance);
static void captureClose(REALcontrolInstance instance);
static void captureStartup(REALcontrolInstance instance);
static void captureDispose(REALcontrolInstance instance);
//static short BESTCaptureDemoTest(void);

#ifdef TARGET_WIN32
static void captureDraw(REALcontrolInstance instance, REALgraphics context);
#else
static void captureEventFilterHandler (EventRecord *event, long theSGComp);
static void captureDraw(REALcontrolInstance instance);
#endif
static Boolean captureIsVideoDeviceAvailable(REALcontrolInstance instance);
static Boolean captureIsSoundDeviceAvailable(REALcontrolInstance instance);
static void captureSetEnableVideo(REALcontrolInstance instance, long param, Boolean value);
static Boolean captureGetEnableVideo(REALcontrolInstance instance, long param);
static void captureSetEnableSound(REALcontrolInstance instance, long param, Boolean value);
static Boolean captureGetEnableSound(REALcontrolInstance instance, long param);
static Boolean captureShowVideoSettingsDialog(REALcontrolInstance instance);
static Boolean captureShowSoundSettingsDialog(REALcontrolInstance instance);
static Boolean captureIsPreviewing(REALcontrolInstance instance);
static Boolean captureIsRecording(REALcontrolInstance instance);
static Boolean captureIsPaused(REALcontrolInstance instance);
static void captureIdle(REALcontrolInstance instance);

static void captureStartRecording(REALcontrolInstance instance, REALfolderItem theMovieFile);

static void captureStartPreviewing(REALcontrolInstance instance);
static void capturePause(REALcontrolInstance instance);
static void captureResume(REALcontrolInstance instance);
static void captureStop(REALcontrolInstance instance);

static void captureFireErrorEvent(REALcontrolInstance instance, long theError);

static void captureFireRecordEvent(REALcontrolInstance instance);

static void captureFireStopEvent(REALcontrolInstance instance);

static void captureSetPreviewState(REALcontrolInstance instance, long param, Boolean theState);
static Boolean captureGetPreviewState(REALcontrolInstance instance, long param);
static void captureSetPreviewWhileRecordingState(REALcontrolInstance instance, long param, Boolean theState);

REALstring REALstringFromPString(const unsigned char *pstring);

static void captureSetVideoDeviceSourceIndex(REALcontrolInstance instance, long theDeviceIndex);//EJT 14 FEB 2004

//static void captureSetSoundDeviceSourceIndex(REALcontrolInstance instance, long theDeviceIndex);//EJT 17 FEB 2004
//End Prototypes

//PROTOTYPES FOR DEVICE CONTROL
static void captureDeviceControlShuttle(REALcontrolInstance instance, long theSpeed);
static void captureDeviceControlReversePlay(REALcontrolInstance instance);
static void captureDeviceControlPlay(REALcontrolInstance instance);
static void captureDeviceControlStop(REALcontrolInstance instance);
static void captureDeviceControlPause(REALcontrolInstance instance);
static void captureDeviceControlFastForward(REALcontrolInstance instance);
static void captureDeviceControlRewind(REALcontrolInstance instance);

