

// WinCapture.cpp
//
//  2001-2003 BEST Software Design -- All Rights Reserved
//
// Document Authors: Benjamin Schneider (BJS), Erick Tejkowski (EJT)
// Document Contributors: 
//
// Revision History
// April 1 2002 -- EJT & BJS (1)	Initial implementations for MacOS and Mac OS X
// June 30 2003 -- EJT & BJS (1)	Initial implementations for Win32


#include <unknwn.h>
#include <windows.h>
#include <dbt.h>
#include <streams.h>
#include <mmreg.h>
#include <msacm.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <tchar.h>
#include <commdlg.h>
#include <pdh.h>
#include <atlconv.h>
#include <commctrl.h>
#include <time.h>
#include <Prsht.h>
#include <fstream.h>
#include <iostream.h>
#include <process.h>
#include "capture.h"
#include "status.h"
#include "WinDirectCapture.h"
#include <String.h>
#include <qedit.h>
#include <objbase.h>
#include <wchar.h>

#include <dxerr9.h>
#include <xprtdefs.h>//for device control raw AV/C commands

//------------------------------------------------------------------------------
// Macros
//------------------------------------------------------------------------------
#define ABS(x) (((x) > 0) ? (x) : -(x))

//
//  Time value constants
//
#define MAX_TIME      ((LONGLONG)0x7FFFFFFFFFFFFFFF)
#define MIN_TIME      ((LONGLONG)0)

#define mydebug	1

#define WM_FGNOTIFY WM_USER+1


//static WCHAR *bestDeviceID1, *bestDeviceID2, *bestDeviceID3, *bestDeviceID4, *bestDeviceID5, *bestDeviceID6, *bestDeviceDefault;
BSTR bestDeviceID1, bestDeviceID2, bestDeviceID3, bestDeviceID4, bestDeviceID5, bestDeviceID6, bestDeviceDefault;

//  EJT D-VERSION
BSTR			bestDevice1Path, 
				bestDevice2Path, 
				bestDevice3Path, 
				bestDevice4Path, 
				bestDevice5Path, 
				bestDevice6Path, 
				bestDeviceDefaultPath;

BSTR			bestDevice1Name, 
				bestDevice2Name, 
				bestDevice3Name, 
				bestDevice4Name, 
				bestDevice5Name, 
				bestDevice6Name, 
				bestDeviceDefaultName;				

long			bestDevice1Active, 
				bestDevice2Active, 
				bestDevice3Active, 
				bestDevice4Active, 
				bestDevice5Active, 
				bestDevice6Active, 
				bestDeviceActive;


//***********************************************************
//
//       AUDIO DEVICES
//
//***********************************************************
BSTR			bestAudioDevice1Path, 
				bestAudioDevice2Path, 
				bestAudioDevice3Path, 
				bestAudioDevice4Path, 
				bestAudioDevice5Path, 
				bestAudioDevice6Path, 
				bestAudioDeviceDefaultPath;



BSTR			bestAudioDevice1Name, 
				bestAudioDevice2Name, 
				bestAudioDevice3Name, 
				bestAudioDevice4Name, 
				bestAudioDevice5Name, 
				bestAudioDevice6Name, 
				bestAudioDeviceDefaultName;		

								
//  EJT D-VERSION
//IGraphBuilder 			*data->pFg;//pFg;

//int xxxx=-1;
extern struct REALcontrol captureControl;

REALevent captureEvents[] = {
	{ "Error(theError As Integer)" },
	{ "Record()" },
	{ "Stop()" }
};

struct captureData
{

	//***********************************************************
	//  Mac Parameters 
	//   = params we'll also use in Windows
	// 	the rest come in the Windows params that follow these
	//  $$$ = params we won't use in Win32 (change to dummies)
	//  QQQ = params we need to alter to remove QT dependencies
	//***********************************************************
	int 					fillColor;									// color in RB color format (xxRRGGBB)//
	long			 		theSGComp;									//$$$QQQ
	long	 				theSGGraphicsPort; 							//$$$QQQ
	Rect 					theSGBounds, theNaturalBounds;				//QQQ
	long	 				theSGVideoChannel, theSGSoundChannel;		//$$$QQQ
	Boolean					enableSound, enableVideo, pauseState, recordState, previewState, previewWhileRecording; //
	Boolean					testProp;									//
	//EventRecord 			captureEvent;								//is EventRecord an RB structure?
	long					sampleRate, frameRate;						//$$$QQQ
	short					sampleSize, numChan, theDepth, soundVolume;	//
	long					soundCType, videoCType;						//QQQ
	long					inDevNum, theKeyFrameRate;					//
	REALpicture				theNoPreviewPicture;						//
	long					theSpatialQuality, theTemporalQuality; 		//$$$QQQ
	long					theSGSoundDeviceList, theSGVideoDeviceList; //$$$QQQ
	long					theVideoComponent;							//$$$QQQ
		
	//***********************************************************
	//  Windows Parameters 
	//***********************************************************
	//these *must* match on the Mac side
	//but I only think the total size matters...
	//that way we can convert params between the two platforms
	//e.g. get rid of QT dependencies in Win version
	

	TCHAR 					szCaptureFile[_MAX_PATH];
    WORD 					wCapFileSize;  // size in Meg
    ICaptureGraphBuilder2 	*pBuilder;
    IVideoWindow 			*pVW;
    IMediaEventEx 			*pME;
    IAMStreamConfig 		*pASC;  	    // for audio cap
    IAMStreamConfig 		*pVSC;	      	// for video cap
    IBaseFilter 			*pGrabberBase;	
    ISampleGrabber 			*pGrabber;
    IBaseFilter 			*pSmartTee;
    IBaseFilter 			*pNULLRenderer;
    IBaseFilter				*dvGrabDecoder; 
    IBaseFilter				*dvPreviewDecoder; 
    IBaseFilter				*dvGrabSplitter; 
    IBaseFilter				*dvPreviewSplitter; 
    IBaseFilter				*aviDecompressor; 
    IBaseFilter				*colorSpaceGrabConverter; 
    IBaseFilter				*colorSpacePreviewConverter; 
    IMediaControl 			*pMC;
    IBaseFilter 			*pRender;
    IBaseFilter 			*pVCap, *pACap;
    IGraphBuilder 			*pFg;
    IConfigAviMux 			*pConfigAviMux;
    int  					iMasterStream;
    BOOL 					fPreviewing;	
    BOOL 					fCapturing;
    BOOL 					fMPEG2;
    BOOL 					fCapAudio;
    BOOL 					fCapCC;
    BOOL 					usingVMR;
    double 					FrameRate;
    WCHAR 					wachFriendlyName[120];
    WCHAR 					wachAudioFriendlyName[120];
    BOOL 					fUseFrameRate;
    HWND 					ghwndApp;
    m_dwGraphRegister
    
    long					videoSlotNumber;
    long					audioSlotNumber;
    
    IBaseFilter 			*pMux;
    IBaseFilter 			*pWrite;
    
    long					VRCreated;
	IBaseFilter 			*pInfTee;
	
	BOOL					useDVAudioDevice;
	IBaseFilter 			*pDVSplit; 
	IBaseFilter 			*pDVDec;
	
	BOOL 					refreshPreviewPicture;//for redrawing the noPreviewPicture

	IBaseFilter 			*pAudioRender;
};



//_DVRESOLUTION           m_DVResolution; //  resolution of DV decoder
//int *m_DVResolution;
int m_DVResolution;


//------------------------------------------------------------------------------
#ifdef WIN32
//------------------------------------------------------------------------------

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(x) \
   if(x != NULL)        \
   {                    \
      x->Release();     \
      x = NULL;         \
   }
#endif 


//*************************************************************************
//
//  PROTOTYPES
//
//*************************************************************************

void 		REALMessageBoxx(REALstring thestring);
BOOL 		MakeGraph(REALcontrolInstance instance);
BOOL 		MakeBuilder(REALcontrolInstance instance);
int 		GetVideoDeviceCount(void);
int 		SetupInitialVideoDevice(REALcontrolInstance instance);
int 		SetupInitialAudioDevice(REALcontrolInstance instance);
char*		wtoa(wchar_t *ws, int wscnt);
wchar_t *	atow(char *s, int *wscnt);
int 		GetAudioDeviceCount(void);
int 		GetAudioDeviceName(REALcontrolInstance instance);
REALstring 	GetVideoDeviceNameByIndex(int theindex);

REALstring 	GetVideoDevicePathByIndex(int theindex);

REALstring 	GetAudioDeviceNameByIndex(int theindex);
HRESULT 	ConnectFilters(IGraphBuilder *pGraph, IPin *pOut, IBaseFilter *pDest);
HRESULT 	ConnectFilters(IGraphBuilder *pGraph, IBaseFilter *pSrc, IBaseFilter *pDest);
HRESULT 	GetUnconnectedPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir, IPin **ppPin);
HRESULT 	GetConnectedPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir, IPin **ppPin);
BOOL 		StopCapture(REALcontrolInstance instance);
BOOL 		StartCapture(REALcontrolInstance instance, REALfolderItem theMovieFile);
BOOL 		StopPreview(REALcontrolInstance instance);
BOOL 		BuildCaptureGraph(REALcontrolInstance instance);
void 		TearDownGraph(REALcontrolInstance instance);
void 		NukeDownstream(REALcontrolInstance instance, IBaseFilter *pf, BOOL releaseFilters);
void 		IMonRelease(IMoniker *&pm);
void 		ClearGraphs( REALcontrolInstance instance);
long 		CheckState(REALcontrolInstance instance);

void 		CreateSmartTee(REALcontrolInstance instance);
void 		ConnectBranches(REALcontrolInstance instance);
HRESULT 	get_pin(IBaseFilter * pFilter, PIN_DIRECTION dir, int n, IPin **ppPin);
void 		CreateVideoRenderer(REALcontrolInstance instance);
void 		CreateNULLRenderer(REALcontrolInstance instance);
void 		CreateSampleGrabber(REALcontrolInstance instance);
void		CreateDVGrabDecoder(REALcontrolInstance instance);
void		CreateDVPreviewDecoder(REALcontrolInstance instance);
void		CreateDVGrabSplitter(REALcontrolInstance instance);
void		CreateDVPreviewSplitter(REALcontrolInstance instance);
void		CreateAVIDecompressor(REALcontrolInstance instance);
void		CreateColorSpaceGrabConverter(REALcontrolInstance instance);
void		CreateColorSpacePreviewConverter(REALcontrolInstance instance);

void 		removeGraphFromRot(DWORD dwRegister);
HRESULT 	addGraphToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);

bool 		SaveDIBTest(REALcontrolInstance instance);//, char* filename);

static REALstring gCaptureGetIDPath(int index);

int 		GetFreeVideoDevicePathSlot(void);
int 		GetFreeAudioDevicePathSlot(void);

BOOL 		IsDeviceOutputDV(IBaseFilter * pFilter);
void 		MyFreeMediaType(AM_MEDIA_TYPE& mt);
void 		MyDeleteMediaType(AM_MEDIA_TYPE *pmt);

int 		GetDVAudioCount(REALcontrolInstance instance);

REALstring 	captureGetIndexedDVSoundDeviceName(REALcontrolInstance instance, int theIndex);

HRESULT 	AddFilterByCLSID( IGraphBuilder *pGraph, const GUID& clsid, LPCWSTR wszName, IBaseFilter **ppF);

HRESULT 	FindPinByCategory(IBaseFilter *pF, PIN_DIRECTION PinDir, const GUID& Category, IPin **ppPin);
BOOL 		PinMatchesCategory(IPin *pPin, const GUID& Category);
bool isDVFormat(REALcontrolInstance instance);


void CreateAudioInfiniteTee(REALcontrolInstance instance);
void CreateAudioPreviewRender(REALcontrolInstance instance);



//********************************************************************************************************
//
//  Device Control functions
//
//********************************************************************************************************
//PROTOTYPES FOR DEVICE CONTROL
static void captureDeviceControlPlay(REALcontrolInstance instance);
static void captureDeviceControlStop(REALcontrolInstance instance);
static void captureDeviceControlFreeze(REALcontrolInstance instance);
static void captureDeviceControlFastForward(REALcontrolInstance instance);
static void captureDeviceControlRewind(REALcontrolInstance instance);
static void captureDeviceControlRecord(REALcontrolInstance instance);
static void captureDeviceControlRecordFreeze(REALcontrolInstance instance);
static void captureDeviceControlPlayReverse(REALcontrolInstance instance);

static void captureDeviceControlShuttle(REALcontrolInstance instance, long theSpeed);


/*
static void captureDeviceControlThaw(REALcontrolInstance instance);
static void captureDeviceControlStrobe(REALcontrolInstance instance);
static void captureDeviceControlStep(REALcontrolInstance instance);
static void captureDeviceControlShuttle(REALcontrolInstance instance);
*/
static long captureDeviceControlGetMode(REALcontrolInstance instance);


//audio pin setting code
static long setAudioDeviceInput(REALcontrolInstance instance, long inputIndex);
static long getAudioPinCount(REALcontrolInstance instance);

//static Boolean captureShowVideoSettingsPinDialog(REALcontrolInstance instance);


//********************************************************************************************************
//  DV size settings window
//
//********************************************************************************************************
HRESULT 	GetVideoWindowDimensions (REALcontrolInstance instance, int* pWidth, int *pHeight, BOOL bChangeResolution,HWND hwndApp);
HRESULT 	GetResolutionFromDVDecoderPropertyPage(REALcontrolInstance instance, HWND hwndApp, BOOL bChangeResolution);
HRESULT 	SeekATN(int iHr, int iMn, int iSc, int iFr);
//BOOL 		IsDeviceOutputDV(IBaseFilter * pFilter);
#define SAFE_RELEASE(pObject) if(pObject){ pObject->Release(); pObject = NULL;}

#define DVENCODER_WIDTH             720
#define PAL_DVENCODER_HEIGHT        576
#define NTSC_DVENCODER_HEIGHT       480

/*
enum _DVDECODERRESOLUTION {
    DVDECODERRESOLUTION_720x480     = 1000,
    DVDECODERRESOLUTION_360x240     = 1001,
    DVDECODERRESOLUTION_180x120     = 1002,
    DVDECODERRESOLUTION_88x60       = 1003
};
*/

enum _DVRESOLUTION {
    DVRESOLUTION_FULL    = 1000,     
    DVRESOLUTION_HALF    = 1001,
    DVRESOLUTION_QUARTER = 1002,
    DVRESOLUTION_DC      = 1003
};

_DVENCODERVIDEOFORMAT   m_VideoFormat; //pal or ntsc


//------------------------------------------------------------------------------
// Global data
//------------------------------------------------------------------------------
HINSTANCE 	ghInstApp=0;
HACCEL 		ghAccel=0;
HFONT  		ghfontApp=0;
TEXTMETRIC 	gtm={0};
TCHAR 		gszAppName[]=TEXT("AMCAP");
DWORD 		g_dwGraphRegister=0;

#endif//#ifdef WIN32s


#pragma mark -


//********************************************************************************************************


#ifdef WIN32
// SwapBytes
//
// Swap byte ordering
//
// Used In: uhtonl
// Gets: buffer -- the buffer to swap
// 		 len -- number of bytes in buffer to swap
// Returns: <nothing>
// Comment: Feb 05 2001 -- WYU (1)
static void SwapBytes(char *buffer, int len)
{
	int i, mid;
	char ch;
	
 	////REALMessageBoxx(REALBuildString("SwapBytes",8));
	
	mid = len / 2;
	for (i = 0; i < mid; i++) {
		ch = buffer[i];
		buffer[i] = buffer[len - i - 1];
		buffer[len - i - 1] = ch;
	}
}

// uhtonl
//
// Convert from big endian to little endian, or vice versa
//
// Used In: graphicsExporterDefaultExtensionGetter
// Gets: v -- the value to convert
// Returns: converted value
// Comment: Feb 05 2001 -- WYU (1)
static unsigned long uhtonl(unsigned long v)
{
	
	SwapBytes((char *) &v, 4);
	return v;
}
#endif

#pragma mark -

static void captureInit(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	if (REALinRuntime())
	{
		data->refreshPreviewPicture = true;
	}		
}

static void captureOpen(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	if (REALinRuntime())
	{
		//start things up
		captureStartup(instance);
	}
	else
	{
		//in the IDE, just sit and do nada
		REALSetControlVisible(instance, 1L); 
	}
}

static void captureClose(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if ( REALinRuntime() )
	{
		//unregister the GraphRot stuff (GraphEdit) 
		if (data->m_dwGraphRegister)
        {
            removeGraphFromRot(data->m_dwGraphRegister);
        }
            
		// Destroy the filter graph and cleanup
    	if (StopPreview(instance))
   		{
	   		//REALMessageBox(REALBuildString("StopPreview=0",13));
    	}
		
		// I *guess* the TearDownGraph call is executed properly (necessary too?)... EJT 2/4/4
    	TearDownGraph(instance);
    
	    //Reset the appropriate global variables
	    //so they can be reused later
	    switch (data->videoSlotNumber)
	    {
	    	case 1:
	    		bestDeviceID1 = SysAllocString(L"Unused Device");
	    		bestDevice1Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 2:
				bestDeviceID2 = SysAllocString(L"Unused Device");
				bestDevice2Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 3:
				bestDeviceID3 = SysAllocString(L"Unused Device");
				bestDevice3Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 4:
				bestDeviceID4 = SysAllocString(L"Unused Device");
				bestDevice4Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 5:
				bestDeviceID5 = SysAllocString(L"Unused Device");
				bestDevice5Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 6:
				bestDeviceID6 = SysAllocString(L"Unused Device");
				bestDevice6Path = SysAllocString(L"Unused Device");
	    		break;
	    }
    
	    bestDeviceDefault = SysAllocString(L"Unused Device");
    	bestDeviceDefaultPath = SysAllocString(L"Unused Device");

	}//if (REALinRuntime())
}

static void captureStartup(REALcontrolInstance instance)
{
	/*
	captureStartup: 
		create pFG
		create pBuilder
		connect pFG and pBuilder
		captureSetEnableVideo(data->enableVideo)
	*/
  		
	ControlData(captureControl, instance, captureData, data);
	::Rect	r;
	HRESULT hr = 0;
	
	//set default value
	data->useDVAudioDevice = false;
	
	//********************************************************************************************************
	// Get bounds
	//********************************************************************************************************
	REALGetControlBounds(instance, &r);
	data->theSGBounds.left = r.left;
	data->theSGBounds.top = r.top;
	data->theSGBounds.right = r.right;
	data->theSGBounds.bottom = r.bottom;
	
	//turn on video by default
	//data->enableVideo = TRUE;
	//turn on audio by default
	//data->enableSound = TRUE;
	
	data->fPreviewing = false;
	data->ghwndApp = REALGetWindowHandle(REALGetControlWindow(instance));
	if (data->ghwndApp == nil)
		return;
	
	
	
	/*
	To refresh try REALInvalidateControl,
	or REALSetControlVisible(c,0), REALSetControlVisible(c,1)
	or REALRefreshWindow(REALGetWindowHandle(REALGetControlWindow(c)))

	> ( For those of you who are wondering, I'm trying to get a loop that might
	> have millions+ of iterations to run as fast as possible, but I don't want to
	> scare the user into thinking that the computer is dead.

	This was a problem before with plugins.  I and others have had to call
	YieldToAnyThread during an iteration so that the progressbar moves and the
	program doesn't look frozen.  Now apparently there is a YieldtoRB function
	we can use instead if you can find the location of the plugin SDK that
	contains that function.

	*/
	
	//REALSetControlVisible(instance, 0L); // BJS
	
    //********************************************************//
	// Create the Capture Graph Builder.
    //********************************************************//

    if(data->pBuilder)
    {
        // we have one already
	}
	else
	{
		//nope, don't have one yet, so create one
		hr = CoCreateInstance (CLSID_CaptureGraphBuilder2 , NULL, CLSCTX_INPROC,
      						IID_ICaptureGraphBuilder2, (void **) &data->pBuilder);
	}
	
	if (SUCCEEDED(hr))
    {
        //********************************************************//
		// Create the Filter Graph.
	    //********************************************************//
    
	    if(data->pFg)
	    {
	        // we have one already
		}
		else
		{
			//nope, don't have one yet, so create one
			hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
	                                  IID_IGraphBuilder, (LPVOID *)&data->pFg);
		}
	
	    //********************************************************//
		// Set the Filter Graph of the Graph Builder.
	    //********************************************************//
		if (SUCCEEDED(hr))
        {
            // Initialize the Capture Graph Builder.
            data->pBuilder->SetFiltergraph(data->pFg);

			//************************************************************************
			//  create the Color Space Converter filter
			//************************************************************************
			CreateColorSpacePreviewConverter(instance);

			//************************************************************************   
			//  create the video renderer filter and add it to the graph
			//************************************************************************   
			data->VRCreated = 0;
			CreateVideoRenderer(instance);
		
			//************************************************************************   
			//  add to the rot
			//************************************************************************   
			hr = addGraphToRot(data->pFg, &data->m_dwGraphRegister);
	
			//********************************************************//
			// captureSetEnableVideo
			//********************************************************//   
			captureSetEnableVideo(instance, 0, data->enableVideo);

			//************************************************************************
			//  create the infinite tee for use with audio previewing... and meters?
			//************************************************************************
			//CreateAudioInfiniteTee(instance);
           
		}
        else
        {
            data->pBuilder->Release();
            data->pBuilder = NULL;
            
        }
	}//if (SUCCEEDED(hr)) created filtergraph
}

void CreateAudioInfiniteTee(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the inf tee filter for audio previewing and maybe meters
	//************************************************************************
	hr = CoCreateInstance(CLSID_InfTee , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->pInfTee);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add Color Space converter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->pInfTee, L"BEST InfTee");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->pInfTee   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->pInfTee   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateAudioInfiniteTee FAIL",27));
	}
	
}

void CreateAudioPreviewRender(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the inf tee filter for audio previewing and maybe meters
	//************************************************************************
	hr = CoCreateInstance(CLSID_DSoundRender , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->pAudioRender);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add Color Space converter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->pAudioRender, L"BEST Audio Render");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->pAudioRender   FAIL",35));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->pAudioRender     OK",35));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateAudioPreviewRender FAIL",27));
	}
	
}


static void captureDispose(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	//do nothing here, for now            
}

static void captureDraw(REALcontrolInstance instance, REALgraphics context)
{
	ControlData(captureControl, instance, captureData, data);

	long 				displayWidth, naturalWidth, displayHeight, naturalHeight;
	::Rect 				r;
	HRESULT 			hr;	
	IMediaControl* 		mc = NULL;
	IBasicVideo* 		bv = NULL;
	
	
	HDC 				hdc;
	HBRUSH 				hbrush; 	// Handle to BRUSH object
    HPEN 				hPen; 
	RECT 				pictRect,myRect;
		
	//get the bounds of the control
	REALGetControlBounds(instance, &r);
	
	if (REALinRuntime())
		{
		//**************************************************
		//  bounds-munging code - 
		//  do we really need to use theSGBounds in Win32?
		//  probably not
		//**************************************************
		
		data->theSGBounds.left = r.left;
		data->theSGBounds.top = r.top;
		data->theSGBounds.right = r.right;
		data->theSGBounds.bottom = r.bottom;
		
		//get the control's size
		displayWidth = r.right - r.left;
		displayHeight = r.bottom - r.top;

		//get the control
		hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
		if (FAILED(hr)) 
			return;
		
		//get the IBasicVideo
		hr = mc->QueryInterface(IID_IBasicVideo, (void **)&bv); 
		if (SUCCEEDED(hr)) 

		//get the video size
		hr = bv->GetVideoSize(&naturalWidth, &naturalHeight);
		if (naturalWidth > 0 && naturalHeight > 0)
			{
			data->theNaturalBounds.left = 0;
			data->theNaturalBounds.top = 0;
			data->theNaturalBounds.right = naturalWidth; 
			data->theNaturalBounds.bottom = naturalHeight; 
			}
		
		
		
		//**************************************************
		//  Win32 - DRAW THE REALPICTURE set for no preview
		//**************************************************
			
		if (!data->previewState || (data->recordState && !data->previewWhileRecording))
		{
	 		
	 		//REALGetControlBounds(instance, &myRect);
	 		
	 		//myWidth = myRect.right - myRect.left;
	 		//myHeight = myRect.bottom - myRect.top;
	 		
			pictRect.left = r.left;
			pictRect.top = r.top;
			pictRect.right = r.right;
			pictRect.bottom = r.bottom;

			hdc = REALGraphicsDC(context);

	 		if (data->theNoPreviewPicture)
			{
				//Mac
	 			//REALDrawPicturePrimitive(data->theNoPreviewPicture, &myRect, 0);
	 			
	 			//Win32 - DRAW THE REALPICTURE set for no preview
	 			//REALDrawPicturePrimitive(hdc, data->theNoPreviewPicture, pictRect, 0);
	 			REALDrawPicturePrimitive(hdc, data->theNoPreviewPicture, &r, 0);
	 			
	 		}
			else//if (data->theNoPreviewPicture)
	 		{
				//Win32 - draw blue if there's no REALpict set for no preview
				hbrush = CreateSolidBrush(RGB(0,0,255)); 
				if (FillRect(hdc,&pictRect,hbrush)){}
				
			}
			DeleteObject(hbrush); // Free memory 
			//**************************************************
			//  END REALPICT DRAWING CODE
			//**************************************************			
		
		
				
			/*
			To refresh try REALInvalidateControl,
			or REALSetControlVisible(c,0), REALSetControlVisible(c,1)
			or REALRefreshWindow(REALGetWindowHandle(REALGetControlWindow(c)))
			*/
			
			//REALInvalidateControl(instance);
			//REALSetControlVisible(instance,0);
			//REALSetControlVisible(instance,1);
			//REALRefreshWindow(REALGetWindowHandle(REALGetControlWindow(instance)));
			if (data->refreshPreviewPicture)//just redraw once
			{
				REALSetControlVisible(instance,0);
				REALSetControlVisible(instance,1);
				data->refreshPreviewPicture = false;
			}
			
			
		}
		else//if (!data->previewState || (data->recordState && !data->previewWhileRecording))
		{
		}
		
		
	}//if (REALinRuntime())
	else // not in runtime = drawing code for Win32 IDE
	{

			//**************************************************
			//  BEGIN ICON DRAWING CODE
			//**************************************************
        	hdc = REALGraphicsDC(context);
			
			pictRect.left = r.left;
			pictRect.top = r.top;
			pictRect.right = r.right;
			pictRect.bottom = r.bottom; 
			
			//fill the control with black
			hbrush = CreateSolidBrush(RGB(0,0,0)); 
            if (FillRect(hdc,&pictRect,hbrush)){}

			int myWidth = r.right - r.left;
	 		int myHeight = r.bottom - r.top;

			
			if (myWidth > 82 && myHeight > 62)
	 		{
	 		pictRect.left = r.left + ((myWidth - 80) / 2);
	 		pictRect.top = r.top + ((myHeight - 60) / 2);
	 		pictRect.right = r.left + 80;
	 		pictRect.bottom = r.top + 60;
	 		
	 		//draw grey box behind colorbars
	 		//simulating the ring around the icon
	 		//since i can't get FrameRect working for some dumb reason
	 		// medium grey
			myRect.left = pictRect.left-1;
			myRect.top = pictRect.top-1;
			myRect.right = pictRect.left+80+1;
			myRect.bottom = pictRect.top+60+1;
			hbrush = CreateSolidBrush(RGB(127,127,127)); 
            if (FillRect(hdc,&myRect,hbrush)){}
            
			// move through rects: left to right, top to bottom
			
			// top row
			// grey
			myRect.left = pictRect.left;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(204,204,204)); 
            if (FillRect(hdc,&myRect,hbrush)){}
			
			// yellow
			myRect.left = pictRect.left + 11;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(255,255,0)); 
            if (FillRect(hdc,&myRect,hbrush)){}
			
			// blue/green
			myRect.left = pictRect.left + 23;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(0,255,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}
			
			// green
			myRect.left = pictRect.left + 34;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(0,255,0)); 
            if (FillRect(hdc,&myRect,hbrush)){}
		
			// red/blue
			myRect.left = pictRect.left + 46;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(255,0,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}
		
			// red
			myRect.left = pictRect.left + 57;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(255,0,0)); 
            if (FillRect(hdc,&myRect,hbrush)){}

			// blue
			myRect.left = pictRect.left + 69;
			myRect.top = pictRect.top;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 40;
			hbrush = CreateSolidBrush(RGB(0,0,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// middle row
			// blue
			myRect.left = pictRect.left;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(0,0,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}

			
			// really dark grey
			myRect.left = pictRect.left + 11;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(19,19,19)); 
            if (FillRect(hdc,&myRect,hbrush)){}

			
			// red/blue
			myRect.left = pictRect.left + 23;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(255,0,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}

			
			// really dark grey
			myRect.left = pictRect.left + 34;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(19,19,19)); 
            if (FillRect(hdc,&myRect,hbrush)){}

		
			// blue/green
			myRect.left = pictRect.left + 46;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(0,255,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}

		
			// really dark grey
			myRect.left = pictRect.left + 57;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 12;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(19,19,19)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// grey
			myRect.left = pictRect.left + 69;
			myRect.top = pictRect.top + 40;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 5;
			hbrush = CreateSolidBrush(RGB(204,204,204)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// bottom row
			// dark blue
			myRect.left = pictRect.left;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 14;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(9,63,90)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// white
			myRect.left = pictRect.left + 14;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 14;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(255,255,255)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// purple
			myRect.left = pictRect.left + 28;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 14;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(59,0,127)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// really dark grey
			myRect.left = pictRect.left + 42;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 15;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(9,9,9)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// black
			myRect.left = pictRect.left + 57;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 4;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(0,0,0)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// really dark grey
			myRect.left = pictRect.left + 61;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 4;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(9,9,9)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// dark grey
			myRect.left = pictRect.left + 65;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 4;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(39,39,39)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			// really dark grey
			myRect.left = pictRect.left + 69;
			myRect.top = pictRect.top + 45;
			myRect.right = myRect.left + 11;
			myRect.bottom = myRect.top + 15;
			hbrush = CreateSolidBrush(RGB(9,9,9)); 
            if (FillRect(hdc,&myRect,hbrush)){}


			//draw white ring around icon
			//hbrush = CreateSolidBrush(RGB(255,0,0)); 
            //if (FrameRect(hdc,&pictRect,hbrush)){}


			}
			
			DeleteObject(hbrush); // Free memory 
		//**************************************************
		//  END ICON DRAWING CODE
		//**************************************************			
		}
}


#pragma mark  BEGIN STILL GRAB HELL 

void ClearGraphs( REALcontrolInstance instance)
{
    ControlData(captureControl, instance, captureData, data);
    
    HRESULT hr;
    IMediaControl *pControl = NULL;
    IVideoWindow* pWindow;
    
    // Destroy capture graph
    if( data->pFg )
    {
        hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&data->pMC);
		if( data->pMC ) 
        {
            REALMessageBoxx(REALBuildString("stopping running pMC",20));
            data->pMC->Stop( );
		}
		
		hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&pWindow);
		if(SUCCEEDED(hr))
		{
            //REALMessageBoxx(REALBuildString("videowindow gone",16));
		}
		else
		{
			//REALMessageBoxx(REALBuildString("videowindow not gone",20));
		}
		//nuke everything from camera on down
		NukeDownstream(instance, data->pVCap, true);
    }
    else
    {
    	//counldn't destroy capture graph
    }
}


long CheckState(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	LONG msTimeout;
	OAFilterState pfs = 0;
	
	msTimeout = 5000;
	
    HRESULT hr = data->pMC->GetState(msTimeout,&pfs);
    if (pfs == State_Running)
    {
    	//REALMessageBoxx(REALBuildString("STATE=RUN",9));
    	return (1);
    }
    else if (pfs == State_Stopped)
    {
    	//REALMessageBoxx(REALBuildString("STATE=STOP",10));
    	return (2);
    }
    else
    {
    	//REALMessageBoxx(REALBuildString("STATE=PAUSE",11));
    	return (3);
    }
}


bool SaveDIBTest(REALcontrolInstance instance)
// get picture and save it as bitmap 
{
	ControlData(captureControl, instance, captureData, data);
	bool ok = false; 
	char buf[1000]; 
	int i;
	
	IMediaControl* mc = NULL; 
	HRESULT hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
	if (SUCCEEDED(hr)) 
	{
		IBasicVideo* bv = NULL; 
		hr = mc->QueryInterface(IID_IBasicVideo, (void **)&bv); 
		if (SUCCEEDED(hr)) 
		{
			long size; 
			long* image = NULL; 
	
			long lWidth, lHeight; 
	
			bv->GetVideoSize(&lWidth, &lHeight); 
			
			//do the pause silliness described in the sdk
			//mc->Pause();
			//while (!CheckState(instance) == 3){}
				//mc->Pause();
			
			// determine size 
			bv->GetCurrentImage(&size,image); 
	
			char* buffer = new char[size]; 
	
			hr = bv->GetCurrentImage(&size,(long*)buffer); 
	
			if(SUCCEEDED(hr)) 
			{
				//ok = WriteDIB(filename,buffer,size); 
				ok = true;
			}
			else 
			{
				char* error; 
				switch(hr) 
				{
				case E_OUTOFMEMORY: 
					error = "Out of memory"; 
					break; 
				case VFW_E_NOT_PAUSED: 
					error = "Video is not paused"; 
					break; 
				case E_FAIL: 
					error = "Capture failed"; 
					break; 
				case E_INVALIDARG: 
					error = "Argument is invalid."; 
					break; 
				case E_NOTIMPL: 
					error = "Method is not supported."; 
					break; 
				case E_POINTER: 
					error = "NULL pointer argument."; 
					break; 
				case E_UNEXPECTED: 
					error = "Unexpected error."; 
					break; 
				default: 
					error = "Unknown error"; 
					break; 
				}
				i = sprintf(buf,"Errorcode: %u, \"%s\"",hr,error); 
				REALMessageBox(REALBuildString(buf,i));
				
			}
			delete [] buffer; 
			bv->Release(); 
		}
	
	mc->Release(); 
	}
	return ok; 
}

static REALpicture captureGrabPict(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	HRESULT 			hr, err;
	int 				i,j;
	char 				str[50];
	char buf[1000]; 

	char *pBuffer = NULL;
    IMediaControl* mc = NULL;
	IBasicVideo* bv = NULL;
	long size = 0; 
	long* image = NULL; 
	long lWidth, lHeight; 
	
	// Get the Media Controller
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc);
	if (FAILED(hr))
		return NULL;

	// Get the Basic Video interface
	hr = mc->QueryInterface(IID_IBasicVideo, (void **)&bv);
	if (FAILED(hr))
		return NULL;
	
	hr = bv->GetVideoSize(&lWidth, &lHeight);

	if (data->usingVMR)
		{
		//REALMessageBoxx(REALBuildString("Using VMR",9));
		hr = bv->GetCurrentImage(&size,image);
		if(SUCCEEDED(hr))
			{
			pBuffer = new char[size];
			hr = bv->GetCurrentImage(&size,(long*)pBuffer);
			if(!SUCCEEDED(hr)) 
				{
				char* error; 
				switch(hr) 
				{
				case E_OUTOFMEMORY: 
					error = "Out of memory"; 
					break; 
				case VFW_E_NOT_PAUSED: 
					error = "Video is not paused"; 
					break; 
				case E_FAIL: 
					error = "Capture failed"; 
					break; 
				case E_INVALIDARG: 
					error = "Argument is invalid."; 
					break; 
				case E_NOTIMPL: 
					error = "Method is not supported."; 
					break; 
				case E_POINTER: 
					error = "NULL pointer argument."; 
					break; 
				case E_UNEXPECTED: 
					error = "Unexpected error."; 
					break; 
				default: 
					error = "Unknown error"; 
					break; 
				}
				char buf[1000]; 
				int i;
				i = sprintf(buf,"Errorcode: %u, \"%s\"",hr,error); 
				REALMessageBox(REALBuildString(buf,i));
				}
			bv->Release();
			}
		}
	else // not using VMR
		{

		//the following two calls don't seem to be necessary anymore, since I ditched the VMR9 for the VMR (EJT 28 JUL 2004)
		//mc->Pause();
		//Sleep(2000);
		
		//get the image to find out how big the buffer is
		hr = bv->GetCurrentImage(&size,image); 
		pBuffer = new char[size];
		
		//ok, now really get the image
		hr = bv->GetCurrentImage(&size,(long*)pBuffer);
		if(!SUCCEEDED(hr)) 
			{
			char* error; 
			switch(hr) 
			{
			case E_OUTOFMEMORY: 
				error = "Out of memory"; 
				break; 
			case VFW_E_NOT_PAUSED: 
				error = "Video is not paused"; 
				break; 
			case E_FAIL: 
				error = "Capture failed"; 
				break; 
			case E_INVALIDARG: 
				error = "Argument is invalid."; 
				break; 
			case E_NOTIMPL: 
				error = "Method is not supported."; 
				break; 
			case E_POINTER: 
				error = "NULL pointer argument."; 
				break; 
			case E_UNEXPECTED: 
				error = "Unexpected error."; 
				break; 
			default: 
				error = "Unknown error"; 
				break; 
			}
			
			i = sprintf(buf,"Errorcode: %u, \"%s\"",hr,error); 
			REALMessageBox(REALBuildString(buf,i));
			}
		bv->Release();
		mc->Run();
		
		}

	if(pBuffer == NULL)
		return NULL;

	return REALBuildPictureFromDIB (pBuffer, true);
}

static void captureSetEnableVideo(REALcontrolInstance instance, long param, Boolean value)
{
	ControlData(captureControl, instance, captureData, data);
	
	HRESULT 	hr;
	::Rect		r;
	int 		n = 0;

	data->enableVideo = value;
	
	if (REALinRuntime())
	{
		REALGetControlBounds(instance, &r);
		if (data->enableVideo)
		{
			//if we do't have a filtergraph, create one
			if(!data->pFg)
			{
				hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder, (LPVOID *)&data->pFg);
			}
			
			//how many video devices?
			if  (data->pVCap == NULL)
			{
				n = GetVideoDeviceCount();
			}
			
			//set up the default video device
			if  (data->pVCap == NULL)
			{
				n = SetupInitialVideoDevice(instance);
			}
			
			//set up the default audio device
			if  (data->pACap == NULL)
			{
				n = SetupInitialAudioDevice(instance);
			}
			
			//set the preview
			captureSetPreviewState(instance, 0, data->previewState);

		}
		else
		{
			BOOL oldPreviewState;
			oldPreviewState = captureGetPreviewState(instance, 0);
			
			//turn off preview
			captureSetPreviewState(instance, 0, false);
			
			//remember what the preview state was
			data->previewState = oldPreviewState;
			//REALSetControlVisible(instance, 0L); 
		}
	}//RunTime
}

static Boolean captureGetEnableVideo(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	//video enabled for this control?
	return data->enableVideo;
}

static void captureSetEnableSound(REALcontrolInstance instance, long param, Boolean value)
{
	ControlData(captureControl, instance, captureData, data);
	//set sound enabled for this control
	data->enableSound = value;
}

static Boolean captureGetEnableSound(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	//sound enabled for this control?
	return data->enableSound;
}


static REALstring captureGetSettings(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	//this is where we deal with retrieving the settings as a string


	char str[512];
	int i;
	//i = sprintf(str, "data->videoSlotNumber = %d",data->videoSlotNumber);
	//REALMessageBoxx(REALBuildString(str,i));

//data->videoSlotNumber
/*
switch (data->videoSlotNumber)
	    {
	    	case 1:
	    		bestDeviceID1 = SysAllocString(L"Unused Device");
	    		bestDevice1Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 2:
				bestDeviceID2 = SysAllocString(L"Unused Device");
				bestDevice2Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 3:
				bestDeviceID3 = SysAllocString(L"Unused Device");
				bestDevice3Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 4:
				bestDeviceID4 = SysAllocString(L"Unused Device");
				bestDevice4Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 5:
				bestDeviceID5 = SysAllocString(L"Unused Device");
				bestDevice5Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 6:
				bestDeviceID6 = SysAllocString(L"Unused Device");
				bestDevice6Path = SysAllocString(L"Unused Device");
	    		break;
	    }
*/

//REALstring stuff
//theName = REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);

	//return nil;
	//return REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
	
	
//	The C way:
/*
	char sum[100]; 			// must be large enough to hold both strings
	strcpy (sum, dest1); 	// copies dest1 to the string buffer
  	strcat (sum, dest2); 	// add dest2 to the string buffer
*/

	
	int x = 0;//use to track the total length of string we'll return
	
	char sum[1024]; 			// must be large enough to hold both strings
	char sum2[2048]; 			// must be large enough to hold both strings
	
	char dest1[256]; 		// must be large enough to hold both strings
	char dest2[256]; 		// must be large enough to hold both strings

	dest2[0]='*';
	dest2[1]='B';
	dest2[2]='E';
	dest2[3]='S';
	dest2[4]='T';
	dest2[5]='*';
	
	
	//********************************
	// devicePath
	//********************************
	/*
	strcpy (sum, REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber))); 	// copies dest1 to the string buffer
	x=x+strlen(REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber)));
	strcat (sum, dest2); 	// add dest2 to the string buffer ===>>> this is our delimiter "*BEST*"
  	x=x+6;
	*/

	//********************************
	// deviceName
	//********************************
	/*
	strcpy (sum2, sum); 	// copies dest1 to the string buffer
	strcat (sum2, REALCString(GetVideoDeviceNameByIndex(data->videoSlotNumber))); 	// copies dest1 to the string buffer
	x=x+strlen(REALCString(GetVideoDeviceNameByIndex(data->videoSlotNumber)));
	strcat (sum2, dest2); 	// add dest2 to the string buffer ===>>> this is our delimiter "*BEST*"
  	x=x+6;
	*/
	
	//i = sprintf(sum2, "%s ABCDEFGHIJKLMNOPQRSTUVWXYZ", sum);
	
	/*
	i = sprintf(sum2, "%s*BEST*%s",
					REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber)),
					REALCString(GetVideoDeviceNameByIndex(data->videoSlotNumber))  
				);
	x=x+strlen(REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber)));
	x=x+strlen(REALCString(GetVideoDeviceNameByIndex(data->videoSlotNumber)));
	x=x+6;
	*/
	
	i = sprintf(sum2, "%s",
					REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber))
				);
	x=x+strlen(REALCString(GetVideoDevicePathByIndex(data->videoSlotNumber)));
	//x=x+strlen(REALCString(GetVideoDeviceNameByIndex(data->videoSlotNumber)));
	//x=x+6;
	
	return REALBuildString(sum2,x);//512);
	
	//return gCaptureGetIDPath(data->videoSlotNumber);//int index)
	//REALstring 	GetVideoDevicePathByIndex(int theindex);
	//return REALBuildString( wtoa(bestDevice1Path,bestDevice1Path[0]),bestDevice1Path[0]);
	
	
	// PARAMS WE CARE ABOUT:

	//from the app 
	
	// monitor enablePreview
	// monitor previewWhileRecording
	// monitor size?
	// audio devicePath
	// audio deviceName
	// audio channelEnabled
	// image settings(?)

	//from directshow
	
}

static void captureSetSettings(REALcontrolInstance instance, long param, REALstring theSettings)
{
	ControlData(captureControl, instance, captureData, data);
	
	//this is where we set the control(s?) to previous settings
	//based on a string that the user passes
	
//************************************************************************************************************
//************************************************************************************************************
	// 1. we get the devicePath in a REALstring format
	// 2. convert to wide?
		//NO! // 3. find out if data->videoSlotNumber = "Unused Device"; if not, reject w/err
	// 4. find out if this desired devicePath is in the bestDeviceID globals already; if so, reject w/err
	// 5. Set the device for this control
//************************************************************************************************************
//************************************************************************************************************		


//int 				*theLen = 0;
//wchar_t 			*wx;
//char 				*ax;

//------------------------------------
//  ax ==> an ascii string
//  wx ==> a wide string
//------------------------------------

//turn the REALstring to a C string
//ax = (char*)REALCString(theSettings);	  
//convert from an ascii string to a wide string
//wx = atow(ax,theLen);


//loop through all device paths
//and see if this device is already in use
//if it is, throw an err
//if not, set this device fr this control


	
/*
	switch (data->videoSlotNumber)
	    {
	    	case 1:
	    		bestDeviceID1 = SysAllocString(L"Unused Device");
	    		bestDevice1Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 2:
				bestDeviceID2 = SysAllocString(L"Unused Device");
				bestDevice2Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 3:
				bestDeviceID3 = SysAllocString(L"Unused Device");
				bestDevice3Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 4:
				bestDeviceID4 = SysAllocString(L"Unused Device");
				bestDevice4Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 5:
				bestDeviceID5 = SysAllocString(L"Unused Device");
				bestDevice5Path = SysAllocString(L"Unused Device");
	    		break;
	    	case 6:
				bestDeviceID6 = SysAllocString(L"Unused Device");
				bestDevice6Path = SysAllocString(L"Unused Device");
	    		break;
	    }
    
	    bestDeviceDefault = SysAllocString(L"Unused Device");
    	bestDeviceDefaultPath = SysAllocString(L"Unused Device");
*/    	
    	
}

static short captureGetPreviewMode(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	//this means nothing on Win32 - Mac-only feature
	return 0;
}

static void captureSetPreviewMode(REALcontrolInstance instance, long param, short theMode)
{
	ControlData(captureControl, instance, captureData, data);
	//this means nothing on Win32 - Mac-only feature
}


static long captureGetVideoWidth(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	HRESULT 			hr = 0;
	long 				theWidth, theHeight;
	::Rect 				r;
	IMediaControl* 		mc = NULL;
	IBasicVideo* 		bv = NULL;
	

    char str[50];
	int i;
	i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
	//REALMessageBoxx(REALBuildString(str,i));


	REALGetControlBounds(instance, &r);

	//**************************************************
	//  natural bounds code goes here!
	//**************************************************
	
	data->theSGBounds.left = r.left;
	data->theSGBounds.top = r.top;
	data->theSGBounds.right = r.right;
	data->theSGBounds.bottom = r.bottom;
	
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
	if (FAILED(hr)) 
		return 0;
	
	hr = mc->QueryInterface(IID_IBasicVideo, (void **)&bv); 
	if (FAILED(hr)) 
		return 0;

	hr = bv->GetVideoSize(&theWidth, &theHeight); // BJS 11/08/03	
	
	i = sprintf(str, "GetVideoSize: w = %d h = %d",theWidth,theHeight);
	//REALMessageBoxx(REALBuildString(str,i));
	i = sprintf(str, "REALGetControlBounds: l=%d t=%d r=%d b=%d",r.left,r.top,r.right,r.bottom);
	//REALMessageBoxx(REALBuildString(str,i));
	
	if (theWidth > 0 && theHeight > 0)
		{
		data->theNaturalBounds.left = 0;
		data->theNaturalBounds.top = 0;
		data->theNaturalBounds.right = theWidth; // BJS 11/08/03
		data->theNaturalBounds.bottom = theHeight; // BJS 11/08/03
		}

	//return (720);
	//return (data->theNaturalBounds.right - data->theNaturalBounds.left);
	
	return (data->theNaturalBounds.right - data->theNaturalBounds.left)*2;
	//return (data->theNaturalBounds.right - data->theNaturalBounds.left);
}

static long captureGetVideoHeight(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	HRESULT 			hr = 0;
	long 				theWidth, theHeight;
	::Rect 				r;
	IMediaControl* 		mc = NULL;
	IBasicVideo* 		bv = NULL;
	
	//**************************************************
	//  bounds of the control
	//**************************************************
	
	REALGetControlBounds(instance, &r);

	data->theSGBounds.left = r.left;
	data->theSGBounds.top = r.top;
	data->theSGBounds.right = r.right;
	data->theSGBounds.bottom = r.bottom;

	//**************************************************
	//  bounds of the video
	//**************************************************	
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
	if (FAILED(hr)) 
		return 0;
	
	hr = mc->QueryInterface(IID_IBasicVideo, (void **)&bv); 
	if (FAILED(hr)) 
		return 0;

	hr = bv->GetVideoSize(&theWidth, &theHeight); 
	
	if (theWidth > 0 && theHeight > 0)
		{
		data->theNaturalBounds.left = 0;
		data->theNaturalBounds.top = 0;
		data->theNaturalBounds.right = theWidth; 
		data->theNaturalBounds.bottom = theHeight; 
		}
	return (data->theNaturalBounds.bottom - data->theNaturalBounds.top)*2;
}



static long captureGetSoundDeviceCurrent(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	return 0;
}

static long captureGetSoundDeviceCount(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	int n = 0;	
	int i = 0;
	
	n = GetAudioDeviceCount();
	i = GetDVAudioCount(instance);
	
	return n + i;
}

static REALstring captureGetIndexedSoundDeviceName(REALcontrolInstance instance, int index)
{
	ControlData(captureControl, instance, captureData, data);
	
	if ( (index+1) > GetAudioDeviceCount() )
	{
		//device video devices posing as audio devices
		return captureGetIndexedDVSoundDeviceName(instance, (index+1-GetAudioDeviceCount()) );
	}
	else
	return GetAudioDeviceNameByIndex(index+1);
}

REALstring captureGetIndexedDVSoundDeviceName(REALcontrolInstance instance, int theIndex)
{
	ControlData(captureControl, instance, captureData, data);

	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	REALstring 			theName = REALBuildString("Unknown",7);
	char 				*strA;
	int					dvcount = 0;
	IBaseFilter 		*tempACap;
	
	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,//we scan video looking for an AUDIO DV device... stupid MS
	        &pEnum, 0);
	} 
	else
	{
		return theName;
	}

	int count = 0;
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    // Find the description or friendly name.
	    VARIANT varName;
	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	        //i = sprintf(str, "FriendlyName");
			//REALMessageBoxx(REALBuildString(str, i));
	    }
	    if (SUCCEEDED(hr))
	    {
	        //i = sprintf(str, "we found a dv device");
			//REALMessageBoxx(REALBuildString(str, i));
			//REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
					
			hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&tempACap);
			if (SUCCEEDED(hr))
			{
				if (IsDeviceOutputDV(tempACap) )
					{
					dvcount++;
					//i = sprintf(str, "dvcount = %d ::: theIndex = %d",dvcount, theIndex);
					//REALMessageBoxx(REALBuildString(str, i));
					}
			} 
			
			//did we find the DV device name we are looking for?
	        if (dvcount == theIndex)
	        	{
	        		theName = REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
					
					pMoniker->Release();
	    			tempACap->Release();
	    			pPropBag->Release();
	    			pMoniker->Release();
	    			VariantClear(&varName); 
				    return theName;
	        	}
	        
	        VariantClear(&varName); 
	    }
	    
	    pPropBag->Release();
	    pMoniker->Release();
	    
	} 
	return theName;
}


static Boolean captureGetIndexedSoundDeviceAvailable(REALcontrolInstance instance, int index)
{
	ControlData(captureControl, instance, captureData, data);
	return false;
}

static void captureSetSoundDeviceName(REALcontrolInstance instance, REALstring theDeviceName)
{
	ControlData(captureControl, instance, captureData, data);
	
	const char *theCStringName;
	theCStringName = REALCString(theDeviceName);
	
	//*******************************************************	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;
	REALstring theName = REALBuildString("Unknown",7);
	

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	} 
	else
	{
		return;
	}

	int count = 0;
	HWND hList; // Handle to the list box.
	IMoniker *pMoniker = NULL;
	VARIANT varName;
	
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 

	    // Find the description or friendly name.
	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char *strA; 
	        
	        //compare new name with names in the list 
	        if (strcmp( wtoa(varName.bstrVal,varName.bstrVal[0]) ,theCStringName) == 0)
	        {
	        	
            	//********************************************************************
		        //     this is where you choose a device to use... 
		        //     we're gonna use the #1 = quickCam for test purposes
		        //********************************************************************
					hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
					if (SUCCEEDED(hr))
					{
					    theName = REALBuildString( (wtoa(varName.bstrVal,varName.bstrVal[0])) ,varName.bstrVal[0]);
					    lstrcpyW(data->wachFriendlyName, varName.bstrVal);
					    //if (!data->pACap)
					    //{
					    	hr = data->pFg->AddFilter(data->pACap, data->wachFriendlyName);
					    	if (SUCCEEDED(hr))
					    		{
					    			////REALMessageBoxx(REALBuildString("pACap YES",9));  
					    		}
					    	else
					    		{
					    			////REALMessageBoxx(REALBuildString("pACap NO",8));  
					    		}
						//}
					} 
	        	//********************************************************************
	        
	        	
				VariantClear(&varName);
				pPropBag->Release();
	    		pMoniker->Release();
	    		return;//we found it, so let's leave this func.
	        }
	        VariantClear(&varName); 
	    }
	    
	    pPropBag->Release();
	    pMoniker->Release();
	    
	} 
	
	return;
}

static long captureGetCurrentSoundDeviceSourceCount(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
    
	if(data->pACap == NULL)
		return -1;

	int 				counter = 0;
	IAMAudioInputMixer 	*mixer = NULL;
    IPin 				*pP;
    ULONG 				u;
    IEnumPins 			*pins = NULL;
    PIN_INFO 			pininfo;
    HRESULT 			hr = data->pACap->EnumPins(&pins);

    pins->Reset();
        
    while(hr == NOERROR)
        {
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
                {
                        hr = pP->QueryPinInfo(&pininfo);
                        if(hr == NOERROR)
                        {
                                if(pininfo.dir == PINDIR_INPUT)
                                {
                                        counter++;
                                }
                                if(pininfo.pFilter)
                                        pininfo.pFilter->Release();
                        }
                        
            pP->Release();
        }
    }
    if(pins)
        pins->Release();

	return counter;
}

static REALstring captureGetIndexedSoundDeviceSource(REALcontrolInstance instance, int index)
{
	ControlData(captureControl, instance, captureData, data);
 	REALstring 			theName = REALBuildString("Unknown",7);
 	   
	if(data->pACap == NULL)
		return theName;

	char asciiname[256];
	char *asKiiname;
	
	int i;
	
	char str[256];
	int ii=0;
	//const char *asciiname;
	//char str[50];
	
	
	/*
	
typedef enum _PinDirection {
    PINDIR_INPUT,
    PINDIR_OUTPUT
} PIN_DIRECTION;

typedef struct  _PinInfo {
    IBaseFilter *pFilter;
    PIN_DIRECTION dir;
    WCHAR achName[128];
} PIN_INFO;

	*/
	
	char *pmbc = (char *)malloc( sizeof( char ) );
	int 				counter = 0;
	int n=0;
	IAMAudioInputMixer 	*mixer = NULL;
    IPin 				*pP;
    ULONG 				u;
    IEnumPins 			*pins = NULL;
    PIN_INFO 			pininfo;
    HRESULT 			hr = data->pACap->EnumPins(&pins);
	
char *s;

    pins->Reset();
        
    while(hr == NOERROR)
        {
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
                {
                        hr = pP->QueryPinInfo(&pininfo);
                        
                        if (SUCCEEDED(hr))
                        //if(hr == NOERROR)
                        {
                                if(pininfo.dir == PINDIR_INPUT)
                                {
                                        if ( (pininfo.dir == PINDIR_INPUT) && (index == counter) )
                                		{
                                        	
                                        	//wcslen(pininfo.achname)
                                        	static const WCHAR fooW[] = {'E','J','T',0};
                                        	
                                        	//n = WideCharToMultiByte(CP_ACP, 0, fooW , -1, asciiname, 256, 0,0);
                                        	//n = WideCharToMultiByte(CP_ACP, 0, fooW , -1, asciiname, 256, 0,0);
                                        	//n = WideCharToMultiByte(CP_ACP, 0, pininfo.achName , -1, asciiname, 256, 0,0);//NULL, NULL);
                                        	
                                        	
                                        	////n = WideCharToMultiByte(CP_ACP, 0, pininfo.achName , -1, asKiiname, 0, 0,0);//NULL, NULL);
                                        	
                                        	
                                        	//n = WideCharToMultiByte(CP_ACP, 0, pininfo.achName , -1, asciiname, 256, 0,0);//NULL, NULL);
                                        	
                                        	//printf( "Convert multibyte character back to a wide character:\n" );
 											//i = mbtowc( pwc, pmbc, MB_CUR_MAX );
 
 											
 											
 											
 											/*
 											char *pmbc = (char *)malloc( sizeof( char ) );
										  wchar_t wc = L'a';
										  wchar_t *pwcnull = NULL;
										  wchar_t *pwc = (wchar_t *)malloc( sizeof( wchar_t ) );
										  printf( "Convert a wide character to multibyte character:\n" );
										  */
										 
										 	//n = wctomb( pmbc, pininfo.achName );
											//i = wctomb( pmbc, wc );
											//printf( "\tCharacters converted: %u\n", i );
											//printf( "\tMultibyte character: %x\n\n", pmbc );
 
                                        	//int wctomb(char *s, wchar_t wchar); 
                                        	//n = wctomb(s, *pininfo.achName); 
                                        	//n = strlen(asciiname);
                                        	
                                        	//SendMessage(hwndCombo, CB_ADDSTRING, 0, (LPARAM) (LPSTR)asciiname);
                                        	//theName = REALBuildString( wtoa(pininfo.achName,pininfo.achName[0]),pininfo.achName[0]);
											
											//WCHAR *wideName=pininfo.achName;

                                        	//char*		wtoa(wchar_t *ws, int wscnt);
                                        	//asciiname = wtoa(pininfo.achName,128);
                                   			
                                   			//i = sprintf(str, "WCHAR len = %d",lstrlenW(wideName) );
                                   			//i = sprintf(str, "strlen(asciiname) = %d",strlen(asciiname) );
                                   			//n = wcslen(pininfo.achName);
                                   			//i = sprintf(str, "n = %d",n );
                                   			i = sprintf(str, "n = %d%d%d",pininfo.achName[0],pininfo.achName[1],pininfo.achName[2] );
                                   			
                                   			
                                   			//i = sprintf(str, "n = %s",pininfo.achName );
                                   			//i = sprintf(str, "n = %s",fooW );
                                   			//i = sprintf(str, "%s",fooW );
                                   			//i = sprintf(str, "%s",pininfo.achName );
                                   			
                                   			//i = sprintf(asciiname, "%s",(wtoa(pininfo.achName,pininfo.achName[0])));
                                   			//i = sprintf(str, "found the input... %d\nii=%d\ns=%s\nlstrlenW(pininfo.achName)=%d\n[0]=%s",counter,ii,asciiname,lstrlenW(pininfo.achName),pininfo.achName[0]);
                                   			
                                   			//pi.achName[0]
                                   			//REALMessageBox(REALBuildString(str,i));
                                   			REALMessageBox(REALBuildString(str,i));
                                   			
                                   			i = sprintf(str, "MAX_PIN_NAME = %d",MAX_PIN_NAME );
                                   			REALMessageBox(REALBuildString(str,i));
                                   			
                                   			n=i;
                                   			i = sprintf(str, "n = %d",n );
                                   			REALMessageBox(REALBuildString(str,i));
                                   			
                                        	/*
                                        	
												typedef struct  _PinInfo {
												    IBaseFilter *pFilter;
												    PIN_DIRECTION dir;
												    WCHAR achName[128];
												} PIN_INFO;
												
												    WCHAR 					wachFriendlyName[120];
    												WCHAR 					wachAudioFriendlyName[120];

                                        	*/
                                		}
                                
                                        counter++;
                                }
                                if(pininfo.pFilter)
                                        pininfo.pFilter->Release();
                        }
                        
            pP->Release();
        }
    }
    if(pins)
        pins->Release();

	//return counter;
	//return nil;
	//return REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
	//return theName;
	//return REALBuildString(asciiname,strlen(asciiname));
	
	//i = sprintf(str, "bestDeviceDefaultPath = %s",(wtoa(bestDeviceDefaultPath,lstrlenW(bestDeviceDefaultPath))));
	
	
	i = sprintf(str, "counter=%d\nindex=%d",counter,index);
	REALMessageBox(REALBuildString(str,i));
	
	//return REALBuildString(asciiname,ii);
	return REALBuildString(asciiname,strlen(asciiname));
	
}

static long captureGetCurrentSoundDeviceSource(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);

	short sourceIndex;
	return -1;
}
#pragma mark 


// based on SetupInitialAudioDevice
static void captureSetSoundDeviceSourceIndex(REALcontrolInstance instance, long theDeviceIndex)
{

	ControlData(captureControl, instance, captureData, data);
	
	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	int					preferredDevice = 1;
	WCHAR 				*dummyChar = NULL;
	int 				ii;
	bool				deviceLoadedSoFar = false;
	HRESULT 			hr;
	IMediaControl 		*pMC = NULL;

	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();

	//remove the current pACap
	//so we can replace it with the new one
    hr = data->pFg->RemoveFilter( data->pACap);
	if (FAILED(hr))
	{
		//i = sprintf(str, "pACap remove err = %d",hr);
		//i = sprintf(str, "disconnect err = %s",DXGetErrorString9(hr));
	}
	else
	{
		//i = sprintf(str, "pACap remove OK");
	}

	
	if ( theDeviceIndex > (GetAudioDeviceCount() - 1) )
	{
		//device video devices posing as audio devices
		//i = sprintf(str, "we're probably dealing with a dv audio device here");
		//REALMessageBoxx(REALBuildString(str, i));
		data->useDVAudioDevice = true;

		//********************************************************
		//********************************************************
		//
		//  MAYBE WE SHOULD BE CREATING OUR DV pACAP HERE?!?!
		//
		//********************************************************
		//********************************************************
	}
	else
	{	
		data->useDVAudioDevice = false;
	}
	
	//***************************************************************
	//  LOOP THRU DEVICEPATH STRINGS
	//  SEARCHING FOR FIRST AVAILABLE UNUSED SLOT
	//  IF WE DON'T GET BACK A VALUE OF 1 THRU 6
	//  IT MEANS NO SLOTS ARE OPEN
	//***************************************************************
	/*
	ii = GetFreeAudioDevicePathSlot();
	if (ii <= 0)
	{
		data->audioSlotNumber = 0;//this indicates we have no audioDevice for this control
		i = sprintf(str, "No slot found\ndata->audioSlotNumber = %d\nii = %d",data->audioSlotNumber,ii);
		//REALMessageBoxx(REALBuildString(str,i));
		return ii;//exit if we didn't find an empty slot
	}
	//  set the "audioSlotNumber" (i.e. the index where we'll store the path in the globals)
	data->audioSlotNumber = ii;
	*/
	
	// Create the System Device Enumerator.
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    REALMessageBoxx(REALBuildString("GetAudioDeviceName1",19));  
	    // Create an enumerator for the audio capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	    REALMessageBoxx(REALBuildString("GetAudioDeviceName2",19));  
	} 
	else
	{
		return;
	}

	int count = 0;
	if (pEnum != nil)
	{
	}
	else
	{
		return;// -1;//this happens if no devices are plugged in
	}
	
	int junk;
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;

		//i = sprintf(str, "count --->  %d",count);
		//REALMessageBoxx(REALBuildString(str,i));
	
	junk = count-1;
	if ( junk == theDeviceIndex)
	{
	    REALMessageBoxx(REALBuildString("GetaudioDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    REALMessageBoxx(REALBuildString("GetaudioDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VARIANT	varPath;
	    VariantInit(&varName);
	    VariantInit(&varPath);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        REALMessageBoxx(REALBuildString("GetaudioDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	        REALMessageBoxx(REALBuildString("GetaudioDeviceName6",19));  
	        char *strA;
	        //REALMessageBoxx(REALBuildString("GetaudioDeviceName7",19));  
	        //REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        
	        	hr = pPropBag->Read(L"DevicePath", &varPath, 0);
				//REALMessageBoxx(REALBuildString( wtoa(varPath.bstrVal,varPath.bstrVal[0]),varPath.bstrVal[0]));
	        

				//--------------------------------------------------------------------------------
	        	//
	        	//  OK, we have a devicePath
	        	//  now we need to know if it is already being used or not..
	        	//  to do so, we check each slot to see if has the same path name 
	        	//  as the device we are examining
	        	//  if it does, then the device we are looking at is already in use
	        	//  if not, we can use it... and we should choose it as the default
	        	//
	        	//--------------------------------------------------------------------------------
	        	//  fun stuff! :-(
	        	
	        	
	        	if (lstrcmpW(bestAudioDevice1Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice1Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice2Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice2Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice3Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice3Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice4Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice4Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice5Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice5Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice6Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice6Path in use", 22));
					}
				else
					{
						
						//i = sprintf(str, "deviceNumFound = %d\ndata->audioSlotNumber = %d",count,data->audioSlotNumber);
	        			//REALMessageBoxx(REALBuildString(str, i));
						
						//set the flag to get us out of the while loop... blech
						//deviceFound = n;
					if (deviceLoadedSoFar==false)//this is so we load one new device each time
					{	
						//  device n is currently not in use
						//  let's use it! 
						switch (data->audioSlotNumber)
	    		    	{
	        		
			        		case 1:
			        		
				        		//i = sprintf(str, "case1A");
	        					//REALMessageBoxx(REALBuildString(str, i));
	        			
				        		SysFreeString(bestAudioDevice1Path);
				        		
				        		//i = sprintf(str, "case1B");
	        					//REALMessageBoxx(REALBuildString(str, i));
	        					
								//bestAudioDevice1Path = SysAllocString(varPath.bstrVal);
								
								//i = sprintf(str, "case1C");
	        					//REALMessageBoxx(REALBuildString(str, i));
	        					
								SysFreeString(bestAudioDevice1Name);
								
								//i = sprintf(str, "case1D");
	        					//REALMessageBoxx(REALBuildString(str, i));
	        					
								bestAudioDevice1Name = SysAllocString(varName.bstrVal);
								
								//i = sprintf(str, "case1E");
	        					//REALMessageBoxx(REALBuildString(str, i));
	        					
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									REALMessageBoxx(REALBuildString("Bind to object 1 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
										{
										//i = sprintf(str, "AddFilter wachAudioFriendlyName succeeded = %s",(wtoa(data->wachAudioFriendlyName,lstrlenW(data->wachAudioFriendlyName))));
										//i = sprintf(str, "AddFilter wachAudioFriendlyName succeeded = %s",(wtoa(data->wachAudioFriendlyName,lstrlenW(data->wachAudioFriendlyName))));
										//REALMessageBoxx(REALBuildString(str, i));
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
										}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									//REALMessageBoxx(REALBuildString("Bind to object 1 NOT succeeded", 30));
								}
	    		    			break;
			        		case 2:
	    		    			SysFreeString(bestAudioDevice2Path);
								bestAudioDevice2Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice2Name);
								bestAudioDevice2Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 NOT succeeded", 30));
								}
	    		    			break;
			        		case 3:
	        					SysFreeString(bestAudioDevice3Path);
								bestAudioDevice3Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice3Name);
								bestAudioDevice3Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 3 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 3 NOT succeeded", 30));
								}
	        					break;
	        				case 4:
	    		    			SysFreeString(bestAudioDevice4Path);
								bestAudioDevice4Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice4Name);
								bestAudioDevice4Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 4 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 4 NOT succeeded", 30));
								}
	    		    			break;
			        		case 5:
	        					SysFreeString(bestAudioDevice5Path);
								bestAudioDevice5Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice5Name);
								bestAudioDevice5Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 5 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 5 NOT succeeded", 30));
								}
	        					break;
	        				case 6:
	    		    			SysFreeString(bestAudioDevice6Path);
								bestAudioDevice6Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice6Name);
								bestAudioDevice6Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 6 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 6 NOT succeeded", 30));
								}
	    		    			break;
			        			
			        	}//end switch
			        	
			        }//end if (deviceLoadedSoFar) 
			        	
				}//end else

   						
	        
	    //********************************************************************
		//hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
          
            
			//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, NULL, data->pMux);
          
          
          	//i = sprintf(str, "%d",hr);
			//REALMessageBoxx(REALBuildString(str, i));
										                                                                
	        //REALMessageBoxx(REALBuildString("VariantClear", 12));
	        VariantClear(&varName); 
	        VariantClear(&varPath); //ejt
	    	//REALMessageBoxx(REALBuildString("post VariantClear",17));
	    	//pPropBag->Release();
	    	//REALMessageBoxx(REALBuildString("post pPropBag Release",21));
	    	//pMoniker->Release();
	    	//REALMessageBoxx(REALBuildString("post pMoniker Release",21));

	}//	if (theDeviceIndex == (count - 1))	
	}//end while loop
	
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************	
	if (lstrcmpW(bestAudioDevice1Path, bestDevice1Path) == 0)
		{
			//i = sprintf(str, "bestAudioDevice1Path == bestDevice1Path");
			//REALMessageBoxx(REALBuildString(str,i));
		}
		else
		{
			//i = sprintf(str, "bestAudioDevice1Path = *%s*",bestAudioDevice1Path);
			//i = sprintf(str, "bestAudioDevice1Path != bestDevice1Path");
			//REALMessageBoxx(REALBuildString(str,i));
			//i = sprintf(str, "bestDevice1Path = *%s*",bestDevice1Path);
			//REALMessageBoxx(REALBuildString(str,i));
		}
		
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
		
	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	
	if (pMC)
		pMC->Release;
		
	return;
	
}

#pragma mark 



static Boolean captureGetAGCState(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

	short agcState;
	double theGain = 0;

	long inputIndex=0;
	
	if(data->pACap == NULL)
		return false;//no audio

	int counter = 0;
	double inputLevel = -1.0;

	IAMAudioInputMixer *mixer = NULL;

    IPin *pP;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;
    HRESULT hr = data->pACap->EnumPins(&pins);
    pins->Reset();
	
    while(hr == NOERROR)
	{
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
		{
			hr = pP->QueryPinInfo(&pininfo);
			if(hr == NOERROR)
			{
				if(pininfo.dir == PINDIR_INPUT)
				{
					pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
					if(mixer)
					{
						if(inputIndex == counter)
							{
							mixer->get_MixLevel(&inputLevel);
							//data->soundVolume = 128 * inputLevel;
							//theGain = 128 * inputLevel;
							theGain = inputLevel;
							}
						mixer->Release();
					}

					counter++;
				}

				if(pininfo.pFilter)
					pininfo.pFilter->Release();
			}
			
            pP->Release();
        }
    }
    if(pins)
        pins->Release();
	
	
	char 				str[50];
	int 				i;
	i = sprintf(str, "theGain=%lf",theGain);
	REALMessageBoxx(REALBuildString(str,i));

	//AMF_AUTOMATICGAIN = -1
	//return theGain;
	if (theGain == AMF_AUTOMATICGAIN)
		return true;
	else
		return false;
}

static void captureSetAGCState(REALcontrolInstance instance, long param, Boolean value)
{
	ControlData(captureControl, instance, captureData, data);

	char 				str[50];
	int 				i;
	long 				inputIndex=0;
	double 				theGain;
	
	if(data->pACap == NULL)
		return;//no audio

	int counter = 0;

	IAMAudioInputMixer *mixer = NULL;

    IPin *pP;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;
    HRESULT hr = data->pACap->EnumPins(&pins);
    pins->Reset();
	
    while(hr == NOERROR)
	{
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
		{
			hr = pP->QueryPinInfo(&pininfo);
			if(hr == NOERROR)
			{
				if(pininfo.dir == PINDIR_INPUT)
				{
					pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
					if(mixer)
					{
						if(inputIndex == counter)
							{
							hr = mixer->put_MixLevel(AMF_AUTOMATICGAIN);
							/*
								S_OK
								Success.

								E_NOTIMPL
								This filter does not support the AMF_AUTOMATICGAIN flag.

								E_INVALIDARG
								Invalid argument.
							*/
							switch (hr)
							{
								case S_OK:
									i = sprintf(str, "hr S_OK");
									REALMessageBoxx(REALBuildString(str,i));
								break;
								
								case E_NOTIMPL:
									i = sprintf(str, "hr E_NOTIMPL");
									REALMessageBoxx(REALBuildString(str,i));
								break;
								
								case E_INVALIDARG:
									i = sprintf(str, "hr E_INVALIDARG");
									REALMessageBoxx(REALBuildString(str,i));
								break;
								
								
							}
							
							mixer->get_MixLevel(&theGain);
							}
						mixer->Release();
					}

					counter++;
				}

				if(pininfo.pFilter)
					pininfo.pFilter->Release();
			}
			
            pP->Release();
        }
    }
    if(pins)
        pins->Release();


	i = sprintf(str, "set AGC theGain=%lf",theGain);
	REALMessageBoxx(REALBuildString(str,i));
	
}

static long captureGetGain(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	long inputIndex=0;
	long theGain = 0;

	if(data->pACap == NULL)
		return -1;

	int counter = 0;
	double inputLevel = -1.0;

	IAMAudioInputMixer *mixer = NULL;

    IPin *pP;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;
    HRESULT hr = data->pACap->EnumPins(&pins);
    pins->Reset();
	
    while(hr == NOERROR)
	{
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
		{
			hr = pP->QueryPinInfo(&pininfo);
			if(hr == NOERROR)
			{
				if(pininfo.dir == PINDIR_INPUT)
				{
					pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
					if(mixer)
					{
						if(inputIndex == counter)
							{
							mixer->get_MixLevel(&inputLevel);
							//data->soundVolume = 128 * inputLevel;
							theGain = 128 * inputLevel;
							}
						mixer->Release();
					}

					counter++;
				}

				if(pininfo.pFilter)
					pininfo.pFilter->Release();
			}
			
            pP->Release();
        }
    }
    if(pins)
        pins->Release();
	
	
	return theGain;
	
}

static void captureSetGain(REALcontrolInstance instance, long param, long value)
{
	ControlData(captureControl, instance, captureData, data);
	
	long inputIndex=0;

	if(data->pACap == NULL)
		return;

	int counter = 0;
	double inputLevel = -1.0;

	IAMAudioInputMixer *mixer = NULL;

    IPin *pP;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;
    HRESULT hr = data->pACap->EnumPins(&pins);
    pins->Reset();
	
    while(hr == NOERROR)
	{
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
		{
			hr = pP->QueryPinInfo(&pininfo);
			if(hr == NOERROR)
			{
				if(pininfo.dir == PINDIR_INPUT)
				{
					pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
					if(mixer)
					{
						if(inputIndex == counter)
							{
							inputLevel = (double)value/128;
							
							mixer->put_MixLevel(inputLevel);
							
							}
						mixer->Release();
					}

					counter++;
				}

				if(pininfo.pFilter)
					pininfo.pFilter->Release();
			}
			
            pP->Release();
        }
    }
    if(pins)
        pins->Release();
}

static Boolean captureGetMeterState(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	return false;
}

static void captureSetMeterState(REALcontrolInstance instance, long param, Boolean value)
{
	ControlData(captureControl, instance, captureData, data);
}

static short captureGetLeftLevel(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	return 0;
}

static short captureGetRightLevel(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	return 0;
}

static long captureGetVideoDeviceCurrent(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	return 0;
}

static long captureGetVideoDeviceCount(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	//how many video devices are connected?
	return GetVideoDeviceCount();
}

static REALstring captureGetIndexedVideoDeviceName(REALcontrolInstance instance, int index)
{
	char 				str[50];
	int 				i;

	i = sprintf(str, "captureGetIndexedVideoDeviceName index=%d",index);
	REALMessageBoxx(REALBuildString(str,i));

	//name of nth video device
	return GetVideoDeviceNameByIndex(index+1);
}


static Boolean captureGetIndexedVideoDeviceAvailable(REALcontrolInstance instance, int index)
{
	ControlData(captureControl, instance, captureData, data);

	return false;
}

static void captureSetVideoDeviceName(REALcontrolInstance instance, REALstring theDeviceName)
{
	ControlData(captureControl, instance, captureData, data);
	
	// MACINTOSH ONLY CALL ?!
	
	//we can't use this function for Windows 
	//as two device may have an identical "Friendly Name"
	//and we are using devicePath to uniquely identify each device
}


static void captureSetVideoDeviceSourceIndex(REALcontrolInstance instance, long theDeviceIndex)
{

	
	ControlData(captureControl, instance, captureData, data);
	
	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	int					preferredDevice = 1;
	char 				str[50];
	WCHAR 				*dummyChar = NULL;
	int 				i,ii;
	bool				deviceLoadedSoFar = false;
	HRESULT 			hr;

	IMediaControl 		*pMC = NULL;


	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();

	i = sprintf(str, "captureSetVideoDeviceSourceIndex");

	//remove the current pVCap
	//so we can replace it with the new one
    hr = data->pFg->RemoveFilter( data->pVCap);
	if (FAILED(hr))
	{
		i = sprintf(str, "disconnect err = %d",hr);
		//i = sprintf(str, "disconnect err = %s",DXGetErrorString9(hr));
	}
	else
	{
		i = sprintf(str, "disconnect OK");
	}

	REALMessageBoxx(REALBuildString(str,i));

	//***************************************************************
	//  LOOP THRU DEVICEPATH STRINGS
	//  SEARCHING FOR FIRST AVAILABLE UNUSED SLOT
	//  IF WE DON'T GET BACK A VALUE OF 1 THRU 6
	//  IT MEANS NO SLOTS ARE OPEN
	//
	// for captureSetVideoDeviceSourceIndex we don't need to find a slot
	//  we should already have one from earlier
	//
	//***************************************************************
	/*
	ii = GetFreeVideoDevicePathSlot();
	if (ii <= 0)
	{
		data->videoSlotNumber = 0;//this indicates we have no videoDevice for this control
		i = sprintf(str, "No slot found\ndata->videoSlotNumber = %d\nii = %d",data->videoSlotNumber,ii);
		//REALMessageBoxx(REALBuildString(str,i));
		return;// ii;//exit if we didn't find an empty slot
	}
	//  set the "videoSlotNumber" (i.e. the index where we'll store the path in the globals)
	data->videoSlotNumber = ii;
	*/
	
	// Create the System Device Enumerator.
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,
	        &pEnum, 0);
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName2",19));  
	} 
	else
	{
		REALMessageBoxx(REALBuildString("CoCreateInstance = -1",21));  
		return;// -1;
	}

	int count = 0;
	if (pEnum != nil)
	{
		REALMessageBoxx(REALBuildString("pEnum      = OKY",16));  
	}
	else
	{
		REALMessageBoxx(REALBuildString("pEnum      = OKN",16));  
		return;
	}
	

	int junk;
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    
	    count++;

		i = sprintf(str, "count --->  %d",count);
		//REALMessageBoxx(REALBuildString(str,i));
	
	junk = count-1;
	if ( junk == theDeviceIndex)
	{
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VARIANT	varPath;
	    VariantInit(&varName);
	    VariantInit(&varPath);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        REALMessageBoxx(REALBuildString("GetVideoDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	        REALMessageBoxx(REALBuildString("GetVideoDeviceName6",19));  
	        char *strA;
	        //REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        //REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        
	        	hr = pPropBag->Read(L"DevicePath", &varPath, 0);
				//REALMessageBoxx(REALBuildString( wtoa(varPath.bstrVal,varPath.bstrVal[0]),varPath.bstrVal[0]));
	        

				//--------------------------------------------------------------------------------
	        	//
	        	//  OK, we have a devicePath
	        	//  now we need to know if it is already being used or not..
	        	//  to do so, we check each slot to see if has the same path name 
	        	//  as the device we are examining
	        	//  if it does, then the device we are looking at is already in use
	        	//  if not, we can use it... and we should choose it as the default
	        	//
	        	//--------------------------------------------------------------------------------
	        	//  fun stuff! :-(
	        	
	        	
	        	if (lstrcmpW(bestDevice1Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice1Path in use", 22));
					}
				else if (lstrcmpW(bestDevice2Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice2Path in use", 22));
					}
				else if (lstrcmpW(bestDevice3Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice3Path in use", 22));
					}
				else if (lstrcmpW(bestDevice4Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice4Path in use", 22));
					}
				else if (lstrcmpW(bestDevice5Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice5Path in use", 22));
					}
				else if (lstrcmpW(bestDevice6Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice6Path in use", 22));
					}
				else
					{
						
						i = sprintf(str, "deviceNumFound = %d\ndata->videoSlotNumber = %d",count,data->videoSlotNumber);
	        			//REALMessageBoxx(REALBuildString(str, i));
						
						//set the flag to get us out of the while loop... blech
						//deviceFound = n;
					if (deviceLoadedSoFar==false)//this is so we load one new device each time
					{	
						//  device n is currently not in use
						//  let's use it! 
						switch (data->videoSlotNumber)
	    		    	{
	        		
			        		case 1:
				        		SysFreeString(bestDevice1Path);
								bestDevice1Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice1Name);
								bestDevice1Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 1 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
										{
										//i = sprintf(str, "AddFilter wachFriendlyName succeeded = %s",(wtoa(data->wachFriendlyName,lstrlenW(data->wachFriendlyName))));
										i = sprintf(str, "AddFilter wachFriendlyName succeeded = %s",(wtoa(data->wachFriendlyName,lstrlenW(data->wachFriendlyName))));
										//REALMessageBoxx(REALBuildString(str, i));
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
										}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 1 NOT succeeded", 30));
								}
	    		    			break;
			        		case 2:
	    		    			SysFreeString(bestDevice2Path);
								bestDevice2Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice2Name);
								bestDevice2Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 2 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 NOT succeeded", 30));
								}
	    		    			break;
			        		case 3:
	        					SysFreeString(bestDevice3Path);
								bestDevice3Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice3Name);
								bestDevice3Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 3 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 3 NOT succeeded", 30));
								}
	        					break;
	        				case 4:
	    		    			SysFreeString(bestDevice4Path);
								bestDevice4Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice4Name);
								bestDevice4Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 4 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 4 NOT succeeded", 30));
								}
	    		    			break;
			        		case 5:
	        					SysFreeString(bestDevice5Path);
								bestDevice5Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice5Name);
								bestDevice5Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 5 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 5 NOT succeeded", 30));
								}
	        					break;
	        				case 6:
	    		    			SysFreeString(bestDevice6Path);
								bestDevice6Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice6Name);
								bestDevice6Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 6 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 6 NOT succeeded", 30));
								}
	    		    			break;
			        			
			        	}//end switch
			        	
			        }//end if (deviceLoadedSoFar) 
			        	
				}//end else

   						
	        
	    //********************************************************************
	        
	        //REALMessageBoxx(REALBuildString("VariantClear", 12));
	        VariantClear(&varName); 
	        VariantClear(&varPath); //ejt
	    	//REALMessageBoxx(REALBuildString("post VariantClear",17));
	    	//pPropBag->Release();
	    	//REALMessageBoxx(REALBuildString("post pPropBag Release",21));
	    	//pMoniker->Release();
	    	//REALMessageBoxx(REALBuildString("post pMoniker Release",21));
	
	}//	if (theDeviceIndex == (count - 1))	
	}//end while loop
	 
	
	//REALMessageBoxx(REALBuildString("we're outta here",16));  
	
	//static void captureSetPreviewState(REALcontrolInstance instance, long param, Boolean theState)
	//toggle preview off and back on if appropriate
	//be careful with the order of operations here
	//since captureSetPreviewState not only turns preview on and off
	//it also sets the state of the data->previewState variable - EJT
	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	
	if (pMC)
		pMC->Release;
		
	return;// count;
	
}


REALstring REALstringFromPString(const unsigned char *pstring)
{
  REALstring result = nil;
  
  if (pstring[0] != 0) { // empty strings don't get converted
    result = REALBuildString((const char *)pstring+1, (int)pstring[0]);
    }
  return result;
}

static long captureGetSoundVolume(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	/*
	long inputIndex=0;
	
	if(data->pACap == NULL)
		return -1;

	int counter = 0;
	double inputLevel = -1.0;

	IAMAudioInputMixer *mixer = NULL;

    IPin *pP;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;
    HRESULT hr = data->pACap->EnumPins(&pins);
    pins->Reset();
	
    while(hr == NOERROR)
	{
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
		{
			hr = pP->QueryPinInfo(&pininfo);
			if(hr == NOERROR)
			{
				if(pininfo.dir == PINDIR_INPUT)
				{
					pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
					if(mixer)
					{
						if(inputIndex == counter)
							{
							mixer->get_MixLevel(&inputLevel);
							data->soundVolume = 128 * inputLevel;
							}
						mixer->Release();
					}

					counter++;
				}

				if(pininfo.pFilter)
					pininfo.pFilter->Release();
			}
			
            pP->Release();
        }
    }
    if(pins)
        pins->Release();
	
	*/
	return data->soundVolume;
}

static void captureSetSoundVolume(REALcontrolInstance instance, long param, long theVolume)
{
	ControlData(captureControl, instance, captureData, data);
}

static long captureGetSampleRate(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

/*
typedef struct _AUDIO_STREAM_CONFIG_CAPS {
        GUID guid;
        ULONG MinimumChannels;
        ULONG MaximumChannels;
        ULONG ChannelsGranularity;
        ULONG MinimumBitsPerSample;
        ULONG MaximumBitsPerSample;
        ULONG BitsPerSampleGranularity;
        ULONG MinimumSampleFrequency;
        ULONG MaximumSampleFrequency;
        ULONG SampleFrequencyGranularity;
    } AUDIO_STREAM_CONFIG_CAPS;
*/    

	char 						str[50];
	int 						i = sprintf(str, "captureSetPreviewState");

	int 						iCount, iSize;
	AUDIO_STREAM_CONFIG_CAPS 	scc;//VIDEO_STREAM_CONFIG_CAPS 	scc;
	AM_MEDIA_TYPE 				*pmt;
	long 						sampleRate = 0;
	HRESULT 					hr;

	i = sprintf(str, "SR1");
	REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//hr = data->pASC->GetNumberOfCapabilities(&iCount, &iSize);
	//ASSERT(sizeof(scc) <= iSize);  // Make sure the structure is big enough.

	i = sprintf(str, "SR2=%d",hr);
	REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetStreamCaps(0, &pmt, reinterpret_cast<BYTE*>(&scc));
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
		// Is it VIDEOINFOHEADER and UYVY?
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);
	        
		sampleRate = wfx->nSamplesPerSec;
		
	    }
	    
	}
	
	//void 		MyDeleteMediaType(AM_MEDIA_TYPE *pmt);
	MyDeleteMediaType(pmt);
	return sampleRate;
}


static void captureSetSampleRate(REALcontrolInstance instance, long param, long theRate)
{

	ControlData(captureControl, instance, captureData, data);

	/*
		typedef struct _AUDIO_STREAM_CONFIG_CAPS {
    	    GUID guid;
    	    ULONG MinimumChannels;
    	    ULONG MaximumChannels;
    	    ULONG ChannelsGranularity;
    	    ULONG MinimumBitsPerSample;
    	    ULONG MaximumBitsPerSample;
    	    ULONG BitsPerSampleGranularity;
    	    ULONG MinimumSampleFrequency;
    	    ULONG MaximumSampleFrequency;
    	    ULONG SampleFrequencyGranularity;
    	} AUDIO_STREAM_CONFIG_CAPS;
	*/    

	char 							str[50];
	int 							i = sprintf(str, "captureSetPreviewState");
	int 							iCount, iSize;
	HRESULT 						hr;
	IMediaControl 					*pMC = NULL;
	AM_MEDIA_TYPE 					*pmt;
	AUDIO_STREAM_CONFIG_CAPS 		scc;//VIDEO_STREAM_CONFIG_CAPS 	scc;

	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();
		
	//i = sprintf(str, "SR1");
	//REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//i = sprintf(str, "SR2=%d",hr);
	//REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetFormat(&pmt);
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
		// Is it FORMAT_WaveFormatEx?
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);
	        
		
		i = sprintf(str, "1. theRate=%d\nwfx->nSamplesPerSec=%d",theRate, wfx->nSamplesPerSec);
		REALMessageBoxx(REALBuildString(str,i));
	
		wfx->nSamplesPerSec = theRate;
		
		i = sprintf(str, "2. theRate=%d\nwfx->nSamplesPerSec=%d",theRate, wfx->nSamplesPerSec);
		REALMessageBoxx(REALBuildString(str,i));
		
		// Set the new format
		hr = data->pASC->SetFormat(pmt);
		//i = sprintf(str, "hr=%d",hr);// -2147220956=not stopped
		//REALMessageBoxx(REALBuildString(str,i));
		
	    }
	}
	MyDeleteMediaType(pmt);

	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	if (pMC)
		pMC->Release;
		
}



static long captureGetSampleSize(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

/*
typedef struct _AUDIO_STREAM_CONFIG_CAPS {
        GUID guid;
        ULONG MinimumChannels;
        ULONG MaximumChannels;
        ULONG ChannelsGranularity;
        ULONG MinimumBitsPerSample;
        ULONG MaximumBitsPerSample;
        ULONG BitsPerSampleGranularity;
        ULONG MinimumSampleFrequency;
        ULONG MaximumSampleFrequency;
        ULONG SampleFrequencyGranularity;
    } AUDIO_STREAM_CONFIG_CAPS;
*/    

	char 						str[50];
	int 						i = sprintf(str, "captureSetPreviewState");

	int 						iCount, iSize;
	AUDIO_STREAM_CONFIG_CAPS 	scc;//VIDEO_STREAM_CONFIG_CAPS 	scc;
	AM_MEDIA_TYPE 				*pmt;
	//long 						sampleRate = 0;
	HRESULT 					hr;

	i = sprintf(str, "SR1");
	REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//hr = data->pASC->GetNumberOfCapabilities(&iCount, &iSize);
	//ASSERT(sizeof(scc) <= iSize);  // Make sure the structure is big enough.

	i = sprintf(str, "SR2=%d",hr);
	REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetStreamCaps(0, &pmt, reinterpret_cast<BYTE*>(&scc));
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);

		data->sampleSize = wfx->wBitsPerSample;
		
	    }
	    
	}
	
	MyDeleteMediaType(pmt);
	return data->sampleSize;
}

static void captureSetSampleSize(REALcontrolInstance instance, long param, long theSize)
{
	ControlData(captureControl, instance, captureData, data);

	/*
		typedef struct _AUDIO_STREAM_CONFIG_CAPS {
    	    GUID guid;
    	    ULONG MinimumChannels;
    	    ULONG MaximumChannels;
    	    ULONG ChannelsGranularity;
    	    ULONG MinimumBitsPerSample;
    	    ULONG MaximumBitsPerSample;
    	    ULONG BitsPerSampleGranularity;
    	    ULONG MinimumSampleFrequency;
    	    ULONG MaximumSampleFrequency;
    	    ULONG SampleFrequencyGranularity;
    	} AUDIO_STREAM_CONFIG_CAPS;
	*/    

	char 							str[50];
	int 							i = sprintf(str, "captureSetPreviewState");
	int 							iCount, iSize;
	HRESULT 						hr;
	IMediaControl 					*pMC = NULL;
	AM_MEDIA_TYPE 					*pmt;
	AUDIO_STREAM_CONFIG_CAPS 		scc;//VIDEO_STREAM_CONFIG_CAPS 	scc;

	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();
		
	//i = sprintf(str, "SR1");
	//REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//i = sprintf(str, "SR2=%d",hr);
	//REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetFormat(&pmt);
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
		// Is it FORMAT_WaveFormatEx?
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);
	        
		
		i = sprintf(str, "1. theSize=%d\nwfx->wBitsPerSample=%d",theSize, wfx->wBitsPerSample);
		REALMessageBoxx(REALBuildString(str,i));
	
		wfx->wBitsPerSample = theSize;
		
		i = sprintf(str, "2. theSize=%d\nwfx->wBitsPerSample=%d",theSize, wfx->wBitsPerSample);
		REALMessageBoxx(REALBuildString(str,i));
		
		// Set the new format
		hr = data->pASC->SetFormat(pmt);
		//i = sprintf(str, "hr=%d",hr);// -2147220956=not stopped
		//REALMessageBoxx(REALBuildString(str,i));
		
	    }
	}
	MyDeleteMediaType(pmt);

	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	if (pMC)
		pMC->Release;
}

static long captureGetNumChan(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

/*
typedef struct _AUDIO_STREAM_CONFIG_CAPS {
        GUID guid;
        ULONG MinimumChannels;
        ULONG MaximumChannels;
        ULONG ChannelsGranularity;
        ULONG MinimumBitsPerSample;
        ULONG MaximumBitsPerSample;
        ULONG BitsPerSampleGranularity;
        ULONG MinimumSampleFrequency;
        ULONG MaximumSampleFrequency;
        ULONG SampleFrequencyGranularity;
    } AUDIO_STREAM_CONFIG_CAPS;
*/    

	char 						str[50];
	int 						i = sprintf(str, "captureSetPreviewState");

	int 						iCount, iSize;
	AUDIO_STREAM_CONFIG_CAPS 	scc;
	AM_MEDIA_TYPE 				*pmt;
	HRESULT 					hr;

	i = sprintf(str, "SR1");
	REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);

	i = sprintf(str, "SR2=%d",hr);
	REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetStreamCaps(0, &pmt, reinterpret_cast<BYTE*>(&scc));
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);

		data->numChan = wfx->nChannels;
		
	    }
	    
	}
	
	MyDeleteMediaType(pmt);

	return data->numChan;
}

static void captureSetNumChan(REALcontrolInstance instance, long param, long theNumChan)
{
	ControlData(captureControl, instance, captureData, data);

	/*
		typedef struct _AUDIO_STREAM_CONFIG_CAPS {
    	    GUID guid;
    	    ULONG MinimumChannels;
    	    ULONG MaximumChannels;
    	    ULONG ChannelsGranularity;
    	    ULONG MinimumBitsPerSample;
    	    ULONG MaximumBitsPerSample;
    	    ULONG BitsPerSampleGranularity;
    	    ULONG MinimumSampleFrequency;
    	    ULONG MaximumSampleFrequency;
    	    ULONG SampleFrequencyGranularity;
    	} AUDIO_STREAM_CONFIG_CAPS;
	*/    

	char 							str[50];
	int 							i = sprintf(str, "captureSetPreviewState");
	int 							iCount, iSize;
	HRESULT 						hr;
	IMediaControl 					*pMC = NULL;
	AM_MEDIA_TYPE 					*pmt;
	AUDIO_STREAM_CONFIG_CAPS 		scc;//VIDEO_STREAM_CONFIG_CAPS 	scc;

	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();
		
	//i = sprintf(str, "SR1");
	//REALMessageBoxx(REALBuildString(str,i));
	
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//i = sprintf(str, "SR2=%d",hr);
	//REALMessageBoxx(REALBuildString(str,i));
	
	// Get the first format.
	hr = data->pASC->GetFormat(&pmt);
	if (hr == S_OK)
	{
	    i = sprintf(str, "SR3");
		REALMessageBoxx(REALBuildString(str,i));
		
		// Is it FORMAT_WaveFormatEx?
	    if (pmt->formattype == FORMAT_WaveFormatEx)
	    {
		/*		
		typedef struct waveformat_extended_tag {
		    WORD  wFormatTag;      
		    WORD  nChannels;       
    		DWORD nSamplesPerSec;  
	    	DWORD nAvgBytesPerSec; 
		    WORD  nBlockAlign;     
		    WORD  wBitsPerSample;  
		    WORD  cbSize;          
		} WAVEFORMATEX;
		*/
		
		// Modify the format block.
	        WAVEFORMATEX *wfx = 
	            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);
	        
		
		i = sprintf(str, "1. theNumChan=%d\nwfx->nChannels=%d",theNumChan, wfx->nChannels);
		REALMessageBoxx(REALBuildString(str,i));
	
		wfx->nChannels = theNumChan;
		
		i = sprintf(str, "2. theNumChan=%d\nwfx->nChannels=%d",theNumChan, wfx->nChannels);
		REALMessageBoxx(REALBuildString(str,i));
		
		// Set the new format
		hr = data->pASC->SetFormat(pmt);
		//i = sprintf(str, "hr=%d",hr);// -2147220956=not stopped
		//REALMessageBoxx(REALBuildString(str,i));
		
	    }
	}
	MyDeleteMediaType(pmt);

	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	if (pMC)
		pMC->Release;
	
}

static REALstring captureGetSoundCompressionType(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	return	nil;//REALBuildString((QT::Ptr) &compType, 4);	
}

static void captureSetSoundCompressionType(REALcontrolInstance instance, long param, REALstring theCompType)
{
	ControlData(captureControl, instance, captureData, data);

}

static long captureGetDepth(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

	return 0;//data->theDepth;
	
}

static void captureSetDepth(REALcontrolInstance instance, long param, long theDepth)
{
	ControlData(captureControl, instance, captureData, data);
	
}

static long captureGetSpatialQuality(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

	return 0;//data->theSpatialQuality;
	
}

static void captureSetSpatialQuality(REALcontrolInstance instance, long param, long theSpatialQuality)
{
	ControlData(captureControl, instance, captureData, data);

}

static long captureGetTemporalQuality(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	return 0;//data->theTemporalQuality;
	
}

static void captureSetTemporalQuality(REALcontrolInstance instance, long param, long theTemporalQuality)
{
	ControlData(captureControl, instance, captureData, data);

}

static long captureGetKeyFrameRate(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	return 0;//data->theKeyFrameRate;
	
}

static void captureSetKeyFrameRate(REALcontrolInstance instance, long param, long theKeyFrameRate)
{
	ControlData(captureControl, instance, captureData, data);

}

static double captureGetFrameRate(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);

double theFrameRate = 0;

	HRESULT 			hr;
	AM_MEDIA_TYPE 		*pmt=0;
	
	char 						str[50];
	int 						i = sprintf(str, "captureSetPreviewState");
	
bool isDV = false;

					
		hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		if(hr != NOERROR)
		{
		        //ErrMsg(TEXT("This graph cannot preview properly"));
		        i = sprintf(str, "This graph cannot preview properly");
			  	REALMessageBoxx(REALBuildString(str,i));
		}
		else//// hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		{
		     
		    //*************************************************************************************
			//check for DV - START
			//*************************************************************************************
		    AM_MEDIA_TYPE * pmtDV;
		    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);
		    if(hr != S_OK)
		        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);

		    if(hr == S_OK)
		    {
		     	i = sprintf(str, "data->pVSC a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
        	}
        	else
        	{
        		i = sprintf(str, "data->pVSC !a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
			}
	
	        if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
	        {
	            if(pmtDV->formattype == FORMAT_DvInfo)
	            {
	                
	                isDV = true;
	                i = sprintf(str, "formattype == FORMAT_DvInfo");
		  			REALMessageBoxx(REALBuildString(str,i));
	            }//if(pmtDV->formattype == FORMAT_DvInfo)
	            else
	            {
	            isDV = false;
	            }
	        }//if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
			//*************************************************************************************
			//check for DV - END
			//*************************************************************************************
				
			hr = data->pVSC->GetFormat(&pmt);

			if(pmt->formattype == FORMAT_VideoInfo)
                {
                        VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pmt->pbFormat;
                        theFrameRate = pvi->AvgTimePerFrame;// = (LONGLONG)(((double)10000000) / theFrameRate);
						
						//pvi->AvgTimePerFrame = (LONGLONG)(((double)10000000) / theFrameRate);

						theFrameRate = (LONGLONG)(((double)10000000) / pvi->AvgTimePerFrame);
						
                        //hr = data->pVSC->SetFormat(pmt);
                        if(hr != NOERROR)
                        {
                                //CHAR error[256];
                                //hrToText(hr, error);
                                //ErrMsg(TEXT("%s : %s : %x"), MyString(IDS_CAP_51),error, hr);
                                //result = -3;
                        }
                }
                else
                {
                        //ErrMsg(TEXT("%s : %s : %x"),MyString(IDS_CAP_51),MyString(IDS_CAP_52), hr);
                        //result = -4;
                }
                
                
                MyDeleteMediaType(pmt);
                //DeleteMediaType(pmt);
                
           }     

return theFrameRate;

}

static void captureSetFrameRate(REALcontrolInstance instance, long param, double theRate)
{
	ControlData(captureControl, instance, captureData, data);

double theFrameRate = theRate;

	HRESULT 			hr;
	AM_MEDIA_TYPE 		*pmt=0;
	
	char 						str[50];
	int 						i = sprintf(str, "captureSetPreviewState");
	
	LONGLONG MinFrameInterval;
    LONGLONG MaxFrameInterval;
    
	bool isDV = false;

	IMediaControl 		*pMC = NULL;

	//  DirectX requires us to stop the graph 
	//  before we yank part of it off (i.e. pVCap)
	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
	if(FAILED(hr))
		return;
	else
		pMC->Stop();

					
		hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		if(hr != NOERROR)
		{
		        //ErrMsg(TEXT("This graph cannot preview properly"));
		        i = sprintf(str, "This graph cannot preview properly");
			  	REALMessageBoxx(REALBuildString(str,i));
		}
		else//// hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		{
		     
		    //*************************************************************************************
			//check for DV - START
			//*************************************************************************************
		    AM_MEDIA_TYPE * pmtDV;
		    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);
		    if(hr != S_OK)
		        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);

		    if(hr == S_OK)
		    {
		     	i = sprintf(str, "data->pVSC a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
        	}
        	else
        	{
        		i = sprintf(str, "data->pVSC !a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
			}
	
	        if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
	        {
	            if(pmtDV->formattype == FORMAT_DvInfo)
	            {
	                
	                isDV = true;
	                i = sprintf(str, "formattype == FORMAT_DvInfo");
		  			REALMessageBoxx(REALBuildString(str,i));
	            }//if(pmtDV->formattype == FORMAT_DvInfo)
	            else
	            {
	            isDV = false;
	            }
	        }//if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
			//*************************************************************************************
			//check for DV - END
			//*************************************************************************************
				
			hr = data->pVSC->GetFormat(&pmt);

			if(pmt->formattype == FORMAT_VideoInfo)
                {
                        i = sprintf(str, "pmt->formattype == FORMAT_VideoInfo");
                        REALMessageBoxx(REALBuildString(str,i));
                        
                        //check frameRate bounds
                        VIDEO_STREAM_CONFIG_CAPS 	scc;





		    //AM_MEDIA_TYPE * pmtDV;
		    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);
		    if(hr != S_OK)
		        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);

	//hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pVCap, IID_IAMStreamConfig, (void **)&data->pASC);
	
	//hr = data->pASC->GetNumberOfCapabilities(&iCount, &iSize);
	//ASSERT(sizeof(scc) <= iSize);  // Make sure the structure is big enough.

	i = sprintf(str, "SR2=%d",hr);
	REALMessageBoxx(REALBuildString(str,i));
	
						// Get the first format.
						hr = data->pVSC->GetStreamCaps(0, &pmt, reinterpret_cast<BYTE*>(&scc));
						if (hr == S_OK)
						{
						    i = sprintf(str, "MaxFrameInterval=%lf",scc.MaxFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							i = sprintf(str, "MaxFrameInterval=%f",scc.MaxFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							i = sprintf(str, "MaxFrameInterval=%d",scc.MaxFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							
							
							
							 i = sprintf(str, "MinFrameInterval=%lf",scc.MinFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							i = sprintf(str, "MinFrameInterval=%f",scc.MinFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							i = sprintf(str, "MinFrameInterval=%d",scc.MinFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							
							//2,000,000 = MAX
							//333,333 = MIN
							
							//(LONGLONG)( MinFrameInterval / ((double)10000000)  );
							
							//MinFrameInterval = scc.MinFrameInterval/ ((double)10000000);
    						//MaxFrameInterval = scc.MaxFrameInterval/ ((double)10000000);
						    MinFrameInterval = scc.MinFrameInterval/ ((double)10000000);
    						MaxFrameInterval = scc.MaxFrameInterval/ ((double)10000000);
    
    						i = sprintf(str, "!!! MinFrameInterval=%d",scc.MinFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							i = sprintf(str, "!!!2 MinFrameInterval=%lf",MinFrameInterval);
							REALMessageBoxx(REALBuildString(str,i));
							
							// Is it VIDEOINFOHEADER and UYVY?
						    if (pmt->formattype == FORMAT_WaveFormatEx)
						    {
							/*		
							typedef struct waveformat_extended_tag {
							    WORD  wFormatTag;      
							    WORD  nChannels;       
					    		DWORD nSamplesPerSec;  
						    	DWORD nAvgBytesPerSec; 
							    WORD  nBlockAlign;     
							    WORD  wBitsPerSample;  
							    WORD  cbSize;          
							} WAVEFORMATEX;
							*/
		
							// Modify the format block.
						        WAVEFORMATEX *wfx = 
						            reinterpret_cast<WAVEFORMATEX*>(pmt->pbFormat);
	        
							//sampleRate = wfx->nSamplesPerSec;
		
						    }
	    
						}
	
						//void 		MyDeleteMediaType(AM_MEDIA_TYPE *pmt);
						//MyDeleteMediaType(pmt);

						//theFrameRate = (LONGLONG)(((double)10000000) * theFrameRate);
						i = sprintf(str, "theFrameRate=%lf",theFrameRate);
							REALMessageBoxx(REALBuildString(str,i));

						//theFrameRate = (LONGLONG)(((double)10000000) / theFrameRate);
						//i = sprintf(str, "multi theFrameRate=%lf",(LONGLONG)(((double)10000000) / theFrameRate));
						//	REALMessageBox(REALBuildString(str,i));
							
							
						if (theFrameRate > MaxFrameInterval)
						{
							//theFrameRate = MaxFrameInterval;
							//theFrameRate = MaxFrameInterval;//(LONGLONG)( MaxFrameInterval / ((double)10000000) );
						}

                        if (theFrameRate < MinFrameInterval)
						{
							//theFrameRate = MinFrameInterval;
							//theFrameRate = MinFrameInterval;//(LONGLONG)( MinFrameInterval / ((double)10000000) );
						}
                                
                        VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pmt->pbFormat;
                        pvi->AvgTimePerFrame = (LONGLONG)(((double)10000000) / theFrameRate);
                        //pvi->bmiHeader.biWidth = appData->CustomWidth;
                        //pvi->bmiHeader.biHeight = appData->CustomHeight;
                        //pmt->subtype = appData->ColourFormat;
                        hr = data->pVSC->SetFormat(pmt);
                        if(hr != NOERROR)
                        {
                                i = sprintf(str, "SetFormat fail2=%d",hr);
                                REALMessageBoxx(REALBuildString(str,i));
                                //CHAR error[256];
                                //hrToText(hr, error);
                                //ErrMsg(TEXT("%s : %s : %x"), MyString(IDS_CAP_51),error, hr);
                                //result = -3;
                        }
                }
                else
                {
                        //ErrMsg(TEXT("%s : %s : %x"),MyString(IDS_CAP_51),MyString(IDS_CAP_52), hr);
                        //result = -4;
                }
                
                
                MyDeleteMediaType(pmt);
                //DeleteMediaType(pmt);
                
           }     

		
	if (data->previewState)
	{
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
	}
	else
	{
		captureSetPreviewState(instance, 0, false);
	}
	
	
	if (pMC)
		pMC->Release;
		                
}

static REALstring captureGetVideoCompressionType(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	
	return	nil;//REALBuildString((QT::Ptr) &compType, 4);	
}

static void captureSetVideoCompressionType(REALcontrolInstance instance, long param, REALstring theCompType)
{
	ControlData(captureControl, instance, captureData, data);
	
}

// BJS added 11/12/02
static long captureGetVideoBlackLevelValue(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	return 0;//theBlackLevelValue;
}

static void captureSetVideoBlackLevelValue(REALcontrolInstance instance, long param, long theValue)
{
	ControlData(captureControl, instance, captureData, data);
		

}




//**************************************************************************************/
//
//     MIN AND MAX GETTERS FOR VIDEO PARAMS
//
//**************************************************************************************/
#pragma mark -

static long captureGetVideoBrightnessMax(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Brightness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Brightness, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        return (-1);
	    }
	} 
	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoBrightnessMin(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Brightness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Brightness, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoContrastMax(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Contrast, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Contrast, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoContrastMin(REALcontrolInstance instance)
{
			ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Contrast, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Contrast, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}


static long captureGetVideoHueMax(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Hue, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Hue, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}
static long captureGetVideoHueMin(REALcontrolInstance instance)
{
			ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Hue, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Hue, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoSaturationMax(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Saturation, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Saturation, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}
static long captureGetVideoSaturationMin(REALcontrolInstance instance)
{
			ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Saturation, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Saturation, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoSharpnessMax(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Sharpness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Sharpness, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoSharpnessMin(REALcontrolInstance instance)
{
			ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Sharpness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Sharpness, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoWhiteLevelMax(REALcontrolInstance instance)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_WhiteBalance, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_WhiteBalance, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Max;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

static long captureGetVideoWhiteLevelMin(REALcontrolInstance instance)
{
			ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_WhiteBalance, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_WhiteBalance, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        //char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			//int i;
			//i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Min;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Prop not supported",24));
	        return (-1);
	    }
	} 

	return (-4);//return a negative in case the code makes it down here... neg = not supported
}

//**************************************************************************************
#pragma mark -
//**************************************************************************************

static long captureGetVideoBrightness(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Brightness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Brightness, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;
}

static void captureSetVideoBrightness(REALcontrolInstance instance, long param, long theValue)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Brightness, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_Brightness, theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 

	//return 0;//theBrightness;
}


static long captureGetVideoContrast(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Contrast, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Contrast, &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;

}

static void captureSetVideoContrast(REALcontrolInstance instance, long param, long theValue)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Contrast, &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_Contrast, theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 
}


static long captureGetVideoHue(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Hue , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Hue , &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;

}

static void captureSetVideoHue(REALcontrolInstance instance, long param, long theValue)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Hue , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_Hue , theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 
}


static long captureGetVideoSaturation(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Saturation , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Saturation , &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;

}

static void captureSetVideoSaturation(REALcontrolInstance instance, long param, long theValue)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Saturation , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_Saturation , theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 
}


static long captureGetVideoSharpness(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Sharpness , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_Sharpness , &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;

}

static void captureSetVideoSharpness(REALcontrolInstance instance, long param, long theValue)
{
		ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_Sharpness , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_Sharpness , theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 
}


static long captureGetVideoWhiteLevelValue(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	    return (-3);
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_WhiteBalance , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Get(VideoProcAmp_WhiteBalance , &Val, &Flags);
	    }
	    else
	    {
	    	return (-2);
	    }
	    if (SUCCEEDED(hr))
	    {
	        char str[50]; /* MUST be big enough to hold all the characters of your number!! */ 
			int i;
			i = sprintf(str, "Val = %d; Max = %d; Min = %d; Flags = %d",Val,Min,Max,Flags);
	        ////REALMessageBoxx(REALBuildString(str,i));  
	        return Val;//Max and Min can be used in the other functions for this
	    }
	    else
	    {
	        // This property is not supported
	        ////REALMessageBoxx(REALBuildString("Brite Prop not supported",24));
	        return (-1);
	    }
	} 

	return 0;//theBrightness;

}

static void captureSetVideoWhiteLevelValue(REALcontrolInstance instance, long param, long theValue)
{
	ControlData(captureControl, instance, captureData, data);
	
	// Query the capture filter for the IAMVideoProcAmp interface.
	IAMVideoProcAmp *pProcAmp = 0;
	HRESULT hr;
	hr = data->pVCap->QueryInterface(IID_IAMVideoProcAmp, (void**)&pProcAmp);
	if (FAILED(hr))
	{
	    // The device does not support IAMVideoProcAmp, so disable the control.
	    ////REALMessageBoxx(REALBuildString("The device does not support IAMVideoProcAmp",43));
	}
	else
	{
	    long Min, Max, Step, Default, Flags, Val;

	    // Get the range and default value. 
	    hr = pProcAmp->GetRange(VideoProcAmp_WhiteBalance , &Min, &Max, &Step,
    	    &Default, &Flags);
	    if (SUCCEEDED(hr))
	    {
	        // Get the current value.
	        hr = pProcAmp->Set(VideoProcAmp_WhiteBalance , theValue, Flags);
	    }
	    else
	    {
	    	//nope - not set
	    }
	} 
}





#pragma mark -

// End BJS additions 11/12/02

static Boolean captureShowVideoSettingsDialog(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	ISpecifyPropertyPages 	*pSpec;
	CAUUID					cauuid;
    HRESULT hr;
    IMediaControl* mc = NULL;
    BOOL	oldPreviewState;

	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc);
	if (FAILED(hr))
		return false;

    
	if (data->pVCap != nil)
	{
		//REALMessageBoxx(REALBuildString("vidFail=no",10));
	}
	else
	{
		//REALMessageBoxx(REALBuildString("vidFail=yes",11));
		return false;
	}

	//mc->Stop();
	
	oldPreviewState = data->previewState;

#if 0	
captureSetPreviewState(instance, 0, false);
#endif

//*************************************************************************************
//this is the vfw video settings dlog... 
//*************************************************************************************
#if 1	
	hr = data->pVCap->QueryInterface(IID_ISpecifyPropertyPages,(void **)&pSpec);
	if(hr == S_OK)
	{
		hr = pSpec->GetPages(&cauuid);
		hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&data->pVCap, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);
		CoTaskMemFree(cauuid.pElems);
		pSpec->Release();
	}
#endif


//*************************************************************************************
//this is the pin dlog	
//*************************************************************************************
#if 0
    IAMStreamConfig *pSC;

    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&pSC);
    if(hr != S_OK)
        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&pSC);

    if(hr == S_OK)
    {
        hr = pSC->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSpec);
        if(hr == S_OK)
        {
            hr = pSpec->GetPages(&cauuid);
            if(hr == S_OK && cauuid.cElems > 0)
            	{
				hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&pSC, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);

                CoTaskMemFree(cauuid.pElems);
            	}

            pSpec->Release();
        }
        pSC->Release();
	}
#endif


//*************************************************************************************
//this is the DV size dlog	
//*************************************************************************************
#if 0
	

	
	//g_pGraph->StopGraph();
	// stop the graph
    IMediaControl *pMC = NULL;
    //HRESULT 
    hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
    if(SUCCEEDED(hr))
    {
        ////REALMessageBoxx(REALBuildString("STOP 3",6));  
        hr = pMC->Stop();
        ////REALMessageBoxx(REALBuildString("STOP 3A",7));  
        pMC->Release();
        ////REALMessageBoxx(REALBuildString("STOP 3B",7));  
    }
    
	
	int             g_iVWHeight;//    = DEFAULT_VIDEO_HEIGHT;
	int             g_iVWWidth;//     = DEFAULT_VIDEO_WIDTH;        
	//HRESULT 	GetVideoWindowDimensions 
	//(REALcontrolInstance instance, int* pWidth, int *pHeight, BOOL bChangeResolution,HWND hwndApp);
	
	hr = GetVideoWindowDimensions(instance, &g_iVWWidth, &g_iVWHeight, TRUE, data->ghwndApp);
	//hr = GetVideoWindowDimensions(instance, &g_iVWWidth, &g_iVWHeight, FALSE, data->ghwndApp);
	
	//SetPreviewWindow();
	
	
#endif

#if 0	
	captureSetPreviewState(instance, 0, oldPreviewState);
	//mc->Run();
#endif
	      
	return true;
}

static Boolean captureShowVideoSettingsPinDialog(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	ISpecifyPropertyPages 	*pSpec;
	CAUUID					cauuid;
    HRESULT hr;
    IMediaControl* mc = NULL;
    BOOL	oldPreviewState;

	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc);
	if (FAILED(hr))
		return false;

    
	if (data->pVCap != nil)
	{
		//REALMessageBoxx(REALBuildString("vidFail=no",10));
	}
	else
	{
		//REALMessageBoxx(REALBuildString("vidFail=yes",11));
		return false;
	}

	//mc->Stop();
	
	oldPreviewState = data->previewState;
	
	captureSetPreviewState(instance, 0, false);

//*************************************************************************************
//this is the vfw video settings dlog... 
//*************************************************************************************
#if 0//1	
	hr = data->pVCap->QueryInterface(IID_ISpecifyPropertyPages,(void **)&pSpec);
	if(hr == S_OK)
	{
		hr = pSpec->GetPages(&cauuid);
		hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&data->pVCap, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);
		CoTaskMemFree(cauuid.pElems);
		pSpec->Release();
	}
#endif


//*************************************************************************************
//this is the pin dlog	
//*************************************************************************************
#if 1
    IAMStreamConfig *pSC;

    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&pSC);
    if(hr != S_OK)
        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&pSC);

    if(hr == S_OK)
    {
        hr = pSC->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSpec);
        if(hr == S_OK)
        {
            hr = pSpec->GetPages(&cauuid);
            if(hr == S_OK && cauuid.cElems > 0)
            	{
				hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&pSC, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);

                CoTaskMemFree(cauuid.pElems);
            	}

            pSpec->Release();
        }
        pSC->Release();
	}
#endif


//*************************************************************************************
//this is the DV size dlog	
//*************************************************************************************
#if 0
	

	
	//g_pGraph->StopGraph();
	// stop the graph
    IMediaControl *pMC = NULL;
    //HRESULT 
    hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
    if(SUCCEEDED(hr))
    {
        ////REALMessageBoxx(REALBuildString("STOP 3",6));  
        hr = pMC->Stop();
        ////REALMessageBoxx(REALBuildString("STOP 3A",7));  
        pMC->Release();
        ////REALMessageBoxx(REALBuildString("STOP 3B",7));  
    }
    
	
	int             g_iVWHeight;//    = DEFAULT_VIDEO_HEIGHT;
	int             g_iVWWidth;//     = DEFAULT_VIDEO_WIDTH;        
	//HRESULT 	GetVideoWindowDimensions 
	//(REALcontrolInstance instance, int* pWidth, int *pHeight, BOOL bChangeResolution,HWND hwndApp);
	
	hr = GetVideoWindowDimensions(instance, &g_iVWWidth, &g_iVWHeight, TRUE, data->ghwndApp);
	//hr = GetVideoWindowDimensions(instance, &g_iVWWidth, &g_iVWHeight, FALSE, data->ghwndApp);
	
	//SetPreviewWindow();
	
	
#endif

	
	captureSetPreviewState(instance, 0, oldPreviewState);
	//mc->Run();
	      
	return true;
}

                
static Boolean captureShowSoundSettingsDialog(REALcontrolInstance instance)
{

	ControlData(captureControl, instance, captureData, data);
	
	ISpecifyPropertyPages 	*pSpec;
	CAUUID					cauuid;
    HRESULT hr;
    IMediaControl* mc = NULL;
    BOOL	oldPreviewState;

	hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc);
	if (FAILED(hr))
		return false;

    
	if (data->pACap != nil)
	{
		//REALMessageBoxx(REALBuildString("vidFail=no",10));
	}
	else
	{
		//REALMessageBoxx(REALBuildString("vidFail=yes",11));
		return false;
	}

	//mc->Stop();
	
	oldPreviewState = data->previewState;
	
	captureSetPreviewState(instance, 0, false);

//*************************************************************************************
//this is the vfw video settings dlog... 
//*************************************************************************************
#if 1	
	hr = data->pACap->QueryInterface(IID_ISpecifyPropertyPages,(void **)&pSpec);
	if(hr == S_OK)
	{
		hr = pSpec->GetPages(&cauuid);
		hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&data->pACap, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);
		CoTaskMemFree(cauuid.pElems);
		pSpec->Release();
	}
#endif


//*************************************************************************************
//this is the pin dlog	
//*************************************************************************************
#if 0
    IAMStreamConfig *pSC;

    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pACap, IID_IAMStreamConfig, (void **)&pSC);
    if(hr != S_OK)
        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pACap, IID_IAMStreamConfig, (void **)&pSC);

    if(hr == S_OK)
    {
        hr = pSC->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pSpec);
        if(hr == S_OK)
        {
            hr = pSpec->GetPages(&cauuid);
            if(hr == S_OK && cauuid.cElems > 0)
            	{
				hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,(IUnknown **)&pSC, cauuid.cElems,(GUID *)cauuid.pElems, 0, 0, NULL);

                CoTaskMemFree(cauuid.pElems);
            	}

            pSpec->Release();
        }
        pSC->Release();
	}
#endif

	
	captureSetPreviewState(instance, 0, oldPreviewState);
	//mc->Run();
	      
	return true;


/*
	ControlData(captureControl, instance, captureData, data);

	
	ISpecifyPropertyPages *pSpec;
	CAUUID cauuid;
    
    HRESULT hr;            

	if(data->previewState)
		StopPreview(instance);

	IAMStreamConfig *pSC;
	hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE,
		&MEDIATYPE_Audio, data->pACap,
		IID_IAMStreamConfig, (void **)&pSC);

	
	hr = pSC->QueryInterface(IID_ISpecifyPropertyPages,(void **)&pSpec);
		if(hr == S_OK)
		{
			
			//REALMessageBoxx(REALBuildString("audio 2",7));
			
			hr = pSpec->GetPages(&cauuid);
			hr = OleCreatePropertyFrame(data->ghwndApp, 30, 30, NULL, 1,
                        (IUnknown **)&pSC, cauuid.cElems,
                        (GUID *)cauuid.pElems, 0, 0, NULL);

			CoTaskMemFree(cauuid.pElems);
			pSpec->Release();
		}
		else
		{
			//REALMessageBoxx(REALBuildString("audio 3",7));
		}
		pSC->Release();

	return true;
*/

}



static Boolean captureIsRecording(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);

	return data->recordState;

}

static void captureIdle(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);

}

static void captureStartRecordingAsync(REALcontrolInstance instance, REALfolderItem theMovieFile)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (StartCapture(instance, theMovieFile))
	{
		//REALMessageBoxx(REALBuildString("start capture cool",18));
	}
	else
	{
		//REALMessageBoxx(REALBuildString("start capture not cool",22));
	}
	
	return;
}


static void captureStartRecordingAsyncTime(REALcontrolInstance instance, REALfolderItem theMovieFile, long theTicks)
{
	ControlData(captureControl, instance, captureData, data);
	
	//co-opt the other recording method for Win32
	captureStartRecordingAsync(instance, theMovieFile);
	return;
}

static void captureStartRecordingSync(REALcontrolInstance instance, REALfolderItem theMovieFile)
{
	ControlData(captureControl, instance, captureData, data);
	
	//co-opt the other recording method for Win32
	captureStartRecordingAsync(instance, theMovieFile);

	return;
}


static void captureStartRecordingSyncTime(REALcontrolInstance instance, REALfolderItem theMovieFile, long theTicks)
{
	ControlData(captureControl, instance, captureData, data);
	
	//co-opt the other recording method for Win32
	captureStartRecordingAsync(instance, theMovieFile);

	return;

}

static void captureSetPreviewState(REALcontrolInstance instance, long param, Boolean theState)
{

	ControlData(captureControl, instance, captureData, data);

	char 				str[50];
	int 				i = sprintf(str, "captureSetPreviewState");
	long 				prevEnableFlag, prevWhileRecFlag;
	HRESULT 			hr, err;
	IMediaControl 		*pMC = NULL;
	AM_MEDIA_TYPE 		*pmt=0;
	REFERENCE_TIME 		start = MAX_TIME;
	REFERENCE_TIME 		stop = MAX_TIME;
	
	data->previewState = theState;
	data->refreshPreviewPicture = true;
	
	if (REALinRuntime)
	{	
		

		i = sprintf(str, "captureSetPreviewState REALinRunTime");
		REALMessageBoxx(REALBuildString(str,i));
		
		if (!data->pRender)
			{
			i = sprintf(str, "captureSetPreviewState: (!data->pRender)");
			REALMessageBoxx(REALBuildString(str,i));
			//if (data->VRCreated == 2)
			//	CreateVideoRenderer(instance);
			return;
			}
		if (!data->pVCap)
			{
			i = sprintf(str, "captureSetPreviewState: (!data->pVCap)");
			REALMessageBoxx(REALBuildString(str,i));
			return;
			}
			
		i = sprintf(str, "captureSetPreviewState REALinRunTime2");
		REALMessageBoxx(REALBuildString(str,i));

		hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
		if(FAILED(hr))
			return;
		
		i = sprintf(str, "captureSetPreviewState REALinRunTime3");
		REALMessageBoxx(REALBuildString(str,i));
		
		if (data->previewState == true)//XYZ
		{
			REALMessageBoxx(REALBuildString("SetPreviewStateOn",17));
			i = sprintf(str, "if (data->previewState == true)");
			REALMessageBoxx(REALBuildString(str,i));
			pMC->Stop;
				
			IPin *pPin1;
			hr = data->pBuilder->FindPin(data->pVCap, PINDIR_OUTPUT, 0, 0, TRUE, 0, &pPin1);
			if(FAILED(hr))
			{
				return;
			}

// JUNE 2004 TEST!			
			//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Stream, data->pVCap, NULL, data->pRender); // try MPEG first
			hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Stream, pPin1, NULL, data->pRender); // try MPEG first
			if(FAILED(hr))//123
			{
				//i = sprintf(str, "RenderStream failed with MEDIATYPE_Stream = %d",hr);
				//REALMessageBoxx(REALBuildString(str,i));
				REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Stream",41));
				//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Interleaved, data->pVCap, NULL, data->pRender); // try interleaved next
				hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Interleaved, pPin1, NULL, data->pRender); // try interleaved next
				if(FAILED(hr))//456
				{
					//i = sprintf(str, "RenderStream failed with MEDIATYPE_Interleaved = %d",hr);
					//REALMessageBoxx(REALBuildString(str,i));
					REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Interleaved",46));
					//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, data->pVCap, NULL, data->pRender); // try video last
					hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pPin1, NULL, data->pRender); // try video last
					if(FAILED(hr))//789
						{
							//i = sprintf(str, "RenderStream failed with MEDIATYPE_Video = %d",hr);
							//REALMessageBoxx(REALBuildString(str,i));
							REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Video",46));
						}//if(FAILED(hr))//789
				}//if(FAILED(hr))//456
			}//if(FAILED(hr))//123
    		//}
    		
			//
	    	//
	    	//  If you render a preview stream and the 
	    	//  method uses a Smart Tee filter, 
	    	//  it returns VFW_S_NOPREVIEWPIN (262782).
	    	//
	    	//  so, then we find it with the 
	    	//  FindFilterByName function
	    	//
			//
	    	//i = sprintf(str, "capSetEnableVideo post renderstream = %s",DXGetErrorString9(hr));
	    	//i = sprintf(str, "capSetEnableVideo post renderstream = %s : %d",DXGetErrorString9(hr), hr);
	    	i = sprintf(str, "hello");
	  		//REALMessageBoxx(REALBuildString(str,i));
	  		if ( hr == 262782 )//VFW_S_NOPREVIEWPIN
	  		{
	  			REALMessageBoxx(REALBuildString(str,i));
	  			//IBaseFilter *pVideo = NULL;
				//IBaseFilter *pAudio = NULL;
				//gcap.pFg->FindFilterByName(L"Video Capture Filter", &pVideo);
				//gcap.pFg->FindFilterByName(L"Audio Capture Filter", &pAudio);
				hr = data->pFg->FindFilterByName(L"Smart Tee", &data->pSmartTee);
				if (hr == S_OK)
				{
					i = sprintf(str, "found smart tee");
				}
				else
				{
					i = sprintf(str, "problem finding TEE = %d",hr);
					//return hr;
				}
				REALMessageBoxx(REALBuildString(str,i));
			}//if ( hr == 262782 )//VFW_S_NOPREVIEWPIN
		
		
if (pPin1)
hr = pPin1->Release();		
    
			//
	    	// Get the preview window to be a child of our app's window...
		    // This will find the IVideoWindow interface on the renderer.  It is 
		    // important to ask the filtergraph for this interface... do NOT use
		    // ICaptureGraphBuilder2::FindInterface, because the filtergraph needs to
		    // know we own the window so it can give us display changed messages, etc.
			//
bool isDV = false;

					
		    hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		    if(hr != NOERROR)
		    {
		        //ErrMsg(TEXT("This graph cannot preview properly"));
		        i = sprintf(str, "This graph cannot preview properly");
			  	REALMessageBoxx(REALBuildString(str,i));
		    }
		    else//// hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
			{
		     
		    //*************************************************************************************
			//check for DV - START
			//*************************************************************************************
		    AM_MEDIA_TYPE * pmtDV;
		    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);
		    if(hr != S_OK)
		        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);

		    if(hr == S_OK)
		    {
		     	i = sprintf(str, "data->pVSC a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
        	}
        	else
        	{
        		i = sprintf(str, "data->pVSC !a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
			}
	
	        if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
	        {
	            if(pmtDV->formattype == FORMAT_DvInfo)
	            {
	                
	                isDV = true;
	                i = sprintf(str, "formattype == FORMAT_DvInfo");
		  			REALMessageBoxx(REALBuildString(str,i));
	            }//if(pmtDV->formattype == FORMAT_DvInfo)
	            else
	            {
	            isDV = false;
	            }
	        }//if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
			//*************************************************************************************
			//check for DV - END
			//*************************************************************************************







			//*************************************************************************************
			//	render audio preview
			//*************************************************************************************
if (data->enableSound)
{
			//do we have an inf tee?
			if (data->pInfTee)
				{
				//do nada
				i = sprintf(str, "do nada 1");
				}
			else
				{
					i = sprintf(str, "do nada 2");
					if (data->previewState == true)
						CreateAudioInfiniteTee(instance);
				}
				REALMessageBoxx(REALBuildString(str,i));
			
			
			//do we have audioRender?	
			if (data->pAudioRender)
				{
				//do nada
				i = sprintf(str, "do nada 3");
				}
			else
				{
					i = sprintf(str, "do nada 4");
					if (data->previewState == true)
						{
						CreateAudioPreviewRender(instance);
						i = sprintf(str, "do nada 444");
						//REALMessageBox(REALBuildString(str,i));
						}
				}
				
				//i = sprintf(str, "PLEASE CHECK GRAPH");
				REALMessageBoxx(REALBuildString(str,i));
						
				if (data->previewState == true)
				{
					//render the preview audio 
					if ( (data->pACap) && (data->pInfTee) && (data->pAudioRender) )
					{
						//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, data->pInfTee, data->pAudioRender);
						hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, data->pInfTee, data->pAudioRender);
						//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, data->pInfTee, data->pAudioRender);
						//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, 0, data->pInfTee);
						
						//works for preview, but is ignoring pInfTee
						//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, 0, data->pAudioRender);
						if(hr == NOERROR)
						{
							i = sprintf(str, "2 RenderStream audio preview hr = %d",hr);
						}
						else
						{
							i = sprintf(str, "2. RenderStream audio preview err hr = %d",hr);
						}
						REALMessageBoxx(REALBuildString(str,i));
						/*
						hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pInfTee, 0, data->pAudioRender);
						if(hr == NOERROR)
						{
							i = sprintf(str, "3 RenderStream audio preview hr = %d",hr);
						}
						else
						{
							i = sprintf(str, "3. RenderStream audio preview err hr = %d",hr);
						}
						REALMessageBox(REALBuildString(str,i));
						*/
					}
				}
}				
//void CreateAudioInfiniteTee(REALcontrolInstance instance);
//void CreateAudioPreviewRender(REALcontrolInstance instance);
//IBaseFilter 			*pInfTee;
//IBaseFilter 			*pAudioRender;
				
				
		    	//RECT rc;
		    	data->pVW->put_Owner((OAHWND)data->ghwndApp);   // We own the window now
		    	data->pVW->put_WindowStyle(WS_CHILD);    		// you are now a child
		
		
				//ControlData(captureControl, instance, captureData, data);
				::Rect	r;
				long displayWidth, naturalWidth, displayHeight, naturalHeight=0;
			
				REALGetControlBounds(instance, &r);
				
				
				i = sprintf(str, "r.left = %d\nr.top=%d\nr.right=%d\nr.bottom=%d",r.left,r.top,r.right,r.bottom);
				REALMessageBoxx(REALBuildString(str,i));
				i = sprintf(str, "r.top = %d",naturalHeight);
				REALMessageBoxx(REALBuildString(str,i));
		
				//**************************************************
				//  bounds code goes here!
				//**************************************************
		           	
				data->theSGBounds.left = r.left;
				data->theSGBounds.top = r.top;
				data->theSGBounds.right = r.right;
				data->theSGBounds.bottom = r.bottom;
				
				displayWidth = r.right - r.left;
				displayHeight = r.bottom - r.top;
				
				IBasicVideo *basicVideo;
				
				//hr = basicVideo->SetSourcePosition(data->theSGBounds.left, data->theSGBounds.top, theWidth, theHeight); // BJS 11/08/03
		
				if (isDV)
				{
					hr = data->pRender->QueryInterface(IID_IBasicVideo, (void**)&basicVideo);
					
					hr = basicVideo->GetVideoSize(&naturalWidth, &naturalHeight); // BJS 11/08/03	
					i = sprintf(str, "naturalWidth = %d\nnaturalHeight = %d",naturalWidth,naturalHeight);
					REALMessageBoxx(REALBuildString(str,i));
					//i = sprintf(str, "naturalHeight = %d",naturalHeight);
					//REALMessageBoxx(REALBuildString(str,i));
					  				
					if (naturalWidth > 0 && naturalHeight > 0)
					{
						data->theNaturalBounds.left = 0;
						data->theNaturalBounds.top = 0;
						data->theNaturalBounds.right = naturalWidth; // BJS 11/08/03
						data->theNaturalBounds.bottom = naturalHeight; // BJS 11/08/03
					}
					
					//return (data->theNaturalBounds.right - data->theNaturalBounds.left)*2;
					//return (data->theNaturalBounds.bottom - data->theNaturalBounds.top)*2;

					//i = sprintf(str, "displayWidth = %d\ndisplayHeight=%d\nnaturalWidth=%d\nnaturalHeightm=%d",displayWidth,displayHeight,naturalWidth,naturalHeight);
					//REALMessageBoxx(REALBuildString(str,i));
				
					//data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, naturalWidth, naturalHeight);		
					data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, displayWidth, displayHeight);
					/*
					if (displayWidth > naturalWidth)
						{data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, displayWidth, displayHeight);		}
					else
						{
						data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, naturalWidth, naturalHeight);		
						}
					*/
					
				}
				else
				{
					data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, displayWidth, displayHeight);		
				}
				//hr = basicVideo->SetSourcePosition(data->theNaturalBounds.left, data->theNaturalBounds.top, naturalWidth, naturalHeight); // BJS 11/08/03
				
				
				//		hr = basicVideo->put_DestinationWidth(theWidth);
				//		hr = basicVideo->put_DestinationHeight(theHeight);
			    
			}//if (noErr) hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
			//
			
			i = sprintf(str, "test1");
			REALMessageBoxx(REALBuildString(str,i));
								
			//
			// now tell  it what frame rate to capture at.  Just find the format it
	    	// is capturing with, and leave everything alone but change the frame rate
	    	// No big deal if it fails.  It's just for preview
	    	// !!! Should we then talk to the preview pin?
	    	//
		    if(data->pVSC && data->fUseFrameRate)
		    {
		        //pVSC
		        i = sprintf(str, "if(data->pVSC && data->fUseFrameRate)");
				REALMessageBoxx(REALBuildString(str,i));
			
		        hr = data->pVSC->GetFormat(&pmt);
				i = sprintf(str, "data->pVSC->GetFormat(&pmt) = %d",hr);
				REALMessageBoxx(REALBuildString(str,i));
		        //**************************************************
		        // DV capture does not use a VIDEOINFOHEADER
		        //**************************************************
		        if(hr == NOERROR)
		        {
		            i = sprintf(str, "hr == NOERROR");
					REALMessageBoxx(REALBuildString(str,i));
					
					if(pmt->formattype == FORMAT_VideoInfo)
		            {
		                i = sprintf(str, "pmt->formattype == FORMAT_VideoInfo");
						REALMessageBoxx(REALBuildString(str,i));
					
						VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pmt->pbFormat;
		                pvi->AvgTimePerFrame = (LONGLONG)(10000000 / data->FrameRate);
		
	    	            hr = data->pVSC->SetFormat(pmt);
	    	            if(hr != NOERROR)
						{
							/*ErrMsg(TEXT("%x: Cannot set frame rate for preview"), hr);*/
						}
	    	        }
	    	        //DeleteMediaType(pmt);
	    	    }
	    	}//if(data->pVSC && data->fUseFrameRate)
		    	
			
			//
	    	//
	    	// make sure we process events while we're previewing!
	    	//
	    	//
	    	hr = data->pFg->QueryInterface(IID_IMediaEventEx, (void **)&data->pME);
	    	if(hr == NOERROR)
	    	{
	    	    data->pME->SetNotifyWindow((OAHWND)data->ghwndApp, WM_FGNOTIFY, 0);
	    	    data->pME->SetNotifyWindow((OAHWND)data->ghwndApp, WM_DISPLAYCHANGE, 0);
			}
			
			//
			//
			//  run the preview
			//
			//			
			hr = pMC->Run();
			data->fPreviewing = true;
			//data->pMC->Run();
			//hr = data->pBuilder->ControlStream(&PIN_CATEGORY_CAPTURE, NULL,NULL, NULL, &stop, 0, 0);
	        if(FAILED(hr))
	        {
    	        // stop parts that ran
        	    REALMessageBoxx(REALBuildString("stop parts that ran FAIL",24));
	        }
				
		}//if (data->previewState == true)//XYZ
		//
		//
		//
		else //(data->previewState == false)
		{
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
#if 1		
				//captureSetPreviewState(instance, 0, data->previewState);
				//REALMessageBoxx(REALBuildString("?!?!?! SetPreviewStateOff",18));
				
				//StopPreview(instance);
				//data->previewState = theState;
				//const 
				//WORD wStartCookie = 1, wStopCookie = 2;  // Arbitrary values. 
				
				hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&data->pMC);
			    if(SUCCEEDED(hr))
			    {
	            	hr = data->pMC->Stop();
	            	
            	data->fPreviewing = false;
            	//data->pBuilder->ControlStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, data->pVCap,0,MAXLONGLONG,NULL,NULL);//(WORD *)wStopCookie); 
            	i = sprintf(str, "PREVIEW STOPPING hr = %d",hr);
            	REALMessageBoxx(REALBuildString(str,i));
	            }
				//NukeDownstream(instance, data->pVCap, true);
				//NukeDownstream(instance, data->pSmartTee, true);
				
				//NukeDownstream(instance, data->pSmartTee, false);
				NukeDownstream(instance, data->pVCap, false);
				data->pFg->RemoveFilter(data->pSmartTee);
				data->pSmartTee = NULL;
				data->VRCreated = 2;
				
				
				//
				//do we have audioRender?	
				//NukeDownstream(instance, data->pInfTee,false);//pACap, false);
				NukeDownstream(instance, data->pACap,false);
				data->pFg->RemoveFilter(data->pInfTee);
				data->pFg->RemoveFilter(data->pAudioRender);
				
				data->pInfTee = NULL;
				data->pAudioRender = NULL;
			
				
				//
				//
				
				
IBaseFilter *tempFilter = NULL;

hr = data->pFg->FindFilterByName(L"Smart Tee", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;

hr = data->pFg->FindFilterByName(L"Smart Tee 0001", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;


hr = data->pFg->FindFilterByName(L"Smart Tee 0002", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;


hr = data->pFg->FindFilterByName(L"Smart Tee 0003", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;


hr = data->pFg->FindFilterByName(L"Smart Tee 0004", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;


hr = data->pFg->FindFilterByName(L"Smart Tee 0005", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;
	

hr = data->pFg->FindFilterByName(L"Smart Tee 0006", &tempFilter);
if (tempFilter)
	data->pFg->RemoveFilter(tempFilter);
tempFilter = NULL;


if (tempFilter)	
	tempFilter->Release;
	
				
				//
				//
				
				
				//if (data->pAudioRender)
				//{
				//data->pFg->RemoveFilter(data->pAudioRender);
				//}

				//do we have pInfTee?	
				//if (data->pInfTee)
				//{
				//data->pFg->RemoveFilter(data->pInfTee);
				//}
				//
				
				
				i = sprintf(str, "POST PREVIEW STOPPING hr = %d",hr);
            	REALMessageBoxx(REALBuildString(str,i));
#endif            	
				//pMC->Run();
		}//if (data->previewState == true)//XYZ
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		

		if (pMC)
			pMC->Release;
				
	} //if (REALinRuntime)
	

}//captureSetPreviewState



static Boolean captureGetPreviewState(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	//data->fWantPreview = data->previewState;
	return data->previewState;
}

static void captureSetPreviewWhileRecordingState(REALcontrolInstance instance, long param, Boolean theState)
{
	ControlData(captureControl, instance, captureData, data);
	data->previewWhileRecording = theState;
}

static Boolean captureGetPreviewWhileRecordingState(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	return data->previewWhileRecording;
}

static void captureSetPause(REALcontrolInstance instance, long param, Boolean theState)
{
	ControlData(captureControl, instance, captureData, data);
	IMediaControl* mc = NULL; 
	HRESULT hr;
	data->pauseState = theState;
	
	if (data->pauseState)
	{
		hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
		if (SUCCEEDED(hr)) 
		{
			mc->Pause(); 
			mc->Release(); 
		}
	}
	else
	{
		hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&mc); 
		if (SUCCEEDED(hr)) 
		{
			mc->Run(); 
			mc->Release(); 
		}
	}
			
}

static Boolean captureGetPause(REALcontrolInstance instance, long param)
{
	ControlData(captureControl, instance, captureData, data);
	return data->pauseState;
	
	//return false;
/*	
	Byte paused;
	ComponentResult err;
	
	////REALMessageBoxx(REALBuildString("GetPause",8));
	
	err = SGGetPause(data->theSGComp, &paused);
	if (err == QT::noErr)
		{
		if (paused == seqGrabPause)
			data->pauseState = true;
		else
			data->pauseState = false;
		}
	
	return data->pauseState;
*/	
}

static void captureStop(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);

	long err = 0;
	
	if (StopCapture(instance))
	{
		if ( (data->previewState) && (data->enableVideo == true) )//0)//
		{
					REALMessageBoxx(REALBuildString("start vid here",14));
					//captureSetPreviewState(instance,0,true);
					captureSetPreviewState(instance, 0, false);
					REALMessageBoxx(REALBuildString("off",3));
					captureSetPreviewState(instance, 0, true);
					REALMessageBoxx(REALBuildString("on ",3));

		}
		else
		{
			//REALMessageBoxx(REALBuildString("stop v a-ok3",12));
		}
	}
	else
	{
		//REALMessageBoxx(REALBuildString("stop v !a-ok",12));
	}
	return;
	
}

static void captureFireErrorEvent(REALcontrolInstance instance, long theError)
{
	// get our private data
	ControlData(captureControl, instance, captureData, data);

	////REALMessageBoxx(REALBuildString("FireErrorEvent",14));
	//	return;//
	if (theError == 0)
		return;
	
	// invoke the event handler
	void (*fp)(REALcontrolInstance instance, int);
	fp = (void (*)(REALcontrolInstance instance, int)) REALGetEventInstance(instance, &captureEvents[0]);
	if (fp) fp(instance, theError);
}

static void captureFireRecordEvent(REALcontrolInstance instance)
{
	// get our private data
	ControlData(captureControl, instance, captureData, data);

	////REALMessageBoxx(REALBuildString("FireRecordEvent",15));
	
	// invoke the event handler
	void (*fp)(REALcontrolInstance instance);
	fp = (void (*)(REALcontrolInstance instance)) REALGetEventInstance(instance, &captureEvents[1]);
	if (fp) fp(instance);
}

static void captureFireStopEvent(REALcontrolInstance instance)
{
	// get our private data
	ControlData(captureControl, instance, captureData, data);
	
	////REALMessageBoxx(REALBuildString("FireStopEvent",13));

	// invoke the event handler
	void (*fp)(REALcontrolInstance instance);
	fp = (void (*)(REALcontrolInstance instance)) REALGetEventInstance(instance, &captureEvents[2]);
	if (fp) fp(instance);
}

/*
static void captureEventFilterHandler (EventRecord *event, long theInstance)
{

	ComponentResult err = QT::noErr;
	Boolean currentPreviewState;
	
	////REALMessageBoxx(REALBuildString("EventFilterHandler",18));
	
	if (theInstance != nil)
		{
		ControlData(captureControl, (REALcontrolInstance) theInstance, captureData, data);
	
		if (REALinRuntime)
			{
			if (data->theSGComp != nil)
				{
				err = SGIdle(data->theSGComp);
				err = SGGetMode(data->theSGComp, &currentPreviewState, &data->recordState);
				
				if (data->recordState || currentPreviewState)
					{
					err = SGIdle(data->theSGComp);
					if (err == grabTimeComplete)
						captureStop((REALcontrolInstance) theInstance);
					
					}		
				}
			}
		}

}
*/


//********************************************************************************************************
#pragma mark -
//********************************************************************************************************
//  WIN32 DIRECTX CAPTURE CODE
//********************************************************************************************************


int GetVideoDeviceCount(void)
{
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
		{
		//REALMessageBoxx(REALBuildString("pEnum      = gut",16));  
	    // Create an enumerator for the video capture category.
	    if (pDevEnum != nil)
	    	{
	    	hr = pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,&pEnum, 0);
	    	}
	    else
	    	{
	    	return -1;	
	    	}
		} 
	else
		{
		return -1;
		}


	
	int count = 0;

	IMoniker *pMoniker = NULL;
	if (pEnum != nil)
		{
		}
	else
		{
		return -1;//this happens if no devices are plugged in
		}
	
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
		{
		count++;
		} 
	return count;
}


//********************************************************************************************************

int GetFreeVideoDevicePathSlot(void)
{

/*
BSTR			bestDevice1Path, 
				bestDevice2Path, 
				bestDevice3Path, 
				bestDevice4Path, 
				bestDevice5Path, 
				bestDevice6Path, 
				bestDeviceDefaultPath;
*/

	if (lstrcmpW(bestDevice1Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID1", 28));
					return (1);
					}
	if (lstrcmpW(bestDevice2Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID2", 28));
					return (2);
					}
	if (lstrcmpW(bestDevice3Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID3", 28));
					return (3);
					}
	if (lstrcmpW(bestDevice4Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID4", 28));
					return (4);
					}
	if (lstrcmpW(bestDevice5Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID5", 28));
					return (5);
					}
	if (lstrcmpW(bestDevice6Path, bestDeviceDefaultPath) == 0)
					{
					//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == ID6", 28));
					return (6);
					}
	
	//REALMessageBoxx(REALBuildString("GetFreeDevicePathSlot == NO SLOTS AVAILABLE", 43));
	return (0);//no slots available
	
}




//********************************************************************************************************

int SetupInitialVideoDevice(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	
	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	int					preferredDevice = 1;
	char 				str[50];
	WCHAR 				*dummyChar = NULL;
	int 				i,ii;
	bool				deviceLoadedSoFar = false;

	i = sprintf(str, "captureInit");

	//***************************************************************
	//  LOOP THRU DEVICEPATH STRINGS
	//  SEARCHING FOR FIRST AVAILABLE UNUSED SLOT
	//  IF WE DON'T GET BACK A VALUE OF 1 THRU 6
	//  IT MEANS NO SLOTS ARE OPEN
	//***************************************************************
	ii = GetFreeVideoDevicePathSlot();
	if (ii <= 0)
	{
		data->videoSlotNumber = 0;//this indicates we have no videoDevice for this control
		i = sprintf(str, "No slot found\ndata->videoSlotNumber = %d\nii = %d",data->videoSlotNumber,ii);
		//REALMessageBoxx(REALBuildString(str,i));
		return ii;//exit if we didn't find an empty slot
	}
	//  set the "videoSlotNumber" (i.e. the index where we'll store the path in the globals)
	data->videoSlotNumber = ii;

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,
	        &pEnum, 0);
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName2",19));  
	} 
	else
	{
		return -1;
	}

	int count = 0;
	if (pEnum != nil)
	{
	}
	else
	{
		return -1;//this happens if no devices are plugged in
	}
	

	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;

		i = sprintf(str, "count --->  %d",count);
		//REALMessageBoxx(REALBuildString(str,i));
	
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    REALMessageBoxx(REALBuildString("GetVideoDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VARIANT	varPath;
	    VariantInit(&varName);
	    VariantInit(&varPath);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        REALMessageBoxx(REALBuildString("GetVideoDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	        REALMessageBoxx(REALBuildString("GetVideoDeviceName6",19));  
	        char *strA;
	        //REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        //REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        
	        	hr = pPropBag->Read(L"DevicePath", &varPath, 0);
				//REALMessageBoxx(REALBuildString( wtoa(varPath.bstrVal,varPath.bstrVal[0]),varPath.bstrVal[0]));
	        

				//--------------------------------------------------------------------------------
	        	//
	        	//  OK, we have a devicePath
	        	//  now we need to know if it is already being used or not..
	        	//  to do so, we check each slot to see if has the same path name 
	        	//  as the device we are examining
	        	//  if it does, then the device we are looking at is already in use
	        	//  if not, we can use it... and we should choose it as the default
	        	//
	        	//--------------------------------------------------------------------------------
	        	//  fun stuff! :-(
	        	
	        	
	        	if (lstrcmpW(bestDevice1Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice1Path in use", 22));
					}
				else if (lstrcmpW(bestDevice2Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice2Path in use", 22));
					}
				else if (lstrcmpW(bestDevice3Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice3Path in use", 22));
					}
				else if (lstrcmpW(bestDevice4Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice4Path in use", 22));
					}
				else if (lstrcmpW(bestDevice5Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice5Path in use", 22));
					}
				else if (lstrcmpW(bestDevice6Path, varPath.bstrVal) == 0)
					{
					//REALMessageBoxx(REALBuildString("bestDevice6Path in use", 22));
					}
				else
					{
						
						i = sprintf(str, "deviceNumFound = %d\ndata->videoSlotNumber = %d",count,data->videoSlotNumber);
	        			//REALMessageBoxx(REALBuildString(str, i));
						
						//set the flag to get us out of the while loop... blech
						//deviceFound = n;
					if (deviceLoadedSoFar==false)//this is so we load one new device each time
					{	
						//  device n is currently not in use
						//  let's use it! 
						switch (data->videoSlotNumber)
	    		    	{
	        		
			        		case 1:
				        		SysFreeString(bestDevice1Path);
								bestDevice1Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice1Name);
								bestDevice1Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 1 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
										{
										//i = sprintf(str, "AddFilter wachFriendlyName succeeded = %s",(wtoa(data->wachFriendlyName,lstrlenW(data->wachFriendlyName))));
										i = sprintf(str, "AddFilter wachFriendlyName succeeded = %s",(wtoa(data->wachFriendlyName,lstrlenW(data->wachFriendlyName))));
										//REALMessageBoxx(REALBuildString(str, i));
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
										}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								
									
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 1 NOT succeeded", 30));
								}
	    		    			break;
			        		case 2:
	    		    			SysFreeString(bestDevice2Path);
								bestDevice2Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice2Name);
								bestDevice2Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 2 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}

										
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 NOT succeeded", 30));
								}
	    		    			break;
			        		case 3:
	        					SysFreeString(bestDevice3Path);
								bestDevice3Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice3Name);
								bestDevice3Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 3 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 3 NOT succeeded", 30));
								}
	        					break;
	        				case 4:
	    		    			SysFreeString(bestDevice4Path);
								bestDevice4Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice4Name);
								bestDevice4Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 4 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 4 NOT succeeded", 30));
								}
	    		    			break;
			        		case 5:
	        					SysFreeString(bestDevice5Path);
								bestDevice5Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice5Name);
								bestDevice5Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 5 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 5 NOT succeeded", 30));
								}
	        					break;
	        				case 6:
	    		    			SysFreeString(bestDevice6Path);
								bestDevice6Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestDevice6Name);
								bestDevice6Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pVCap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 6 succeeded", 26));
									lstrcpyW(data->wachFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pVCap, data->wachFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 6 NOT succeeded", 30));
								}
	    		    			break;
			        			
			        	}//end switch
			        	
			        }//end if (deviceLoadedSoFar) 
			        	
				}//end else

   						
	        
	    //********************************************************************
	        
	        //REALMessageBoxx(REALBuildString("VariantClear", 12));
	        VariantClear(&varName); 
	        VariantClear(&varPath); //ejt
	    	//REALMessageBoxx(REALBuildString("post VariantClear",17));
	    	//pPropBag->Release();
	    	//REALMessageBoxx(REALBuildString("post pPropBag Release",21));
	    	//pMoniker->Release();
	    	//REALMessageBoxx(REALBuildString("post pMoniker Release",21));
	} 
	
	//REALMessageBoxx(REALBuildString("we're outta here",16));  
	
	return count;
	
}

//********************************************************************************************************

int SetupInitialAudioDevice(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	
	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	int					preferredDevice = 1;
	char 				str[50];
	WCHAR 				*dummyChar = NULL;
	int 				i,ii;
	bool				deviceLoadedSoFar = false;

	i = sprintf(str, "captureInit");


	if ( 0 > (GetAudioDeviceCount() - 1) )
	{
		data->useDVAudioDevice = true;
	}
	else	
		data->useDVAudioDevice = false;

	
	//***************************************************************
	//  LOOP THRU DEVICEPATH STRINGS
	//  SEARCHING FOR FIRST AVAILABLE UNUSED SLOT
	//  IF WE DON'T GET BACK A VALUE OF 1 THRU 6
	//  IT MEANS NO SLOTS ARE OPEN
	//***************************************************************
	ii = GetFreeAudioDevicePathSlot();
	if (ii <= 0)
	{
		data->audioSlotNumber = 0;//this indicates we have no audioDevice for this control
		i = sprintf(str, "No slot found\ndata->audioSlotNumber = %d\nii = %d",data->audioSlotNumber,ii);
		REALMessageBoxx(REALBuildString(str,i));
		return ii;//exit if we didn't find an empty slot
	}
	//  set the "audioSlotNumber" (i.e. the index where we'll store the path in the globals)
	data->audioSlotNumber = ii;

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    REALMessageBoxx(REALBuildString("GetAudioDeviceName1",19));  
	    // Create an enumerator for the audio capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	    REALMessageBoxx(REALBuildString("GetAudioDeviceName2",19));  
	} 
	else
	{
		return -1;
	}

	int count = 0;
	if (pEnum != nil)
	{
	}
	else
	{
		return -1;//this happens if no devices are plugged in
	}
	

	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;

		i = sprintf(str, "count --->  %d",count);
		REALMessageBoxx(REALBuildString(str,i));
	
	    REALMessageBoxx(REALBuildString("GetaudioDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    REALMessageBoxx(REALBuildString("GetaudioDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VARIANT	varPath;
	    VariantInit(&varName);
	    VariantInit(&varPath);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        REALMessageBoxx(REALBuildString("GetaudioDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	        REALMessageBoxx(REALBuildString("GetaudioDeviceName6",19));  
	        char *strA;
	        //REALMessageBoxx(REALBuildString("GetaudioDeviceName7",19));  
	        //REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        
	        	hr = pPropBag->Read(L"DevicePath", &varPath, 0);
				//REALMessageBoxx(REALBuildString( wtoa(varPath.bstrVal,varPath.bstrVal[0]),varPath.bstrVal[0]));
	        

				//--------------------------------------------------------------------------------
	        	//
	        	//  OK, we have a devicePath
	        	//  now we need to know if it is already being used or not..
	        	//  to do so, we check each slot to see if has the same path name 
	        	//  as the device we are examining
	        	//  if it does, then the device we are looking at is already in use
	        	//  if not, we can use it... and we should choose it as the default
	        	//
	        	//--------------------------------------------------------------------------------
	        	//  fun stuff! :-(
	        	
	        	
	        	if (lstrcmpW(bestAudioDevice1Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice1Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice2Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice2Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice3Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice3Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice4Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice4Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice5Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice5Path in use", 22));
					}
				else if (lstrcmpW(bestAudioDevice6Path, varPath.bstrVal) == 0)
					{
					REALMessageBoxx(REALBuildString("bestAudioDevice6Path in use", 22));
					}
				else
					{
						
						i = sprintf(str, "deviceNumFound = %d\ndata->audioSlotNumber = %d",count,data->audioSlotNumber);
	        			REALMessageBoxx(REALBuildString(str, i));
						
						//set the flag to get us out of the while loop... blech
						//deviceFound = n;
					if (deviceLoadedSoFar==false)//this is so we load one new device each time
					{	
						//  device n is currently not in use
						//  let's use it! 
						switch (data->audioSlotNumber)
	    		    	{
	        		
			        		case 1:
			        		
				        		i = sprintf(str, "case1A");
	        					REALMessageBoxx(REALBuildString(str, i));
	        			
				        		SysFreeString(bestAudioDevice1Path);
				        		
				        		i = sprintf(str, "case1B");
	        					REALMessageBoxx(REALBuildString(str, i));
	        					
								//bestAudioDevice1Path = SysAllocString(varPath.bstrVal);
								
								i = sprintf(str, "case1C");
	        					REALMessageBoxx(REALBuildString(str, i));
	        					
								SysFreeString(bestAudioDevice1Name);
								
								i = sprintf(str, "case1D");
	        					REALMessageBoxx(REALBuildString(str, i));
	        					
								bestAudioDevice1Name = SysAllocString(varName.bstrVal);
								
								i = sprintf(str, "case1E");
	        					REALMessageBoxx(REALBuildString(str, i));
	        					
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									REALMessageBoxx(REALBuildString("Bind to object 1 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
										{
										//i = sprintf(str, "AddFilter wachAudioFriendlyName succeeded = %s",(wtoa(data->wachAudioFriendlyName,lstrlenW(data->wachAudioFriendlyName))));
										i = sprintf(str, "AddFilter wachAudioFriendlyName succeeded = %s",(wtoa(data->wachAudioFriendlyName,lstrlenW(data->wachAudioFriendlyName))));
										REALMessageBoxx(REALBuildString(str, i));
										deviceLoadedSoFar = true;
										REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
										}
									else
										{
										REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 1 NOT succeeded", 30));
								}
	    		    			break;
			        		case 2:
	    		    			SysFreeString(bestAudioDevice2Path);
								bestAudioDevice2Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice2Name);
								bestAudioDevice2Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 2 NOT succeeded", 30));
								}
	    		    			break;
			        		case 3:
	        					SysFreeString(bestAudioDevice3Path);
								bestAudioDevice3Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice3Name);
								bestAudioDevice3Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 3 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 3 NOT succeeded", 30));
								}
	        					break;
	        				case 4:
	    		    			SysFreeString(bestAudioDevice4Path);
								bestAudioDevice4Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice4Name);
								bestAudioDevice4Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 4 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 4 NOT succeeded", 30));
								}
	    		    			break;
			        		case 5:
	        					SysFreeString(bestAudioDevice5Path);
								bestAudioDevice5Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice5Name);
								bestAudioDevice5Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 5 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 5 NOT succeeded", 30));
								}
	        					break;
	        				case 6:
	    		    			SysFreeString(bestAudioDevice6Path);
								bestAudioDevice6Path = SysAllocString(varPath.bstrVal);
								SysFreeString(bestAudioDevice6Name);
								bestAudioDevice6Name = SysAllocString(varName.bstrVal);
								hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
								if (SUCCEEDED(hr))
								{
									//REALMessageBoxx(REALBuildString("Bind to object 6 succeeded", 26));
									lstrcpyW(data->wachAudioFriendlyName, varName.bstrVal);
									hr = data->pFg->AddFilter(data->pACap, data->wachAudioFriendlyName);
									if (SUCCEEDED(hr))
									{
										deviceLoadedSoFar = true;
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName succeeded", 36));
									}
									else
										{
										//REALMessageBoxx(REALBuildString("AddFilter wachAudioFriendlyName DID NOT succeeded", 44));
										}
								} // Bind to object succeeded
								else
								{
									REALMessageBoxx(REALBuildString("Bind to object 6 NOT succeeded", 30));
								}
	    		    			break;
			        			
			        	}//end switch
			        	
			        }//end if (deviceLoadedSoFar) 
			        	
				}//end else

   						
	        
	    //********************************************************************
		//hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, IID_IAMStreamConfig, (void **)&data->pASC);
          
            
			//hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, NULL, data->pMux);
          
          
          	i = sprintf(str, "%d",hr);
			REALMessageBoxx(REALBuildString(str, i));
										                                                                
	        //REALMessageBoxx(REALBuildString("VariantClear", 12));
	        VariantClear(&varName); 
	        VariantClear(&varPath); //ejt
	    	//REALMessageBoxx(REALBuildString("post VariantClear",17));
	    	//pPropBag->Release();
	    	//REALMessageBoxx(REALBuildString("post pPropBag Release",21));
	    	//pMoniker->Release();
	    	//REALMessageBoxx(REALBuildString("post pMoniker Release",21));
	} 
	
	//REALMessageBoxx(REALBuildString("we're outta here",16));  
	
	return count;
	
}

int GetFreeAudioDevicePathSlot(void)
{

	if (lstrcmpW(bestAudioDevice1Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (1);
					}
	if (lstrcmpW(bestAudioDevice2Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (2);
					}
	if (lstrcmpW(bestAudioDevice3Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (3);
					}
	if (lstrcmpW(bestAudioDevice4Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (4);
					}
	if (lstrcmpW(bestAudioDevice5Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (5);
					}
	if (lstrcmpW(bestAudioDevice6Path, bestAudioDeviceDefaultPath) == 0)
					{
					return (6);
					}
	
	return (0);
	
}




char *wtoa(wchar_t *ws, int wscnt)           
{                                               
    char *s;                                    
    int slen;                                   
                                                
    slen = MB_CUR_MAX * wscnt + 1;              
    s = (char*)malloc(sizeof(char) * slen);            
    if (wcstombs(s, ws, slen) == -1) {          
        //printf("wcstombs convert error.\n");
        free(s);                                
        return NULL;                            
    }                                           
    return s;                                   
} 

wchar_t *atow(char *s, int *wscnt)
{                                               

	int i;
	char 				str[50];
		
	i = sprintf(str, "atow1");
	//REALMessageBoxx(REALBuildString(str, i));

    wchar_t *ws;                                
    int wslen, wcnt;                            
                                                
    wslen = strlen(s) + 1;                  
    
    i = sprintf(str, "atow2");
	//REALMessageBoxx(REALBuildString(str, i));
	    
    ws = (wchar_t*)malloc(sizeof(wchar_t) * wslen);       
    if ((wcnt = mbstowcs(ws, s, wslen)) == -1) {
    	i = sprintf(str, "mbstowcs convert error");
		//REALMessageBoxx(REALBuildString(str, i));
        //printf("mbstowcs convert error.\n");
        free(ws);                               
        return NULL;                            
    }                                           
	
	i = sprintf(str, "post if");
	//REALMessageBoxx(REALBuildString(str, i));

	//this next line causes a crash for some reason
	//oh well, we're not using the length of the string anyway, 
	//so we removed it just to get by for now (EJT 31 MAR 2004)
    //*wscnt = wcnt;                              
    return ws;                                  
}
 

//********************************************************************************************************

// helper function

BOOL IsDeviceOutputDV(IBaseFilter * pFilter) 
{
    if (!pFilter) return FALSE;

    IEnumPins *pEnum = 0;
    IPin *pPin = 0;
    ULONG            ul ;
    BOOL bFound = FALSE;

    HRESULT hr = pFilter->EnumPins(&pEnum);
    if (FAILED(hr)) return FALSE;

    while (S_OK == pEnum->Next(1, &pPin, 0))
    {
        // See if this pin matches the specified direction.
        PIN_DIRECTION ThisPinDir;
        hr = pPin->QueryDirection(&ThisPinDir);
        if (FAILED(hr))        {
            SAFE_RELEASE(pPin);
            break;
        }

        if (ThisPinDir == PINDIR_OUTPUT)
        {
            IEnumMediaTypes* pTypeEnum;
            hr = pPin->EnumMediaTypes (&pTypeEnum);

            AM_MEDIA_TYPE* pMediaType;
            // Loop thru' media type list for a match
            do {
                hr = pTypeEnum->Next(1, &pMediaType, &ul) ;
                if (FAILED(hr) || 0 == ul) {
                    SAFE_RELEASE(pPin);
                    break ;
                }
        
                if (pMediaType->subtype == MEDIASUBTYPE_dvsd  ||
                    pMediaType->subtype == MEDIASUBTYPE_DVSD) {  
                    bFound = TRUE;
                    SAFE_RELEASE(pPin);
                    MyDeleteMediaType( pMediaType );
                
                    pTypeEnum->Release();
                    SAFE_RELEASE(pEnum);

                    return TRUE;
                }
                
                MyDeleteMediaType( pMediaType );

            } while (!bFound) ;  // until the reqd one is found

            pTypeEnum->Release();                      
        } 
    }

    SAFE_RELEASE(pPin);
    SAFE_RELEASE(pEnum);

    // Did not find a matching filter.
    return FALSE;
}

void MyDeleteMediaType(AM_MEDIA_TYPE *pmt)
{
    if (pmt != NULL)
    {
        MyFreeMediaType(*pmt); // See FreeMediaType for the implementation.
        CoTaskMemFree(pmt);
    }
}


void MyFreeMediaType(AM_MEDIA_TYPE& mt)
{
    if (mt.cbFormat != 0)
    {
        CoTaskMemFree((PVOID)mt.pbFormat);
        mt.cbFormat = 0;
        mt.pbFormat = NULL;
    }
    if (mt.pUnk != NULL)
    {
        // Unecessary because pUnk should not be used, but safest.
        mt.pUnk->Release();
        mt.pUnk = NULL;
    }
}


int GetAudioDeviceCount(void)
{
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;
	
	int i;
	char 				str[50];
		
	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetAudioDevices = gut",21));  
	    // Create an enumerator for the audio capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	} 
	else
	{
		////REALMessageBoxx(REALBuildString("GetAudioDevices = -1",20));  
		return -1;
	}
	
	int count = 0;
	IMoniker *pMoniker = NULL;
	
	if (pEnum != nil)
	{
	}
	else
	{
		return -1;//this happens if no devices are plugged in
	}
	
	while ( (pEnum != nil) && (pEnum->Next(1, &pMoniker, NULL) == S_OK) )
	{
	    count++;
	} 
		
	i = sprintf(str, "GetAudioDeviceCount = %d",count);
	REALMessageBoxx(REALBuildString(str, i));
	
	return count;
}

int GetDVAudioCount(REALcontrolInstance instance)
{
	//if (IsDeviceOutputDV(data->pVCap) )
	//	REALMessageBoxx(REALBuildString("dev1=dv!", 8));
	//else
	//	REALMessageBoxx(REALBuildString("dev1!=dv!", 9));
										
	ControlData(captureControl, instance, captureData, data);

    char 				*strA;
	IBaseFilter 		*tempACap;
	ICreateDevEnum 		*pDevEnum = NULL;
	IEnumMoniker 		*pEnum = NULL;
	VARIANT 			varName;
	    
	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetAudioDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,
	        &pEnum, 0);
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName2",19));  
	} 
	else
	{
		return -1;
	}

	int count=0;
	int dvcount = 0;
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName4",19));  
	    // Find the description or friendly name.

	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetAudioDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
			hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&tempACap);
			if (SUCCEEDED(hr))
			{
					
				if (IsDeviceOutputDV(tempACap) )
				dvcount++;
				/*
			    lstrcpyW(data->wachFriendlyName, varName.bstrVal);
			    	hr = data->pFg->AddFilter(data->pACap, data->wachFriendlyName);
			    	if (SUCCEEDED(hr))
			    		{
			    			////REALMessageBoxx(REALBuildString("pACap YES",9));  
			    		}
			    	else
			    		{
			    			////REALMessageBoxx(REALBuildString("pACap NO",8));  
			    		}
			    */
			} 
				

	        //********************************************************************
	        
	      }//succeeded
	        
	        VariantClear(&varName); 
	    }
	    //pPropBag->Release();
	    pMoniker->Release();
	    tempACap->Release();//needed?
	    
	//} 
	return dvcount;
}

int GetAudioDeviceName(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetAudioDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName2",19));  
	} 
	else
	{
		return -1;
	}

	int count = 0;
	HWND hList; // Handle to the list box.
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    ////REALMessageBoxx(REALBuildString("GetAudioDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetAudioDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetAudioDeviceName6",19));  
	        // Add it to the application's list box.
	        //USES_CONVERSION;
	        //(long)SendMessage(hList, LB_ADDSTRING, 0, 
	        //    (LPARAM)OLE2T(varName.bstrVal));
	        char *strA;
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        ////REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        
	        	        
	        //******************************************************************************
	        //     this is where you choose a device to use... 
	        //     we're gonna use the #1 = soundcard(?) or #2 = quickCam for test purposes
	        //******************************************************************************
	        
	        if (count==2)
	        {
	        	//IBaseFilter *pCap = NULL;
				hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&data->pACap);
				if (SUCCEEDED(hr))
				{
				    ////REALMessageBoxx(REALBuildString("pVCap1",6));  
				    //pVCap
				    //hr = m_pGraph->AddFilter(pCap, L"Capture Filter");
				    //hr = data->pVCap->AddFilter(pCap, L"Capture Filter");
				    lstrcpyW(data->wachFriendlyName, varName.bstrVal);
				    //if (!data->pACap)
				    //{
				    	hr = data->pFg->AddFilter(data->pACap, data->wachFriendlyName);
				    	if (SUCCEEDED(hr))
				    		{
				    			////REALMessageBoxx(REALBuildString("pACap YES",9));  
				    		}
				    	else
				    		{
				    			////REALMessageBoxx(REALBuildString("pACap NO",8));  
				    		}
				    //}
				} 
				
			}
	        //********************************************************************
	        
	      }//succeeded
	        
	        VariantClear(&varName); 
	    }
	    //pPropBag->Release();
	    pMoniker->Release();
	    
	//} 
	return count;
}


REALstring GetAudioDeviceNameByIndex(int theIndex)
{
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;
	REALstring theName = REALBuildString("Unknown",7);
	

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetVideoDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_AudioInputDeviceCategory,
	        &pEnum, 0);
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName2",19));  
	} 
	else
	{
		return theName;
	}

	int count = 0;
	HWND hList; // Handle to the list box.
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName6",19));  
	        char *strA;
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        ////REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        if (count == theIndex)
	        	theName = REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
	        
	        VariantClear(&varName); 
	    }
	    
	    pPropBag->Release();
	    pMoniker->Release();
	    
	} 
	return theName;
}

REALstring GetVideoDeviceNameByIndex(int theIndex)
{
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;
	REALstring theName = REALBuildString("Unknown",7);
	

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetVideoDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,
	        &pEnum, 0);
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName2",19));  
	} 
	else
	{
		return theName;
	}

	int count = 0;
	HWND hList; // Handle to the list box.
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VariantInit(&varName);
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName6",19));  
	        char *strA;
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        ////REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        if (count == theIndex)
	        	theName = REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
	        
	        VariantClear(&varName); 
	    }
	    
	    pPropBag->Release();
	    pMoniker->Release();
	    
	} 
	return theName;
}


REALstring GetVideoDevicePathByIndex(int theIndex)
{
	
	ICreateDevEnum *pDevEnum = NULL;
	IEnumMoniker *pEnum = NULL;
	REALstring theName = REALBuildString("Unknown",7);
	

	// Create the System Device Enumerator.
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL,
	    CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, 
	    reinterpret_cast<void**>(&pDevEnum));
	if (SUCCEEDED(hr))
	{
	    //REALMessageBoxx(REALBuildString("GetVideoDeviceName1",19));  
	    // Create an enumerator for the video capture category.
	    hr = pDevEnum->CreateClassEnumerator(
	        CLSID_VideoInputDeviceCategory,
	        &pEnum, 0);
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName2",19));  
	} 
	else
	{
		return theName;
	}

	int count = 0;
	HWND hList; // Handle to the list box.
	IMoniker *pMoniker = NULL;
	while (pEnum->Next(1, &pMoniker, NULL) == S_OK)
	{
	    count++;
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName3",19));  
	    IPropertyBag *pPropBag;
	    hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
	        (void**)(&pPropBag));
	    if (FAILED(hr))
	    {
	        pMoniker->Release();
	        continue;  // Skip this one, maybe the next one will work.
	    } 
	    ////REALMessageBoxx(REALBuildString("GetVideoDeviceName4",19));  
	    // Find the description or friendly name.
	    VARIANT varName;
	    VARIANT varPath;
	    VariantInit(&varName);
	    VariantInit(&varPath);
	    
	    hr = pPropBag->Read(L"Description", &varName, 0);
	    if (FAILED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName5",19));  
	        hr = pPropBag->Read(L"FriendlyName", &varName, 0);
	    }
	    if (SUCCEEDED(hr))
	    {
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName6",19));  
	        char *strA;
	        ////REALMessageBoxx(REALBuildString("GetVideoDeviceName7",19));  
	        ////REALMessageBoxx(REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]));
	        if (count == theIndex)
	        	{
	        		//************************************************************
				    //hr = pPropBag->Read(L"DevicePath", &varPath, 0);
				    
				    hr = pPropBag->Read(L"DevicePath", &varPath, 0);
	        		//theName = REALBuildString( wtoa(varName.bstrVal,varName.bstrVal[0]),varName.bstrVal[0]);
	        		theName = REALBuildString( wtoa(varPath.bstrVal,varPath.bstrVal[0]),varPath.bstrVal[0]);
	        	}
	        
	        VariantClear(&varName); 
	        VariantClear(&varPath); 
	    }
	    
	    
	    
				
	    
	    pPropBag->Release();
	    pMoniker->Release();
	    
	} 
	return theName;
}


// Make a graph object we can use for capture graph building
//
BOOL MakeGraph(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
    //********************************************************//
	// Create the Capture Graph Builder.
    //********************************************************//

    if(data->pBuilder)
    {
        // we have one already
    	//REALMessageBoxx(REALBuildString("MakeGraph (data->pBuilder) = TRUE",27));  
        //return TRUE;
	}
	else
	{
		//nope, so create one
		//REALMessageBoxx(REALBuildString("MakeGraph (data->pBuilder) = FALSE",28));  
		hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER,
                                  IID_ICaptureGraphBuilder2, (LPVOID *)&data->pBuilder);
	}
	
	if (SUCCEEDED(hr))
    {
    	//REALMessageBoxx(REALBuildString("Create the Capture Graph Builder = SUCCESS",42));  
        //********************************************************//
		// Create the Filter Graph.
	    //********************************************************//
    
	    if(data->pFg)
	    {
	        // we have one already
	   		//REALMessageBoxx(REALBuildString("MakeGraph (data->pFg) = TRUE",27));  
	        //return TRUE;
		}
		else
		{
			//nope, so create one
			//REALMessageBoxx(REALBuildString("MakeGraph (data->pFg) = FALSE",28));  
			hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
	                                  IID_IGraphBuilder, (LPVOID *)&data->pFg);
		}
	
	    //********************************************************//
		// Set the Filter Graph of the Graph Builder.
	    //********************************************************//
		if (SUCCEEDED(hr))
        {
            // Initialize the Capture Graph Builder.
            data->pBuilder->SetFiltergraph(data->pFg);
			////REALMessageBoxx(REALBuildString("post-setFilterGraph",19));  
			
            // Return both interface pointers to the caller.
            //*ppBuild = pBuild;
            //*ppGraph = pGraph; // The caller must release both interfaces.
            return TRUE;//S_OK;
		}
        else
        {
            //REALMessageBoxx(REALBuildString("CoCreateInstance err",20));  
            data->pBuilder->Release();
            data->pBuilder = NULL;
        }
		
    }
    else
    {
    	//REALMessageBoxx(REALBuildString("Create the Capture Graph Builder = ERR    ",42));  
    }
    


    return (hr == NOERROR) ? TRUE : FALSE;
}


// Tear down everything downstream of a given filter
void NukeDownstream(REALcontrolInstance instance, IBaseFilter *pf, BOOL releaseFilters)
{
    
    ControlData(captureControl, instance, captureData, data);

    IPin *pP=0, *pTo=0;
    ULONG u;
    IEnumPins *pins = NULL;
    PIN_INFO pininfo;

    if (!pf)
        return;

    HRESULT hr = pf->EnumPins(&pins);
    pins->Reset();

    while(hr == NOERROR)
    {
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
        {
            pP->ConnectedTo(&pTo);
            if(pTo)
            {
                hr = pTo->QueryPinInfo(&pininfo);
                if(hr == NOERROR)
                {
                    if(pininfo.dir == PINDIR_INPUT)
                    {
                        NukeDownstream(instance, pininfo.pFilter, releaseFilters);
                        data->pFg->Disconnect(pTo);
                        data->pFg->Disconnect(pP);
                        if (releaseFilters)
                        	data->pFg->RemoveFilter(pininfo.pFilter);
                    }
                    if (releaseFilters)
                    	pininfo.pFilter->Release();
                }
                pTo->Release();
            }
            pP->Release();
        }
    }

    if(pins)
        pins->Release();
}


// Tear down everything downstream of the capture filters, so we can build
// a different capture graph.  Notice that we never destroy the capture filters
// and WDM filters upstream of them, because then all the capture settings
// we've set would be lost.
//
void TearDownGraph(REALcontrolInstance instance)
{
    
    ControlData(captureControl, instance, captureData, data);
    

//
    if(data->pVW)
    {
        // stop drawing in our window, or we may get wierd repaint effects
        data->pVW->put_Owner(NULL);
        data->pVW->put_Visible(0);//OAFALSE);
        data->pVW->Release();
        data->pVW = NULL;
        //REALMessageBoxx(REALBuildString("TEARDOWN 1",10));  
    }

    // destroy the graph downstream of our capture filters
    if(data->pVCap)
        {
        NukeDownstream(instance, data->pVCap, true);
        //REALMessageBoxx(REALBuildString("TEARDOWN 2",10));  
        }
    if(data->pACap)
    	{
        NukeDownstream(instance, data->pACap, true);
       	//REALMessageBoxx(REALBuildString("TEARDOWN 3",10));  
      	}
    //if(data->pVCap)
    //    data->pBuilder->ReleaseFilters();

    // potential debug output - what the graph looks like
    // if (data->pFg) DumpGraph(data->pFg, 1);

#ifdef REGISTER_FILTERGRAPH
    // Remove filter graph from the running object table   
    if(g_dwGraphRegister)
    {
        RemoveGraphFromRot(g_dwGraphRegister);
        g_dwGraphRegister = 0;
    }
#endif

    //data->fCaptureGraphBuilt = FALSE;
    data->fPreviewing = FALSE;
    //data->fPreviewFaked = FALSE;
    
    SAFE_RELEASE(data->pConfigAviMux);
    SAFE_RELEASE(data->pRender);
    SAFE_RELEASE(data->pME);
    
    
}


// Make a graph builder object we can use for capture graph building
//
BOOL MakeBuilder(REALcontrolInstance instance)
{

	ControlData(captureControl, instance, captureData, data);
	
    //********************************************************//
	// Create the Capture Graph Builder.
    //********************************************************//

    // we have one already
    if(data->pBuilder)
    {
        //REALMessageBoxx(REALBuildString("MakeGraph (data->pBuilder) = TRUE",27));  
        return TRUE;
	}
	else
	{
		//REALMessageBoxx(REALBuildString("MakeGraph (data->pBuilder) = FALSE",28));  
	}
	
	// we have one already
	    if(data->pFg)
	    {
	        //REALMessageBoxx(REALBuildString("MakeGraph (data->pFg) = TRUE",27));  
	        return TRUE;
		}
		else
		{
			//REALMessageBoxx(REALBuildString("MakeGraph (data->pFg) = FALSE",28));  
	}
    HRESULT hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
	                                  IID_IGraphBuilder, (LPVOID *)&data->pFg);


	if (SUCCEEDED(hr))
    {
    	//REALMessageBoxx(REALBuildString("Create the Capture Graph Builder = SUCCESS",42));  
        //********************************************************//
		// Create the Filter Graph Manager.
	    //********************************************************//
    
	    
	
	    //HRESULT 
		hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER,
                                  IID_ICaptureGraphBuilder2, (LPVOID *)&data->pBuilder);
                                  
		if (SUCCEEDED(hr))
        {
            // Initialize the Capture Graph Builder.
            //pBuild->SetFiltergraph(pGraph);
            //REALMessageBoxx(REALBuildString("pre-setFilterGraph",18));  
            data->pBuilder->SetFiltergraph(data->pFg);
			////REALMessageBoxx(REALBuildString("post-setFilterGraph",19));  
			
            // Return both interface pointers to the caller.
            //*ppBuild = pBuild;
            //*ppGraph = pGraph; // The caller must release both interfaces.
            
            //wyh are we returning S_OK here... it's throwing an error, so we'll return true for jollies
            return S_OK;
            //return true;
        }
        else
        {
            ////REALMessageBoxx(REALBuildString("CoCreateInstance err",20));  
            data->pBuilder->Release();
        }
		
    }
    else
    {
    	////REALMessageBoxx(REALBuildString("Create the Capture Graph Builder = ERR    ",42));  
    }
    


    return (hr == NOERROR) ? TRUE : FALSE;    
}







// build the capture graph
//
BOOL BuildCaptureGraph(REALcontrolInstance instance)
{
    //USES_CONVERSION;
    ControlData(captureControl, instance, captureData, data);
    
    int cy, cyBorder;
    HRESULT hr=0;
    BOOL f;
    AM_MEDIA_TYPE *pmt=0;

    // we have one already
    //if(data->fCaptureGraphBuilt)
    //    return TRUE;

    // No rebuilding while we're running
    //if(data->fCapturing || data->previewState)
    //    return FALSE;

    // We don't have the necessary capture filters
    if(data->pVCap == NULL)
        return FALSE;
    //if(data->pACap == NULL && data->fCapAudio)
    //    return FALSE;

    // no capture file name yet... we need one first
    //if(data->szCaptureFile[0] == 0)
    //{
    //    f = SetCaptureFile(instance, ghwndApp);
    //    if(!f)
    //        return f;
    //}

    // we already have another graph built... tear down the old one
    //if(data->fPreviewGraphBuilt)
    //    TearDownGraph(instance);

    //
    // We need a rendering section that will write the capture file out in AVI
    // file format
    //

    GUID guid;
    if( data->fMPEG2 )
    {
        guid = MEDIASUBTYPE_Avi;//MEDIASUBTYPE_Mpeg2;
    }
    else
    {
        guid = MEDIASUBTYPE_Avi;
    }


    //
    // Get the preview window to be a child of our app's window
    //

    // This will find the IVideoWindow interface on the renderer.  It is 
    // important to ask the filtergraph for this interface... do NOT use
    // ICaptureGraphBuilder2::FindInterface, because the filtergraph needs to
    // know we own the window so it can give us display changed messages, etc.

    if(!data->fMPEG2 && data->previewWhileRecording)
    {
        hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
        if(hr != NOERROR && data->previewWhileRecording)
        {
            //REALMessageBoxx(REALBuildString("BuildCaptureGraph7",18));  
            //ErrMsg(TEXT("This graph cannot preview"));
        }
        else if(hr == NOERROR)
        {
            RECT rc;
            data->pVW->put_Owner((OAHWND)data->ghwndApp);    // We own the window now
            data->pVW->put_WindowStyle(WS_CHILD);    // you are now a child

            // give the preview window all our space but where the status bar is
            GetClientRect(data->ghwndApp, &rc);
            cyBorder = GetSystemMetrics(SM_CYBORDER);
            //cy = statusGetHeight() + cyBorder;
            cy = 240 + cyBorder;
            rc.bottom -= cy;

            data->pVW->SetWindowPosition(0, 0, rc.right, rc.bottom); // be this big
            //data->pVW->put_Visible(OATRUE);
            
            
            //*******************************************
            //REALMessageBoxx(REALBuildString("BuildCaptureGraph7",18));
            // EJT ADDED PREVIEW RESIZER
            //RECT rc;
        	data->pVW->put_Owner((OAHWND)data->ghwndApp);    // We own the window now
        	data->pVW->put_WindowStyle(WS_CHILD);    // you are now a child
			// give the preview window all our space but where the status bar is
        	GetClientRect(data->ghwndApp, &rc);
        	cyBorder = GetSystemMetrics(SM_CYBORDER);
        	cy = statusGetHeight() + cyBorder;// + 50;//size tests
        	rc.bottom -= cy;
        	//ControlData(captureControl, instance, captureData, data);
			::Rect	r;
			REALGetControlBounds(instance, &r);
			data->theSGBounds.left = r.left;
			data->theSGBounds.top = r.top;
			data->theSGBounds.right = r.right;
			data->theSGBounds.bottom = r.bottom;
			data->pVW->SetWindowPosition(0, r.top, rc.right, rc.bottom); // be this big
            // END EJT ADDED PREVIEW RESIZER
        	//*******************************************
        
        
        }
    }


REALMessageBoxx(REALBuildString("BuildCaptureGr6 IN",21));  
    // now tell it what frame rate to capture at.  Just find the format it
    // is capturing with, and leave everything alone but change the frame rate
    if( !data->fMPEG2 )
    {
        REALMessageBoxx(REALBuildString("BuildCaptureGr7 IN",21));  
        hr = data->fUseFrameRate ? E_FAIL : NOERROR;
        if(data->pVSC && data->fUseFrameRate)
        {
            REALMessageBoxx(REALBuildString("BuildCaptureGr8 IN",21));  
            hr = data->pVSC->GetFormat(&pmt);

            // DV capture does not use a VIDEOINFOHEADER
            if(hr == NOERROR)
            {
                REALMessageBoxx(REALBuildString("BuildCaptureG8 OUT",18));  
                if(pmt->formattype == FORMAT_VideoInfo)
                {
                    REALMessageBoxx(REALBuildString("BuildCapture8 out2",18));  
                    VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pmt->pbFormat;
                    pvi->AvgTimePerFrame = (LONGLONG)(10000000 / data->FrameRate);
                    hr = data->pVSC->SetFormat(pmt);
                }
                //DeleteMediaType(pmt);
            }
        }
        if(hr != NOERROR)
            {
            ////REALMessageBoxx(REALBuildString("BuildCaptureGraph8",18));  
            //ErrMsg(TEXT("Cannot set frame rate for capture"));
            }
    }

    // now ask the filtergraph to tell us when something is completed or aborted
    // (EC_COMPLETE, EC_USERABORT, EC_ERRORABORT).  This is how we will find out
    // if the disk gets full while capturing
    hr = data->pFg->QueryInterface(IID_IMediaEventEx, (void **)&data->pME);
    if(hr == NOERROR)
    {
        //data->pME->SetNotifyWindow((OAHWND)ghwndApp, WM_FGNOTIFY, 0);
    }

    // potential debug output - what the graph looks like
    // DumpGraph(data->pFg, 1);

    // Add our graph to the running object table, which will allow
    // the GraphEdit application to "spy" on our graph
#ifdef REGISTER_FILTERGRAPH
    hr = AddGraphToRot(data->pFg, &g_dwGraphRegister);
    if(FAILED(hr))
    {
        //REALMessageBoxx(REALBuildString("BuildCaptureGraph9",18));  
        //ErrMsg(TEXT("Failed to register filter graph with ROT!  hr=0x%x"), hr);
        g_dwGraphRegister = 0;
    }
#endif

    // All done.
    
    //data->fCaptureGraphBuilt = TRUE;
    return TRUE;

SetupCaptureFail:
    //TearDownGraph(instance);
    return FALSE;
}





// stop the preview graph
//
BOOL StopPreview(REALcontrolInstance instance)
{
    //REALMessageBoxx(REALBuildString("STOP PREVIEW",12));  
    
    ControlData(captureControl, instance, captureData, data);
    
    ////REALMessageBoxx(REALBuildString("STOP 1",6));  
    
    // way ahead of you
    //if(!data->previewState)
    //{
    //    return FALSE;
    //}

	////REALMessageBoxx(REALBuildString("STOP 2",6));  
	
    // stop the graph
    IMediaControl *pMC = NULL;
    HRESULT hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
    if(SUCCEEDED(hr))
    {
        ////REALMessageBoxx(REALBuildString("STOP 3",6));  
        hr = pMC->Stop();
        ////REALMessageBoxx(REALBuildString("STOP 3A",7));  
        pMC->Release();
        ////REALMessageBoxx(REALBuildString("STOP 3B",7));  
    }
    if(FAILED(hr))
    {
        ////REALMessageBoxx(REALBuildString("STOP 4",6));  
        //ErrMsg(TEXT("Error %x: Cannot stop preview graph"), hr);
        return FALSE;
    }

    //REALMessageBoxx(REALBuildString("STOPSTOP1",9));  
    data->previewState = FALSE;
	
	////REALMessageBoxx(REALBuildString("STOP pre5",9));  
	
    // get rid of menu garbage
    //InvalidateRect(ghwndApp, NULL, TRUE);
	
	////REALMessageBoxx(REALBuildString("STOP 5",6));  

    return TRUE;
}




//****************************************************************************************
//
//     	start the capture graph
//
//		POSSIBLE VIDEO SCENARIOS:
//		V1. plain jane video [e.g. QuickCam]
//		V2. DV video [e.g. MiniDV]
//		V3. no video
//
//
//		POSSIBLE AUDIO SCENARIOS:
//		A1. plain jane audio [e.g. QuickCam microphone, soundcard, etc]
//		A2. DV audio [e.g. same MiniDV as above in VIDEO SCENARIOS]
//		A3. DV audio [e.g. different MiniDV than above in VIDEO SCENARIOS; ]
//					 [in fact, DV connection may not exist yet, since DV may not be video src]
//		A4. no audio
//
//****************************************************************************************


// start the capture graph
//
BOOL StartCapture(REALcontrolInstance instance, REALfolderItem theMovieFile)
{
    ControlData(captureControl, instance, captureData, data);
    
	int 				*theLen = 0;
	int 				i, n;
	wchar_t 			*wx;
	char 				*ax;
    char 				str[512];
    BOOL 				f;
    HRESULT 			hr;
	BOOL				videoIsDV = false;
	BOOL				audioIsDV = false;
	::Rect				r;
	long 				displayWidth, 
						naturalWidth, 
						displayHeight, 
						naturalHeight;
	IPin 				*pACapPin = NULL;
	IPin 				*pInfInPin = NULL;
	IFileSinkFilter2 	*pFileSink=NULL;
	IBaseFilter 		*pF = 0;
	IBaseFilter 		*pDVSplitter = 0;
	IMediaControl 		*pMC = NULL;
	IPin 				*pPin1;
    IPin 				*pPin2;
    
	//*******************************************************************
	//
	//  get a ref to the control	
    //
    //*******************************************************************
    hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
    if(FAILED(hr))
    {
        i = sprintf(str, "can't find the control");
        REALMessageBoxx(REALBuildString(str,i));
        return FALSE;
    }
    else
    {
    	//*******************************************************************
    	//  found the control... 
    	//  let's stop it before we start mucking with the graph
    	//*******************************************************************
    	hr = pMC->Stop();
    	if(FAILED(hr))
    	{
    		i = sprintf(str, "can't stop for some reason");
    	}
    	else
    	{
    		i = sprintf(str, "found control stopped it");
    	}
    	REALMessageBoxx(REALBuildString(str,i));
    	
    }


	//*******************************************************************
	//
	//  set up previewWhileRecording
	//
	//*******************************************************************
	if ( (data->previewWhileRecording) && (data->enableSound) )
	{
		
 		i = sprintf(str, "*** set up previewWhileRecording ***\n*** set up previewWhileRecording ***\n*** set up previewWhileRecording ***");
		REALMessageBoxx(REALBuildString(str,i));
			
		//captureSetPreviewState(instance, 0, false);
		//captureSetPreviewState(instance, 0, true);


		//*************************************************************************************
		//	render audio preview
		//*************************************************************************************
		//do we have an inf tee?
		if (data->pInfTee)
		{
		//do nada
		}
		else
		{
			if (data->previewState == true)
				CreateAudioInfiniteTee(instance);
		}
	
		//do we have audioRender?	
		if (data->pAudioRender)
		{
		//do nada
			i = sprintf(str, "we found data->pAudioRender");
			REALMessageBoxx(REALBuildString(str,i));
		}
		else
		{
			i = sprintf(str, "creating data->pAudioRender");
			REALMessageBoxx(REALBuildString(str,i));
			
			if (data->previewState == true)
				{
				i = sprintf(str, "StartCapture CreateAudioPreviewRender");
				REALMessageBoxx(REALBuildString(str,i));
				CreateAudioPreviewRender(instance);
				}
		}
				
			//render the preview audio 
			if ( (data->pACap) && (data->pInfTee) && (data->pAudioRender) )
			{
				i = sprintf(str, "rendering previewAudio");
				REALMessageBoxx(REALBuildString(str,i));
				
				hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, data->pACap, data->pInfTee, data->pAudioRender);
				if(hr == NOERROR)
				{
					i = sprintf(str, "RenderStream audio preview hr = %d",hr);
				}
				else
				{
					i = sprintf(str, "1. RenderStream audio preview err hr = %d",hr);
				}
				REALMessageBoxx(REALBuildString(str,i));
			}

	}
	else//if !(data->previewWhileRecording)
	{
		//captureSetPreviewState(instance, 0, false);
		i = sprintf(str, "no preview while recording");
		REALMessageBoxx(REALBuildString(str,i));
			
		NukeDownstream(instance, data->pSmartTee, true);
		data->pFg->RemoveFilter(data->pSmartTee);
	}//END  set up previewWhileRecording


	i = sprintf(str, "pre -- Add the Mux and FileWriter filters");
	REALMessageBoxx(REALBuildString(str,i));
		
	//*******************************************************************
	//
	//  Add the Mux and FileWriter filters - used by all scenarios
	//
	//*******************************************************************
	hr = AddFilterByCLSID(data->pFg, CLSID_AviDest, L"My AVI Mux", &data->pMux);
	if (SUCCEEDED(hr))
	{
    	hr = AddFilterByCLSID(data->pFg, CLSID_FileWriter, L"My File Writer", &data->pWrite);
    	if (SUCCEEDED(hr))
    	{
			hr = data->pWrite->QueryInterface(IID_IFileSinkFilter2, (void **)&pFileSink);
			i = sprintf(str, "pWrite->QueryInterface hr value = %d",hr);
			REALMessageBoxx(REALBuildString(str,i));

			//ax ==> an ASCII string
			//wx ==> a wide string

    	    //turn the folderitem into a path
    	    ax = (char*)REALCString(REALpathFromFolderItem(theMovieFile));	  
    	    //convert the path from ascii to a wide string
    	    wx = atow(ax,theLen);
    	    //assign this path to the file writing part of the graph
    	    hr = pFileSink->SetFileName(wx,NULL);
			i = sprintf(str, "SetFileName hr value = %d",hr);
			REALMessageBoxx(REALBuildString(str,i));
    	}
    	else
    	{
    		i = sprintf(str, "can't add filewriter filter");
    	}
    
	}
	else
	{
		i = sprintf(str, "can't add avimux filter");
		return false;
	}
	REALMessageBoxx(REALBuildString(str,i));

	i = sprintf(str, "post -- Add the Mux and FileWriter filters");
	REALMessageBoxx(REALBuildString(str,i));

	//*******************************************************************
	//
	//  figure out the video and audio scenarios 
	//  that we're recording/previewing
	//
	//*******************************************************************
	videoIsDV = IsDeviceOutputDV(data->pVCap);
	
	
	
	

//*******************************************************************
//*******************************************************************	
//*******************************************************************
//*******************************************************************
//
//  SCENARIO V1. plain Jane video (e.g. QuickCam video)
//
//*******************************************************************
//*******************************************************************
//*******************************************************************
//*******************************************************************
if ((videoIsDV == false) && (data->enableVideo == true))
{
		i = sprintf(str, "SCENARIO V1. plain Jane video");
		REALMessageBoxx(REALBuildString(str,i));
	
		hr = data->pFg->FindFilterByName(L"Smart Tee", &data->pSmartTee);
			if (hr == S_OK)
			{
				i = sprintf(str, "found smart tee");
				REALMessageBoxx(REALBuildString(str,i));
			}
			else
			{
				//i = sprintf(str, "problem finding Tee = %d",hr);
				//hr = S_OK;//AddFilterByCLSID(data->pFg, CLSID_SmartTee, L"Smart Tee", &data->pSmartTee);
				if (data->previewWhileRecording)//(hr == S_OK)//
				{
					i = sprintf(str, "problem finding tee so we made a new one");
					hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Stream, data->pVCap, NULL, data->pRender); // try MPEG first
					if(FAILED(hr))//123
					{
						//i = sprintf(str, "RenderStream failed with MEDIATYPE_Stream = %d",hr);
						//REALMessageBoxx(REALBuildString(str,i));
						REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Stream",41));
						hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Interleaved, data->pVCap, NULL, data->pRender); // try interleaved next
						if(FAILED(hr))//456
						{
							//i = sprintf(str, "RenderStream failed with MEDIATYPE_Interleaved = %d",hr);
							//REALMessageBoxx(REALBuildString(str,i));
							REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Interleaved",46));
							hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, data->pVCap, NULL, data->pRender); // try video last
							if(FAILED(hr))//789
								{
									//i = sprintf(str, "RenderStream failed with MEDIATYPE_Video = %d",hr);
									//REALMessageBoxx(REALBuildString(str,i));
									REALMessageBoxx(REALBuildString("RenderStream failed with MEDIATYPE_Video",46));
								}//if(FAILED(hr))//789
						}//if(FAILED(hr))//456
					}//if(FAILED(hr))//123

				}
				else
				{
					//add a smart tee for when we have no previewWhileRecording (which auto creates via renderstream above)
					hr = AddFilterByCLSID(data->pFg, CLSID_SmartTee, L"Smart Tee", &data->pSmartTee);
					/*
					if(FAILED(hr))
					{}
					else
					{
						hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Stream, data->pVCap, NULL, data->pRender); // try MPEG first
						if(FAILED(hr))//123
						{
							//i = sprintf(str, "RenderStream failed with MEDIATYPE_Stream = %d",hr);
							//REALMessageBoxx(REALBuildString(str,i));
							REALMessageBoxx(REALBuildString("XenderStream failed with MEDIATYPE_Stream",41));
							hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, NULL, data->pRender); // try interleaved next
							if(FAILED(hr))//456
							{
								//i = sprintf(str, "RenderStream failed with MEDIATYPE_Interleaved = %d",hr);
								//REALMessageBoxx(REALBuildString(str,i));
								REALMessageBoxx(REALBuildString("XenderStream failed with MEDIATYPE_Interleaved",46));
								hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, NULL, data->pRender); // try video last
								if(FAILED(hr))//789
									{
										//i = sprintf(str, "RenderStream failed with MEDIATYPE_Video = %d",hr);
										//REALMessageBoxx(REALBuildString(str,i));
										REALMessageBoxx(REALBuildString("XenderStream failed with MEDIATYPE_Video",46));
									}//if(FAILED(hr))//789
							}//if(FAILED(hr))//456
						}//if(FAILED(hr))//123
					}
					*/
					
					//connect the device to the smart tee for the previewless capture
					hr = ConnectFilters(data->pFg, data->pVCap, data->pSmartTee);
					if (hr == S_OK)
						{
						i = sprintf(str, "connected pVCap to pSmartTee!");
						}
					else
						{
						//i = sprintf(str, "problem connecting pSmartTee to pMux! = %d : %s",hr,DXGetErrorString9(hr));
						i = sprintf(str, "problem connecting pVCap to pSmartTee! = %d",hr);
						//return hr;
						}
					REALMessageBoxx(REALBuildString(str,i));
			
					hr = 262782;
					//hr = pMC->Run();
					//return true;
				}//if (data->previewWhileRecording)
				
				REALMessageBoxx(REALBuildString(str,i));
				
				//**************************************
				
				if ( hr == 262782 )//VFW_S_NOPREVIEWPIN
		  		{
		  			REALMessageBoxx(REALBuildString(str,i));
					hr = data->pFg->FindFilterByName(L"Smart Tee", &data->pSmartTee);
					if (hr == S_OK)
					{
						i = sprintf(str, "ABC found smart tee");
					}
					else
					{
						i = sprintf(str, "ABC problem finding TEE = %d",hr);
						//return hr;
					}
					REALMessageBoxx(REALBuildString(str,i));
				}//if ( hr == 262782 )//VFW_S_NOPREVIEWPIN
			
				//**************************************
				
				//return hr;
			}//find filter by name
			


	hr = ConnectFilters(data->pFg, data->pSmartTee, data->pMux);
	if (hr == S_OK)
	{
		i = sprintf(str, "connected pSmartTee to pMux!");
	}
	else
	{
		//i = sprintf(str, "problem connecting pSmartTee to pMux! = %d : %s",hr,DXGetErrorString9(hr));
		i = sprintf(str, "problem connecting pSmartTee to pMux! = %d",hr);
		//return hr;
	}
	REALMessageBoxx(REALBuildString(str,i));



	hr = ConnectFilters(data->pFg, data->pMux, data->pWrite);

	if (hr == S_OK)
	{
		i = sprintf(str, "connected pMux to pWrite!");
	}
	else
	{
		i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
		//return hr;
	}
	REALMessageBoxx(REALBuildString(str,i));


	hr = ConnectFilters(data->pFg,data->pInfTee, data->pMux);

	if (hr == S_OK)
	{
		i = sprintf(str, "v1 connected audio to pMux to pWrite!");
	}
	else
	{
		i = sprintf(str, "v1 problem connecting audio to pMux to pWrite! = %d",hr);
		//return hr;
	}
	REALMessageBoxx(REALBuildString(str,i));


//return true;
}
//  END SCENARIO V1. plain Jane video (e.g. QuickCam video)
	
	
	
	i = sprintf(str, "END SCENARIO V1.");
	REALMessageBoxx(REALBuildString(str,i));	
	
	
	
	
//*******************************************************************	
//*******************************************************************
//*******************************************************************
//*******************************************************************
//
//  SCENARIO V2. DV (e.g. MiniDV)
//
//*******************************************************************
//*******************************************************************
//*******************************************************************
//*******************************************************************
if ((videoIsDV == true) && (data->enableVideo == true))
{
			//  get rid of everything so we can build 
		//  the whole dv graph by hand
		//  this is necessary because we want to be 
		//  able to hook up audio in funky ways
		NukeDownstream(instance, data->pVCap, true);
		
		//  video path:
		//  pVCap->DV Splitter->Smart Tee->AVI Mux->File
		//  pVCap->DV Splitter->Smart Tee->Video Renderer
		//  audio path:
		//  pVCap->DV Splitter->Infinite Tee->AVI Mux->File
		//  pVCap->DV Splitter->Infinite Tee->Default Audio Renderer
		
		//**************************************************************
		//
		//  Create the DV Splitter (CLSID_DVSplitter)
		//
		//**************************************************************
		hr = AddFilterByCLSID(data->pFg, CLSID_DVSplitter, L"DV Splitter", &data->pDVSplit);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't add DV splitter");
			return false;
		}
		else
		{
			i = sprintf(str, "added DV splitter");

		}
		
		//**************************************************************
		//
		//  Create the Smart Tee (CLSID_SmartTee)
		//
		//**************************************************************
		hr = AddFilterByCLSID(data->pFg, CLSID_SmartTee, L"Smart Tee", &data->pSmartTee);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't add smart tee");
			return false;
		}
		else
		{
			i = sprintf(str, "added smart tee");

		}
		
		//**************************************************************
		//
		//  Create the DV Decoder (CLSID_DVVideoCodec) [used in video render]
		//
		//**************************************************************
		
		hr = AddFilterByCLSID(data->pFg, CLSID_DVVideoCodec, L"DV Decoder", &data->pDVDec);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't add dv decoder");
			return false;
		}
		else
		{
			i = sprintf(str, "added dv decoder");

		}
		
		
		//**************************************************************
		//
		//  RENDER pVCap to DV splitter.
		//
		//**************************************************************
		
		hr = data->pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, 0, data->pDVSplit);
		if(FAILED(hr))
		{
			i = sprintf(str, "!!!!! can't render pVCap to DV Splitter");
			return false;
		}
		else
		{
			i = sprintf(str, "!!!!! rendered pVCap to DV Splitter");
			
		}
		REALMessageBoxx(REALBuildString(str,i));
		
		
		/*
		hr = gcap.pBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, 
                                         gcap.pACap, NULL, gcap.pRender);
        if(hr != NOERROR)
        {
            ErrMsg(TEXT("Cannot render audio capture stream"));
            goto SetupCaptureFail;
        }
        */
        
        /*
		hr = data->pBuilder->FindPin(data->pVCap, PINDIR_OUTPUT, 0, 0, TRUE, 0, &pPin1);
		if(FAILED(hr))
		{
			i = sprintf(str, "***** can't find av pin");
			REALMessageBoxx(REALBuildString(str,i));
		}
		else
		{
			i = sprintf(str, "***** found av pin");
			REALMessageBoxx(REALBuildString(str,i));
		}
			hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Stream, pPin1, 0, data->pDVSplit);
			if(FAILED(hr))
			{
				i = sprintf(str, "***** can't render pVCap to DV Splitter 1");
				//return false;
				REALMessageBoxx(REALBuildString(str,i));
				hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Interleaved, pPin1, 0, data->pDVSplit);
				if(FAILED(hr))
				{	
					i = sprintf(str, "***** can't render pVCap to DV Splitter 2");
					REALMessageBoxx(REALBuildString(str,i));
					hr = data->pBuilder->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pPin1, 0, data->pDVSplit);
					if(FAILED(hr))
					{
						i = sprintf(str, "***** can't render pVCap to DV Splitter 3");
						REALMessageBoxx(REALBuildString(str,i));
					}
					
				}
			}
			else
			{
				i = sprintf(str, "***** rendered pVCap to preview");
				
			}
		*/
		
		//**************************************************************
		//
		//  RENDER DV Splitter to DV Decoder to Smart Tee.
		//
		//**************************************************************
/*		
		hr = data->pBuilder->RenderStream(0, &MEDIATYPE_Video, data->pDVSplit, data->pDVDec, data->pSmartTee);
		//hr = pBuilder->RenderStream(0, &MEDIATYPE_Interleaved, data->pDVSplit, 0, data->pSmartTee);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't render DV Splitter to DV Decoder to Smart Tee");
			return false;
		}
		else
		{
			i = sprintf(str, "rendered DV Splitter to DV Decoder to Smart Tee");
			
		}
		REALMessageBoxx(REALBuildString(str,i));
*/		

		//**************************************************************
		//
		//  RENDER DV Splitter to SmartTee to Mux
		//
		//**************************************************************
		//data->pMux
		hr = data->pBuilder->RenderStream(0, &MEDIATYPE_Video, data->pDVSplit, data->pSmartTee, data->pMux);
		//hr = pBuilder->RenderStream(0, &MEDIATYPE_Interleaved, data->pDVSplit, 0, data->pSmartTee);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't render DV Splitter to DV Decoder to mux");
			return false;
		}
		else
		{
			i = sprintf(str, "rendered DV Splitter to DV Decoder to mux");
			
		}
		REALMessageBoxx(REALBuildString(str,i));
			
	
		//**************************************************************
		//
		//  RENDER Smart Tee (video) to Avi Mux.
		//
		//**************************************************************
/*
		hr = data->pBuilder->FindPin(data->pSmartTee, PINDIR_OUTPUT, 0, 0, TRUE, 0, &pPin1);
		hr = data->pBuilder->RenderStream(0, 0, pPin1, 0, data->pMux);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't render Smart Tee to pmux");
			return false;
		}
		else
		{
			i = sprintf(str, "rendered Smart Tee to pmux");
			
		}
		hr = pPin1->Release();
		REALMessageBoxx(REALBuildString(str,i));
*/
		
		
		//**************************************************************
		//
		//  RENDER Avi Mux to file.
		//
		//**************************************************************
		hr = ConnectFilters(data->pFg, data->pMux, data->pWrite);

		if (hr == S_OK)
		{
			i = sprintf(str, "connected pMux to pWrite!");
		}
		else
		{
			i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
			//return hr;
		}
		REALMessageBoxx(REALBuildString(str,i));


	
		//**************************************************************
		//
		//  RENDER the preview
		//
		//  Smart Tee to preview.
		//
		//  RENDER Smart Tee (video) to pRender.
		//
		//**************************************************************
		
		//recreate the pRender
		CreateVideoRenderer(instance);
		
		hr = data->pBuilder->FindPin(data->pSmartTee, PINDIR_OUTPUT, 0, 0, false, 1, &pPin2);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't find smarttee preview pin=%d",hr);
			//return false;
		}
		else
		{
			i = sprintf(str, "found smarttee preview pin");
			
		}
		REALMessageBoxx(REALBuildString(str,i));
		
		hr = data->pBuilder->RenderStream(0, 0, pPin2, 0, data->pRender);
		if(FAILED(hr))
		{
			i = sprintf(str, "can't render Smart Tee to prender=%d %s",hr,DXGetErrorString9(hr));
			
			//return false;
		}
		else
		{
			i = sprintf(str, "rendered Smart Tee to prender");
			
		}
		REALMessageBoxx(REALBuildString(str,i));
		//hr = pPin2->Release();
		


		//*****************************************************************
		//	
		//  connect the audio
		//
		//*****************************************************************
if (data->enableSound == true)
{
		if ( (data->useDVAudioDevice == false) )
		{
			//non-DV audio devices - simple to connect
			hr = data->pBuilder->FindPin(data->pACap, PINDIR_OUTPUT, 0, 0, TRUE, 0, &pPin1);

			if ( (data->pInfTee) && (data->previewWhileRecording))
				hr = data->pBuilder->RenderStream(0, 0, pPin1, data->pInfTee, data->pMux);
			else
				hr = data->pBuilder->RenderStream(0, 0, pPin1, 0, data->pMux);
						
			if(FAILED(hr))
			{
				i = sprintf(str, "can't render pACap to pmux");
				return false;
			}
			else
			{
				i = sprintf(str, "rendered pACap to pmux");
				
			}
			hr = pPin1->Release();
			REALMessageBoxx(REALBuildString(str,i));
		}
		else// (data->useDVAudioDevice == true)
		{
			//use a dv device as an audio src
			i = sprintf(str, "render dv audio src here");
			REALMessageBoxx(REALBuildString(str,i));
			
			//for now, we're just going to assume that the dv audio device
			//is the dv video device.
			//this may not be true... later
			
			if ( (data->pInfTee) && (data->previewWhileRecording))
				hr = data->pBuilder->RenderStream(0, 0, data->pDVSplit, data->pInfTee, data->pMux);
			else
				hr = data->pBuilder->RenderStream(0, 0, data->pDVSplit, 0, data->pMux);
				

			if(FAILED(hr))
			{
				i = sprintf(str, "can't render pACap to pmux");
				return false;
			}
			else
			{
				i = sprintf(str, "rendered pACap to pmux");
				
			}
			REALMessageBoxx(REALBuildString(str,i));
			
		}
}//is the sound channel enabled?

		
			//
	    	// Get the preview window to be a child of our app's window...
		    // This will find the IVideoWindow interface on the renderer.  It is 
		    // important to ask the filtergraph for this interface... do NOT use
		    // ICaptureGraphBuilder2::FindInterface, because the filtergraph needs to
		    // know we own the window so it can give us display changed messages, etc.
			//
					
		    hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		    if(hr != NOERROR)
		    {
		        //ErrMsg(TEXT("This graph cannot preview properly"));
		    }
		    else//// hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
			{
		        //Find out if this is a DV stream
		        AM_MEDIA_TYPE * pmtDV;
		
		        if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
		        {
		            if(pmtDV->formattype == FORMAT_DvInfo)
		            {
		                // in this case we want to set the size of the parent window to that of 
		                // current DV resolution.
		                // We get that resolution from the IVideoWindow.
		                
		                //start problems
		                //CComQIPtr <IBasicVideo, &IID_IBasicVideo> pBV(data->pVW);
	
	                
		            }//if(pmtDV->formattype == FORMAT_DvInfo)
		        }//if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
	
	
		    	//RECT rc;
		    	data->pVW->put_Owner((OAHWND)data->ghwndApp);   // We own the window now
		    	data->pVW->put_WindowStyle(WS_CHILD);    		// you are now a child
		    	REALGetControlBounds(instance, &r);
		
				//**************************************************
				//  natural bounds code goes here!
				//**************************************************
		           	
				data->theSGBounds.left = r.left;
				data->theSGBounds.top = r.top;
				data->theSGBounds.right = r.right;
				data->theSGBounds.bottom = r.bottom;
				
				displayWidth = r.right - r.left;
				displayHeight = r.bottom - r.top;
				IBasicVideo *basicVideo;
				hr = data->pRender->QueryInterface(IID_IBasicVideo, (void**)&basicVideo);
		
				//hr = basicVideo->SetSourcePosition(data->theSGBounds.left, data->theSGBounds.top, theWidth, theHeight); // BJS 11/08/03
		
				hr = basicVideo->GetVideoSize(&naturalWidth, &naturalHeight); // BJS 11/08/03	
				if (naturalWidth > 0 && naturalHeight > 0)
				{
					data->theNaturalBounds.left = 0;
					data->theNaturalBounds.top = 0;
					data->theNaturalBounds.right = naturalWidth; // BJS 11/08/03
					data->theNaturalBounds.bottom = naturalHeight; // BJS 11/08/03
				}
				data->pVW->SetWindowPosition(data->theSGBounds.left, data->theSGBounds.top, displayWidth, displayHeight);
				
				
		    }
		
		
		//**************************************************************
		//
		//  RUN the graph.
		//
		//**************************************************************
		/*
		hr = pMC->Run();
    	if(FAILED(hr))
    	{
    	    // stop parts that started
    	    pMC->Stop();
    	    pMC->Release();
    	    i = sprintf(str, "problem restarting = %d",hr);
    	    REALMessageBoxx(REALBuildString(str,i));
    	    return FALSE;
    	}
    	
    	i = sprintf(str, "NO problems restarting = %d",hr);
    	REALMessageBoxx(REALBuildString(str,i));
    	*/
    	//return true;

}
//  END SCENARIO V2. DV (e.g. MiniDV)	
	
	
	
	
	
	
	
//*******************************************************************	
//*******************************************************************
//*******************************************************************
//*******************************************************************
//
//  SCENARIO V3. audio only
//
//*******************************************************************
//*******************************************************************
//*******************************************************************
//*******************************************************************
if ((data->enableSound == true)  && (data->enableVideo == false))
{
	i = sprintf(str, "in v3");
		REALMessageBoxx(REALBuildString(str,i));

		i = sprintf(str, "SCENARIO V3");
		REALMessageBoxx(REALBuildString(str,i));
		
		//if ((videoIsDV == true) && (data->enableVideo == true))
			
		if ( (data->useDVAudioDevice == false) )
		{
			//non-DV audio devices - simple to connect
			hr = data->pBuilder->FindPin(data->pACap, PINDIR_OUTPUT, 0, 0, TRUE, 0, &pPin1);

			if ( (data->pInfTee) && (data->previewWhileRecording))
				hr = data->pBuilder->RenderStream(0, 0, pPin1, data->pInfTee, data->pMux);
			else
				hr = data->pBuilder->RenderStream(0, 0, pPin1, 0, data->pMux);
				
			if(FAILED(hr))
			{
				i = sprintf(str, "can't render pACap to pmux");
				return false;
			}
			else
			{
				i = sprintf(str, "rendered pACap to pmux");
				
			}
			
			//connect to file writer		
			hr = ConnectFilters(data->pFg, data->pMux, data->pWrite);

			if (hr == S_OK)
			{
				i = sprintf(str, "connected pMux to pWrite!");
			}
			else
			{
				i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
				//return hr;
			}
			REALMessageBoxx(REALBuildString(str,i));
	
			hr = pPin1->Release();
			REALMessageBoxx(REALBuildString(str,i));
		}
		else// (data->useDVAudioDevice == true)
		{
			//use a dv device as an audio src
			i = sprintf(str, "render dv audio src here");
			REALMessageBoxx(REALBuildString(str,i));
			
			//for now, we're just going to assume that the dv audio device
			//is the dv video device.
			//this may not be true... later
			if ( (data->pInfTee) && (data->previewWhileRecording))
				hr = data->pBuilder->RenderStream(0, 0, data->pDVSplit, data->pInfTee, data->pMux);
			else
				hr = data->pBuilder->RenderStream(0, 0, data->pDVSplit, 0, data->pMux);
			
			if(FAILED(hr))
			{
				i = sprintf(str, "can't render pACap to pmux");
				return false;
			}
			else
			{
				i = sprintf(str, "rendered pACap to pmux");
				
			}
			REALMessageBoxx(REALBuildString(str,i));
			
			
			//**************************************************************
			//
			//  RENDER Avi Mux to file.
			//
			//**************************************************************
			hr = ConnectFilters(data->pFg, data->pMux, data->pWrite);
	
			if (hr == S_OK)
			{
				i = sprintf(str, "connected pMux to pWrite!");
			}
			else
			{
				i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
				//return hr;
			}
			REALMessageBoxx(REALBuildString(str,i));
			


			hr = ConnectFilters(data->pFg,data->pInfTee, data->pMux);
			if (hr == S_OK)
			{
				i = sprintf(str, "v3 connected audio to pMux to pWrite!");
			}
			else
			{
				i = sprintf(str, "v3 problem connecting audio to pMux to pWrite! = %d",hr);
				//return hr;
			}
			REALMessageBoxx(REALBuildString(str,i));


		
		}
}
//  END SCENARIO V3. audio only	
	
	
	
	
	
	
	
	
	i = sprintf(str, "post v3");
		REALMessageBoxx(REALBuildString(str,i));

	
	if (pACapPin)
		pACapPin->Release;
	if (pInfInPin)
		pInfInPin->Release;
	if (pDVSplitter)
		pDVSplitter->Release;


//*****************************************************************
//	
//  end - connect the audio
//
//*****************************************************************		
	
			
	hr = pMC->Run();
    //else
    //    hr = pMC->Pause();
    if(FAILED(hr))
    {
        // stop parts that started
        pMC->Stop();
        pMC->Release();
        i = sprintf(str, "problems with pMC->Run = %d",hr);
        REALMessageBoxx(REALBuildString(str,i));
        //ErrMsg(TEXT("Error %x: Cannot start graph"), hr);
        return FALSE;
    }
    
    i = sprintf(str, "NO problems with pMC->Run = %d",hr);
    REALMessageBoxx(REALBuildString(str,i));
return (true);

			
    //
    // Render the video capture and preview pins - even if the capture filter only
    // has a capture pin (and no preview pin) this should work... because the
    // capture graph builder will use a smart tee filter to provide both capture
    // and preview.  We don't have to worry.  It will just work.
    //

    // NOTE that we try to render the interleaved pin before the video pin, because
    // if BOTH exist, it's a DV filter and the only way to get the audio is to use
    // the interleaved pin.  Using the Video pin on a DV filter is only useful if
    // you don't want the audio.




}



// stop the capture graph
//
BOOL StopCapture(REALcontrolInstance instance)
{

	ControlData(captureControl, instance, captureData, data);
    char str[50];
	int i;
	
    
    
    //i = sprintf(str, "problem connecting pMux to pWrite! = %d",hr);
    i = sprintf(str, "StopCapture");
	REALMessageBoxx(REALBuildString(str,i));
		
    
    // stop the graph
    IMediaControl *pMC = NULL;
    HRESULT hr = data->pFg->QueryInterface(IID_IMediaControl, (void **)&pMC);
    if(SUCCEEDED(hr))
    {
        hr = pMC->Stop();
        pMC->Release();
        NukeDownstream(instance, data->pVCap, true);
        //NukeDownstream(instance, data->pMux, true);
        //data->pFg->RemoveFilter(data->pMux);
        
    }
    if(FAILED(hr))
    {
        return FALSE;
    }
    
	//data->previewState = FALSE;
	
		if ((data->previewState == true) && (data->enableVideo == true))
		{

    i = sprintf(str, "StopCapture::Restart Preview");
	REALMessageBoxx(REALBuildString(str,i));

		CreateVideoRenderer(instance);
		captureSetPreviewState(instance, 0, false);
		captureSetPreviewState(instance, 0, true);
		//captureSetPreviewState(instance, 0, data->previewState);
		//captureSetPreviewState(instance, 0, true);
		//static void captureSetPreviewState(REALcontrolInstance instance, long param, Boolean theState)
		}
	return TRUE;
	


    return TRUE;
}



HRESULT AddFilterByCLSID(
    IGraphBuilder *pGraph,  // Pointer to the Filter Graph Manager.
    const GUID& clsid,      // CLSID of the filter to create.
    LPCWSTR wszName,        // A name for the filter.
    IBaseFilter **ppF)      // Receives a pointer to the filter.
{
    if (!pGraph || ! ppF) return E_POINTER;
    *ppF = 0;
    IBaseFilter *pF = 0;
    HRESULT hr = CoCreateInstance(clsid, 0, CLSCTX_INPROC_SERVER,
        IID_IBaseFilter, reinterpret_cast<void**>(&pF));
    if (SUCCEEDED(hr))
    {
        hr = pGraph->AddFilter(pF, wszName);
        if (SUCCEEDED(hr))
            *ppF = pF;
        else
            pF->Release();
    }
    return hr;
}


void IMonRelease(IMoniker *&pm)
{
    if(pm)
    {
        pm->Release();
        pm = 0;
    }
}

#pragma mark -

void CreateVideoRenderer(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	/*
	if (data->pRender == NULL)
	{}
	else
	{return;}
	*/
	
	//************************************************************************
	//  create the Video Renderer
	//************************************************************************

	//hr = CoCreateInstance(CLSID_VideoMixingRenderer9 , NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&data->pRender);
	hr = CoCreateInstance(CLSID_VideoMixingRenderer , NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&data->pRender);
	if(SUCCEEDED(hr))
	{
		REALMessageBoxx(REALBuildString("Create VideoRenderer OK",23));  
		//************************************************************************   
		//add Video Renderer to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->pRender, L"BEST Video Mixing Renderer");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->pRender   FAIL",30));
		}
		else
			{
			data->usingVMR = true;
			//REALMessageBoxx(REALBuildString("AddFilter data->pRender   OK  ",30));
			//REALMessageBoxx(REALBuildString("data->usingVMR = true;",22));
			data->VRCreated = 1;
			}
		}
	else
		{ // VMR creation failed
		hr = CoCreateInstance(CLSID_VideoRenderer , NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&data->pRender);
		if(SUCCEEDED(hr))
			{
			REALMessageBoxx(REALBuildString("Create VideoRenderer OK",23));  
			//************************************************************************   
			//add Video Renderer to the graph
			//************************************************************************   
			hr = data->pFg->AddFilter(data->pRender, L"BEST Video Renderer");
			if (FAILED(hr))
				{
			    // Return an error.
			    REALMessageBoxx(REALBuildString("AddFilter data->pRender   FAIL",30));
				}
			else
				{
				data->usingVMR = false;
				//REALMessageBoxx(REALBuildString("AddFilter data->pRender   OK  ",30));
				//REALMessageBoxx(REALBuildString("data->usingVMR = false;",23));
				data->VRCreated = 1;
				}
			}
		else
			{
			REALMessageBoxx(REALBuildString("CreateVideoRenderer FAIL",20));
			}	
		}
	
}

// BJS start
void CreateDVGrabDecoder(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the DV decoder filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_DVVideoCodec , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->dvGrabDecoder);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV Decoder OK",23));  
		//************************************************************************   
		//add DV decoder to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->dvGrabDecoder, L"BEST DV Grab Decoder");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->dvGrabDecoder   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->dvGrabDecoder   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateDVGrabDecoder FAIL",20));
	}
	
}

void CreateDVPreviewDecoder(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the DV decoder filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_DVVideoCodec , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->dvPreviewDecoder);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV Decoder OK",23));  
		//************************************************************************   
		//add DV decoder to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->dvPreviewDecoder, L"BEST DV Preview Decoder");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->dvPreviewDecoder   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->dvPreviewDecoder   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateDVPreviewDecoder FAIL",20));
	}
	
}

void CreateDVPreviewSplitter(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the DV splitter filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_DVSplitter , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->dvPreviewSplitter);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add DV splitter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->dvPreviewSplitter, L"BEST DV Preview Splitter");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->dvPreviewSplitter   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->dvPreviewSplitter   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateDVPreviewSplitter FAIL",20));
	}
	
}

void CreateDVGrabSplitter(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the DV splitter filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_DVSplitter , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->dvGrabSplitter);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add DV splitter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->dvGrabSplitter, L"BEST DV Grab Splitter");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->dvGrabSplitter   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->dvGrabSplitter   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateDVGrabSplitter FAIL",20));
	}
	
}

void CreateAVIDecompressor(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the AVI Decompressor filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_AVIDec , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->aviDecompressor);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add AVI Decompressor to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->aviDecompressor, L"BEST AVI Decompressor");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->aviDecompressor   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->aviDecompressor   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateAVIDecompressor FAIL",20));
	}
	
}

void CreateColorSpaceGrabConverter(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the Color Space converter filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_Colour , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->colorSpaceGrabConverter);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add Color Space converter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->colorSpaceGrabConverter, L"BEST Color Space Grab Converter");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->colorSpaceGrabConverter   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->colorSpaceGrabConverter   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateColorSpaceGrabConverter FAIL",20));
	}
	
}

void CreateColorSpacePreviewConverter(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the Color Space converter filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_Colour , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->colorSpacePreviewConverter);

	if(SUCCEEDED(hr))
	{
		//REALMessageBoxx(REALBuildString("Create DV splitter OK",23));  
		//************************************************************************   
		//add Color Space converter to the graph
		//************************************************************************   
		hr = data->pFg->AddFilter(data->colorSpacePreviewConverter, L"BEST Color Space Preview Converter");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->colorSpacePreviewConverter   FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->colorSpacePreviewConverter   OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateColorSpacePreviewConverter FAIL",20));
	}
	
}

// BJS end

void CreateSmartTee(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the smart tee filter
	//************************************************************************
	hr = CoCreateInstance(CLSID_SmartTee , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->pSmartTee);

	if(SUCCEEDED(hr))
	{
		REALMessageBoxx(REALBuildString("CreateSmartTee OK",17));  
		//************************************************************************   
		//add smart tee to the graph
		//************************************************************************   
	
		hr = data->pFg->AddFilter(data->pSmartTee, L"BEST Smart Tee");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->pSmartTee FAIL",30));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->pSmartTee OK  ",30));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("CreateSmartTee FAIL",19));
	}
	
}

void CreateNULLRenderer(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the NULL renderer
	//************************************************************************
	hr = CoCreateInstance(CLSID_NullRenderer , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->pNULLRenderer);

	if(SUCCEEDED(hr))
	{
		REALMessageBoxx(REALBuildString("CreateNULLRenderer OK",21));  
		//************************************************************************   
		//add the NULL renderer to the graph
		//************************************************************************   
	
		hr = data->pFg->AddFilter(data->pNULLRenderer, L"BEST NULL Renderer");
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("AddFilter data->pNULLRenderer FAIL",34));
		}
		else
		{
			REALMessageBoxx(REALBuildString("AddFilter data->pNULLRenderer OK  ",34));
		}
	}
	else
	{
		REALMessageBoxx(REALBuildString("Create    data->pNULLRenderer FAIL",34));
	}
	
}

void CreateSampleGrabber(REALcontrolInstance instance)
{
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the sample grabber
	//************************************************************************
	hr = CoCreateInstance(CLSID_SampleGrabber , NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&data->pGrabberBase);

	if(SUCCEEDED(hr))
	{
		REALMessageBoxx(REALBuildString("CreateSampleGrabber no err",26));
		//************************************************************************   
		// get an interface to the grabber
		//************************************************************************   
		hr = data->pGrabberBase->QueryInterface(IID_ISampleGrabber, (void**)&data->pGrabber); 
		if (FAILED(hr))
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("query  the sample grabber err",29));
		    return;
		}
		else
		{
		    // Return an error.
		    REALMessageBoxx(REALBuildString("query the sample grabber no err",32));
		    //************************************************************************   
			//add the sample grabber to the graph
			//************************************************************************   
		
			hr = data->pFg->AddFilter(data->pGrabberBase, L"BEST Sample Grabber");
			if (FAILED(hr))
			{
			    // Return an error.
			    REALMessageBoxx(REALBuildString("AddFilter data->pGrabberBase FAIL",33));
			}
			else
			{
				REALMessageBoxx(REALBuildString("AddFilter data->pGrabberBase OK",31));
			}
		}
			
		
	}
	else
	{
		REALMessageBoxx(REALBuildString("create the sample grabber err",29));
	}
	
}

	


void ConnectBranches(REALcontrolInstance instance)
{

/*
	//new params will go here
	TCHAR 					szCaptureFile[_MAX_PATH];
    WORD 					wCapFileSize;  // size in Meg
    ICaptureGraphBuilder2 	*pBuilder;
    IVideoWindow 			*pVW;
    IMediaEventEx 			*pME;
    IAMStreamConfig 		*pASC;  	    // for audio cap
    IAMStreamConfig 		*pVSC;	      	// for video cap
    IBaseFilter 			*pGrabberBase;	
    ISampleGrabber 			*pGrabber;
    IBaseFilter 			*pSrcFilter;
    IBaseFilter 			*pSmartTee;
    IMediaControl 			*pMC;
    IBaseFilter 			*pRender;
    IBaseFilter 			*pVCap, *pACap;
    IGraphBuilder 			*pFg;
    IConfigAviMux 			*pConfigAviMux;
    int  					iMasterStream;
    BOOL 					fPreviewGraphBuilt;	
    BOOL 					fCapturing;
    BOOL 					fMPEG2;
    BOOL 					fCapAudio;
    BOOL 					fCapCC;
    double 					FrameRate;
    WCHAR 					wachFriendlyName[120];
    BOOL 					fUseFrameRate;
    HWND 					ghwndApp;
*/
	
	ControlData(captureControl, instance, captureData, data);
	HRESULT hr = 0;
	
	//************************************************************************
	//  create the sample grabber base
	//************************************************************************
	//	hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER,IID_IBaseFilter, 
	//							(void**)&data->pGrabberBase);

	//IPin *pGrabberIn = 0;
	//hr = GetUnconnectedPin(data->pGrabberBase, PINDIR_INPUT, &pGrabberIn);
	//if (FAILED(hr))
	//{
	//    REALMessageBoxx(REALBuildString("err --> GetUnconnectedPinIn pGrabberBase",40));
	//}

	// Preview branch
    IPin *pTmpPin = NULL;
    hr = get_pin(data->pSmartTee, PINDIR_OUTPUT, 1, &pTmpPin);// Preview Pin
    if (FAILED(hr))
		// Return an error.
	    REALMessageBoxx(REALBuildString("Preview branch FAIL",19));
	else
	    {
	    REALMessageBoxx(REALBuildString("Preview branch OK  ",19));
    	data->pFg->Render(pTmpPin); //use added m_pRenderFilter
    	}
    
    // Capture branch
    pTmpPin = NULL;
   	hr = get_pin(data->pSmartTee, PINDIR_OUTPUT, 0, &pTmpPin);// Capture pin
    // Render the capture pin with a file writer to save video
    //JIF(m_pCaptureGraphBuilder2->SetOutputFileName(&MEDIASUBTYPE_Avi, 
    //                                 m_wcOutputFile, &pf, &pSink));
    data->pBuilder->RenderStream(NULL, NULL, pTmpPin, NULL, data->pGrabberBase);
	 if (FAILED(hr))
		// Return an error.
	    REALMessageBoxx(REALBuildString("capture branch FAIL",19));
	else
	    {
	    REALMessageBoxx(REALBuildString("capture branch OK  ",19));
    	data->pFg->Render(pTmpPin); //use added m_pRenderFilter
    	}

    REALMessageBoxx(REALBuildString("smart tee exit",14));
    	
}

///////////////////////////////////////////////////////////////////////
// get_pin: Get the specified pin of a given filter
// Auguments:
//   pFilter: Get the pin of the pFilter
//   dir    : Which pin (input or output pin)
//   n      : the nth pin of given direction
//   ppPin  : To receive the pin we found
// return value: error code
///////////////////////////////////////////////////////////////////////
HRESULT get_pin(IBaseFilter * pFilter, PIN_DIRECTION dir, int n, IPin **ppPin)
{
    IEnumPins *pEnum;
    *ppPin = NULL;
    HRESULT hr;
    pFilter->EnumPins(&pEnum);

    ULONG ulFound;
    IPin *pPin;
    hr = E_FAIL;
    while(S_OK == pEnum->Next(1, &pPin, &ulFound))
    {
        PIN_DIRECTION pindir = (PIN_DIRECTION)3;
        pPin->QueryDirection(&pindir);
        if(pindir == dir) {
            if(n == 0) {
                hr = S_OK, *ppPin = pPin;
                break;
            }
            n--;
        } // if
        pPin->Release();
    } // while

    return hr;
}

HRESULT GetConnectedPin(
    IBaseFilter *pFilter,   // Pointer to the filter.
    PIN_DIRECTION PinDir,   // Direction of the pin to find.
    IPin **ppPin)           // Receives a pointer to the pin.
{
    *ppPin = 0;
    IEnumPins *pEnum = 0;
    IPin *pPin = 0;
    HRESULT hr = pFilter->EnumPins(&pEnum);
    if (FAILED(hr))
    {
        return hr;
    }
    while (pEnum->Next(1, &pPin, NULL) == S_OK)
    {
        PIN_DIRECTION ThisPinDir;
        pPin->QueryDirection(&ThisPinDir);
        if (ThisPinDir == PinDir)
        {
            IPin *pTmp = 0;
            hr = pPin->ConnectedTo(&pTmp);
            if (SUCCEEDED(hr))  // Already connected, this is the pin we want.
            {
                pEnum->Release();
                *ppPin = pPin;
                return S_OK;
            }
            else  // Unconnected, not the pin we want.
            {
                pTmp->Release();
            }
        }
        pPin->Release();
    }
    pEnum->Release();
    // Did not find a matching pin.
    return E_FAIL;
} 


HRESULT GetUnconnectedPin(
    IBaseFilter *pFilter,   // Pointer to the filter.
    PIN_DIRECTION PinDir,   // Direction of the pin to find.
    IPin **ppPin)           // Receives a pointer to the pin.
{
    *ppPin = 0;
    IEnumPins *pEnum = 0;
    IPin *pPin = 0;
    HRESULT hr = pFilter->EnumPins(&pEnum);
    if (FAILED(hr))
    {
        return hr;
    }
    while (pEnum->Next(1, &pPin, NULL) == S_OK)
    {
        PIN_DIRECTION ThisPinDir;
        pPin->QueryDirection(&ThisPinDir);
        if (ThisPinDir == PinDir)
        {
            IPin *pTmp = 0;
            hr = pPin->ConnectedTo(&pTmp);
            if (SUCCEEDED(hr))  // Already connected, not the pin we want.
            {
                pTmp->Release();
            }
            else  // Unconnected, this is the pin we want.
            {
                pEnum->Release();
                *ppPin = pPin;
                return S_OK;
            }
        }
        pPin->Release();
    }
    pEnum->Release();
    // Did not find a matching pin.
    return E_FAIL;
}


HRESULT ConnectFilters(
    IGraphBuilder *pGraph, // Filter Graph Manager.
    IPin *pOut,            // Output pin on the upstream filter.
    IBaseFilter *pDest)    // Downstream filter.
{
    if ((pGraph == NULL) || (pOut == NULL) || (pDest == NULL))
    {
        return E_POINTER;
    }
#ifdef debug
        PIN_DIRECTION PinDir;
        pOut->QueryDirection(&PinDir);
        _ASSERTE(PinDir == PINDIR_OUTPUT);
#endif

    // Find an input pin on the downstream filter.
    IPin *pIn = 0;
    HRESULT hr = GetUnconnectedPin(pDest, PINDIR_INPUT, &pIn);
    if (FAILED(hr))
    {
        return hr;
    }
    // Try to connect them.
    hr = pGraph->Connect(pOut, pIn);
    pIn->Release();
    return hr;
}


HRESULT ConnectFilters(
    IGraphBuilder *pGraph, 
    IBaseFilter *pSrc, 
    IBaseFilter *pDest)
{
    if ((pGraph == NULL) || (pSrc == NULL) || (pDest == NULL))
    {
        return E_POINTER;
    }

    // Find an output pin on the first filter.
    IPin *pOut = 0;
    HRESULT hr = GetUnconnectedPin(pSrc, PINDIR_OUTPUT, &pOut);
    if (FAILED(hr)) 
    {
        return hr;
    }
    hr = ConnectFilters(pGraph, pOut, pDest);
    pOut->Release();
    return hr;
}



HRESULT FindPinByCategory(
    IBaseFilter *pF,      // Pointer to the filter to search.
    PIN_DIRECTION PinDir, // Direction of the pin.
    const GUID& Category, // Pin category.
    IPin **ppPin)         // Receives a pointer to the pin.
{
    if (!pF || !ppPin) return E_POINTER;

    *ppPin = 0;
    HRESULT hr;
    IEnumPins *pEnum = 0;
    if (SUCCEEDED(pF->EnumPins(&pEnum)))
    {
        IPin *pPin = 0;
        while (hr = pEnum->Next(1, &pPin, 0), hr == S_OK)
        {
            PIN_DIRECTION ThisPinDir;
            hr = pPin->QueryDirection(&ThisPinDir);
            if (FAILED(hr))
            {
                pPin->Release();
                pEnum->Release();
                return E_UNEXPECTED; // Something strange happened.
            }
            if ((ThisPinDir == PinDir) && 
                PinMatchesCategory(pPin, Category))
            {
                *ppPin = pPin;  // Caller must release the interface.
                pEnum->Release();
                return S_OK;
            }
            pPin->Release();
        }
        pEnum->Release();
    }
    // No pin matches.
    return E_FAIL;
}


BOOL PinMatchesCategory(IPin *pPin, const GUID& Category)
{
    if (pPin == NULL) return E_POINTER;

    BOOL bFound = FALSE;
    IKsPropertySet *pKs;
    HRESULT hr = pPin->QueryInterface(IID_IKsPropertySet, (void **)&pKs);
    if (SUCCEEDED(hr))
    {
        GUID PinCategory;
        DWORD cbReturned;
        hr = pKs->Get(AMPROPSETID_Pin, AMPROPERTY_PIN_CATEGORY, NULL, 0, 
            &PinCategory, sizeof(GUID), &cbReturned);
        if (SUCCEEDED(hr))
        {
            bFound = (PinCategory == Category);
        }
        pKs->Release();
    }
    return bFound;
}


///////////////////////////////////////////////////////////////////////
// addGraphToRot: Register the graph for the GraphEdt.exe to view it
// Auguments:
//   pUnkGraph:   the graph to register
//   pdwRegister: to retrieve the register number (to unregister later)
// return value: error code
///////////////////////////////////////////////////////////////////////
HRESULT addGraphToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) 
{
    IMoniker* pMoniker;
    IRunningObjectTable* pROT;
    WCHAR wsz[128];
    HRESULT hr;

    GetRunningObjectTable(0, &pROT);

    wsprintfW(wsz, L"FilterGraph %08x pid %08x", (DWORD_PTR)pUnkGraph, 
              GetCurrentProcessId());

	//lstrcpyW(data->wachFriendlyName, varName.bstrVal);
	
    hr = CreateItemMoniker(L"!", wsz, &pMoniker);
    if (SUCCEEDED(hr)) {
        hr = pROT->Register(0, pUnkGraph, pMoniker, pdwRegister);
    }
    return hr;
}


///////////////////////////////////////////////////////////////////////
// removeGraphFromRot: unregister the previous registered graph
// Auguments:
//   pdwRegister: specify which graph to unregister
///////////////////////////////////////////////////////////////////////
void removeGraphFromRot(DWORD dwRegister)
{
    IRunningObjectTable* pROT;
    if (SUCCEEDED(GetRunningObjectTable(0, &pROT))) {
        pROT->Revoke(dwRegister);
    }
}

#pragma mark -
void REALMessageBoxx(REALstring thestring)
{
	//REALMessageBoxx(thestring);
}

bool isDVFormat(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	bool isDV = false;
	HRESULT hr;
    char str[50];
	int i;
				
		    hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
		    if(hr != NOERROR)
		    {
		        //ErrMsg(TEXT("This graph cannot preview properly"));
		        i = sprintf(str, "This graph cannot preview properly");
			  	REALMessageBoxx(REALBuildString(str,i));
		    }
		    else//// hr = data->pFg->QueryInterface(IID_IVideoWindow, (void **)&data->pVW);
			{
		     
		    //*************************************************************************************
			//check for DV - START
			//*************************************************************************************
		    AM_MEDIA_TYPE * pmtDV;
		    hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Interleaved, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);
		    if(hr != S_OK)
		        hr = data->pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, data->pVCap, IID_IAMStreamConfig, (void **)&data->pVSC);

		    if(hr == S_OK)
		    {
		     	i = sprintf(str, "data->pVSC a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
        	}
        	else
        	{
        		i = sprintf(str, "data->pVSC !a-ok");
		  		REALMessageBoxx(REALBuildString(str,i));
			}
	
	        if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
	        {
	            if(pmtDV->formattype == FORMAT_DvInfo)
	            {
	                
	                isDV = true;
	                i = sprintf(str, "formattype == FORMAT_DvInfo");
		  			REALMessageBoxx(REALBuildString(str,i));
	            }//if(pmtDV->formattype == FORMAT_DvInfo)
	            else
	            {
	            isDV = false;
	            }
	        }//if(data->pVSC && SUCCEEDED(data->pVSC->GetFormat(&pmtDV)))
			//*************************************************************************************
			//check for DV - END
			//*************************************************************************************


			}

	return isDV;	
}

#pragma mark -
void captureDeviceControlPlay(REALcontrolInstance instance)
{

	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_PLAY);   
    SAFE_RELEASE(m_pIAMExtTransport);
    

/*
Action 					opcode1 	opcode2 
--------------------------------------------
Play 					0xc3 		0x75 
Rewind 					0xc4 		0x65 
Rewind Play 			0xc3 		0x4e 
Fast Forward 			0xc4 		0x75 
Fast Forward Play 		0xc3 		0x3e 
Stop 					0xc4 		0x60 
Pause 					0xc3 		0x7d 
Next Frame 				0xc3 		0x30 
Slow Forward 			0xc3 		0x35 
Previous Frame 			0xc3 		0x40 
Slow Rewind 			0xc3 		0x45 
*/


/*
Value  						Device State  
--------------------------------------------
ED_MODE_PLAY  				Play  
ED_MODE_STOP  				Stop  
ED_MODE_FREEZE  			Pause  
ED_MODE_FF  				Fast-forward  
ED_MODE_REW  				Rewind  
ED_MODE_RECORD  			Record  
ED_MODE_RECORD_FREEZE  		Record-pause  
*/

    
}

void captureDeviceControlStop(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_STOP);   
    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlFreeze(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_FREEZE);   
    SAFE_RELEASE(m_pIAMExtTransport);
}



static void captureDeviceControlFastForward(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_FF);   
    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlRewind(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_REW);   
    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlRecord(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_RECORD);   
    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlRecordFreeze(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;

	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport			*m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);

	i = sprintf(str, "* Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
  
    m_pIAMExtTransport->put_Mode(ED_MODE_RECORD_FREEZE);   
    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlPlayReverse(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
	
	if (!isDVFormat(instance))
		return;
		
	char 					str[50];
	int 					i;
	HRESULT 				hr;
    IAMExtTransport         *m_pIAMExtTransport;
	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);
    //CHECK_ERROR( TEXT(" Failed to  QI IAMExtTransport."), hr);
	i = sprintf(str, "Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));


//*****************************************************//
//
//  RAW AV/C COMMANDS
//*****************************************************//
/*
-------------------------------------------------------------
	Action 						opcode1 	opcode2 
-------------------------------------------------------------

opcode1 c2 = REC commands
	Record		 				0xc2 		0x75 
	Record Pause 				0xc2 		0x7D 

opcode1 c3 = PLAY commands
	Next Frame 					0xc3 		0x30 
	Slowest Forward				0xc3 		0x31 
	Slow Forward 6 				0xc3 		0x32 
	Slow Forward 5 				0xc3 		0x33 
	Slow Forward 4 				0xc3 		0x34 
	Slow Forward 3 				0xc3 		0x35 
	Slow Forward 2 				0xc3 		0x36 
	Slow Forward 1 				0xc3 		0x37 
	Play (normal speed X1)		0xc3 		0x38 	
	Fast Forward 1 				0xc3 		0x39 
	Fast Forward 2 				0xc3 		0x3A 
	Fast Forward 3 				0xc3 		0x3B 
	Fast Forward 4 				0xc3 		0x3C 
	Fast Forward 5 				0xc3 		0x3D 
	Fast Forward 6 				0xc3 		0x3E
	Fastest Forward				0xc3 		0x3F 
	Previous Frame 				0xc3 		0x40 
	Slowest Forward				0xc3 		0x41 
	Slow Forward 6 				0xc3 		0x42 
	Slow Forward 5 				0xc3 		0x43 
	Slow Forward 4 				0xc3 		0x44 
	Slow Forward 3 				0xc3 		0x45 
	Slow Forward 2 				0xc3 		0x46 
	Slow Forward 1 				0xc3 		0x47 
	Play (normal Reverse X1)	0xc3 		0x48 	
	Fast Reverse 1 				0xc3 		0x49 
	Fast Reverse 2 				0xc3 		0x4A 
	Fast Reverse 3 				0xc3 		0x4B 
	Fast Reverse 4 				0xc3 		0x4C 
	Fast Reverse 5 				0xc3 		0x4D 
	Fast Reverse 6 				0xc3 		0x4E
	Fastest Reverse				0xc3 		0x4F 
	Reverse						0xc3 		0x65 //play at normal speed in reverse
	Reverse Pause				0xc3 		0x6D //pause in reverse playback
	Forward						0xc3 		0x75 //playback at normal speed
	Forward Pause				0xc3 		0x7D //pause in playback

opcode1 c4 = WIND commands
	hi speed Rewind				0xc4 		0x65 //rewinds as quickly as possible
	Stop						0xc4 		0x60 
	Rewind 						0xc4 		0x65 //regular rewind
	Fast Forward	 			0xc4 		0x75 

*/


//
//*****************************************************//

LONG cbCmd = 4;  
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x75 }; //PLAY
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC4, 0x65 }; //REW
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x4e }; //REW Play
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC4, 0x75 }; //Fast FWD
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x3e }; //Fast Forward Play
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC4, 0x60 }; //STOP
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x7d }; //PAUSE
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x30 }; //NEXT FRAME
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x35 }; //Slow FWD
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x40 }; //Previous Frame
//BYTE AvcCmd[4] = { 0x00, 0x20, 0xC3, 0x45 }; //Slow REW

BYTE AvcCmd[4] = { 0x00, 0x20, 0xC4, 0x3F }; //ZOOM

hr = m_pIAMExtTransport->GetTransportBasicParameters(ED_RAW_EXT_DEV_CMD, &cbCmd, (LPOLESTR*) AvcCmd);  


// fill up the avc frame
// inBuffer[0] = 0x00; //kAVCControlCommand;
// inBuffer[1] = 0x20;
// inBuffer[2] = 0xC3; // Play command is 0xc3 0x75
// inBuffer[3] = 0x75;


    SAFE_RELEASE(m_pIAMExtTransport);
}

static void captureDeviceControlShuttle(REALcontrolInstance instance, long theSpeed)
{
	

}


static long captureDeviceControlGetMode(REALcontrolInstance instance)
//, REALnoImplementation, "DeviceControlGetMode() as integer" },
{
	ControlData(captureControl, instance, captureData, data);
	char str[50];
	int i;
	HRESULT hr;
    IAMExtTransport         *m_pIAMExtTransport;

	
    hr = data->pVCap->QueryInterface(IID_IAMExtTransport, 
                                        (void **) &m_pIAMExtTransport);
    //CHECK_ERROR( TEXT(" Failed to  QI IAMExtTransport."), hr);
	i = sprintf(str, "Failed to  QI IAMExtTransport. = %d",hr);
	REALMessageBoxx(REALBuildString(str,i));
   
    long pMode;
    m_pIAMExtTransport->get_Mode(&pMode);   

    SAFE_RELEASE(m_pIAMExtTransport);
    
    i = sprintf(str, "NADA");
    switch(pMode)
    {
    	case ED_MODE_PLAY:
    		i = sprintf(str, "PLAY = %d",pMode);
    		break;
    	case ED_MODE_STOP:
    		i = sprintf(str, "STOP = %d",pMode);
    		break;
    	case ED_MODE_FREEZE:
    		i = sprintf(str, "PAUSE = %d",pMode);
    		break;
    	case ED_MODE_FF:
    		i = sprintf(str, "FFWD = %d",pMode);
    		break;
    	case ED_MODE_REW:
    		i = sprintf(str, "REW = %d",pMode);
    		break;
    	case ED_MODE_RECORD:
    		i = sprintf(str, "REC = %d",pMode);
    		break;
    	case ED_MODE_RECORD_FREEZE:
    		i = sprintf(str, "REC_PAUSE = %d",pMode);
    		break;

    }
    REALMessageBox(REALBuildString(str,i));
    
    return pMode;
}


#pragma mark deviceConstants

/* 
Value  						Device State  
--------------------------------------------
ED_MODE_PLAY  				Play  
ED_MODE_STOP  				Stop  
ED_MODE_FREEZE  			Pause 
ED_MODE_THAW				Resume (unpause)
ED_MODE_FF  				Fast-forward  
ED_MODE_REW  				Rewind  
ED_MODE_RECORD  			Record  
ED_MODE_RECORD_FREEZE  		Record-pause  
ED_MODE_RECORD_STROBE		Record single frame
ED_MODE_STEP				Single step
ED_MODE_SHUTTLE				Shuttle (high-speed movement with visible picture)

ED_MODE_EDIT_CUE			Cue for an edit event
ED_MODE_LINK_ON				Link this method to the graph's IMediaControl::Run, Stop, and Pause methods
ED_MODE_LINK_OFF			Disengage this method from the graph's IMediaControl::Run, Stop, Pause methods.
*/


/*
Action 					opcode1 	opcode2 
--------------------------------------------
Play 					0xc3 		0x75 
Rewind 					0xc4 		0x65 
Rewind Play 			0xc3 		0x4e 
Fast Forward 			0xc4 		0x75 
Fast Forward Play 		0xc3 		0x3e 
Stop 					0xc4 		0x60 
Pause 					0xc3 		0x7d 
Next Frame 				0xc3 		0x30 
Slow Forward 			0xc3 		0x35 
Previous Frame 			0xc3 		0x40 
Slow Rewind 			0xc3 		0x45 
*/

/*
When Mode equals ED_MODE_RECORD, State may be:

ED_MODE_RECORD
ED_MODE_RECORD_FREEZE.

When Mode equals ED_MODE_PLAY, State may be:

ED_MODE_PLAY
ED_MODE_REV_PLAY
ED_MODE_STEP_FWD
ED_MODE_STEP_REV
ED_MODE_PLAY_SLOWEST_FWD
ED_MODE_PLAY_FASTEST_FWD
ED_MODE_PLAY_SLOWEST_REV
ED_MODE_PLAY_FASTEST_REV
ED_MODE_FREEZE

Mode equals State in the cases of:

ED_MODE_REW_FASTEST
ED_MODE_STOP
ED_MODE_PLAY
ED_MODE_FF
*/

/*

The TRANSPORT_STATE structure

 typedefstruct{
ULONGMode;
ULONGState;
}TRANSPORT_STATE,*PTRANSPORT_STATE;

*/


/*
//	IAMExtTransport Modes
#define	ED_MODE_PLAY				ED_BASE+200L
#define	ED_MODE_STOP				ED_BASE+201L
#define	ED_MODE_FREEZE				ED_BASE+202L	// really "pause"
#define	ED_MODE_THAW				ED_BASE+203L
#define	ED_MODE_FF					ED_BASE+204L
#define	ED_MODE_REW					ED_BASE+205L
#define	ED_MODE_RECORD				ED_BASE+206L
#define	ED_MODE_RECORD_STROBE		ED_BASE+207L
#define ED_MODE_RECORD_FREEZE		ED_BASE+808L	// never "put", only "get"
#define	ED_MODE_STEP				ED_BASE+208L	// same as "jog"
#define	ED_MODE_STEP_FWD			ED_BASE+208L	// same as ED_MODE_STEP
#define	ED_MODE_STEP_REV			ED_BASE+809L
#define	ED_MODE_SHUTTLE				ED_BASE+209L
#define	ED_MODE_EDIT_CUE			ED_BASE+210L
#define ED_MODE_VAR_SPEED			ED_BASE+211L
#define ED_MODE_PERFORM				ED_BASE+212L	// returned status only
#define	ED_MODE_LINK_ON				ED_BASE+280L
#define	ED_MODE_LINK_OFF			ED_BASE+281L
#define ED_MODE_NOTIFY_ENABLE		ED_BASE+810L
#define ED_MODE_NOTIFY_DISABLE		ED_BASE+811L
#define ED_MODE_SHOT_SEARCH			ED_BASE+812L
*/



#pragma mark -





/*-------------------------------------------------------------------------------
Routine:        CDVGraph::GetResolutionFromDVDecoderPropertyPage
Purpose:        controls discard or not half of the frames in the video stream
Arguments:      None
Returns:        HRESULT
Notes:          For NTSC, the frame rate is reduced from 30 frames per second (fps) to 15 fps. 
                For PAL, the frame rate is reduced from 25 fps to 12.5 fps.
---------------------------------------------------------------------------------*/
HRESULT GetResolutionFromDVDecoderPropertyPage(REALcontrolInstance instance, HWND hwndApp, BOOL bChangeResolution)
{
    ControlData(captureControl, instance, captureData, data);
	char str[50];
	int i;
	
	HRESULT hr;
    IBaseFilter *pDVDecoder;
    IIPDVDec    *pIPDVDec;

    /* Obtain the dv docoder's IBaseFilter interface. */
    hr = data->pFg->FindFilterByName(L"DV Video Decoder", &pDVDecoder) ;
    //CHECK_ERROR( TEXT("CDVGraph::GetResolutionFromDVDecoderPropertyPage()::data->pFg->FindFilterByName failed."), hr);        

    //CComPtr<ISpecifyPropertyPages> pProp;
    ISpecifyPropertyPages 	*pProp;


    hr = pDVDecoder->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
    //CHECK_ERROR( TEXT("CDVGraph::GetResolutionFromDVDecoderPropertyPage()::QI ISpecifyPropertyPages failed."), hr);        
    
    // Get the filter's name and IUnknown pointer.
    FILTER_INFO FilterInfo;
    hr = pDVDecoder->QueryFilterInfo(&FilterInfo); 
    //CHECK_ERROR( TEXT("CDVGraph::GetResolutionFromDVDecoderPropertyPage()::pDVDecoder->QueryFilterInfo failed."), hr);        

    // Show the page. 
    if(bChangeResolution)
    {
        CAUUID caGUID;
        pProp->GetPages(&caGUID);

        OleCreatePropertyFrame(
            hwndApp,                // Parent window
            0, 0,                   // (Reserved)
            FilterInfo.achName,     // Caption for the dialog box
            1,                      // Number of objects (just the filter)
            (IUnknown **)&pDVDecoder,            // Array of object pointers. 
            caGUID.cElems,          // Number of property pages
            caGUID.pElems,          // Array of property page CLSIDs
            0,                      // Locale identifier
            0, NULL                 // Reserved
        );
        CoTaskMemFree(caGUID.pElems);
    }

    // Clean up.
    FilterInfo.pGraph->Release(); 
   
    hr = pDVDecoder->QueryInterface(IID_IIPDVDec, reinterpret_cast<PVOID *>(&pIPDVDec));
    //CHECK_ERROR( TEXT("CDVGraph::GetResolutionFromDVDecoderPropertyPage()::QI IIPDVDec failed."), hr);        

    hr = pIPDVDec->get_IPDisplay(reinterpret_cast <int *>(&m_DVResolution));
    //CHECK_ERROR( TEXT("CDVGraph::GetResolutionFromDVDecoderPropertyPage()::pIPDVDec->get_IPDisplay failed."), hr);        
  
    SAFE_RELEASE( pDVDecoder );
    SAFE_RELEASE( pIPDVDec );

    return hr;
}

/*-------------------------------------------------------------------------
Routine:        CDVGraph::GetResolutionFromDVDecoderPropertyPage
Purpose:        controls discard or not half of the frames in the video stream
Arguments:      None
Returns:        HRESULT
Notes:          For NTSC, the frame rate is reduced from 30 frames per second (fps) to 15 fps. 
                For PAL, the frame rate is reduced from 25 fps to 12.5 fps.
------------------------------------------------------------------------*/

HRESULT GetVideoWindowDimensions (REALcontrolInstance instance, int* pWidth, int *pHeight, BOOL bChangeResolution,HWND hwndApp)
{
    ControlData(captureControl, instance, captureData, data);
	char str[50];
	int i;
	
	
	HRESULT hr;

    ASSERT(pWidth != NULL);
    ASSERT(pHeight != NULL);
    if (!pWidth || !pHeight)
        return E_POINTER;

    hr = GetResolutionFromDVDecoderPropertyPage( instance, hwndApp, bChangeResolution );
    //CHECK_ERROR( TEXT("CDVGraph::GetVideoWindowDimensions()::GetResolutionFromDVDecoderPropertyPage() failed."), hr); 

	i = sprintf(str, "GetResolutionFromDVDecoderPropertyPage = %d",hr);
	REALMessageBox(REALBuildString(str,i));
	
    switch (m_DVResolution)
    {
        case DVRESOLUTION_FULL:
            *pWidth = DVENCODER_WIDTH;
            if (DVENCODERVIDEOFORMAT_PAL == m_VideoFormat)
                *pHeight = PAL_DVENCODER_HEIGHT;
            else if (DVENCODERVIDEOFORMAT_NTSC == m_VideoFormat)
                *pHeight = NTSC_DVENCODER_HEIGHT;
            break;

        case DVRESOLUTION_HALF:
            *pWidth = DVENCODER_WIDTH/2;
            if (DVENCODERVIDEOFORMAT_PAL == m_VideoFormat)
                *pHeight = PAL_DVENCODER_HEIGHT/2;
            else if (DVENCODERVIDEOFORMAT_NTSC == m_VideoFormat)
                *pHeight = NTSC_DVENCODER_HEIGHT/2;
            break;

        case DVRESOLUTION_QUARTER:
            *pWidth = DVENCODER_WIDTH/4;
            if (DVENCODERVIDEOFORMAT_PAL == m_VideoFormat)
                *pHeight = PAL_DVENCODER_HEIGHT/4;
            else if (DVENCODERVIDEOFORMAT_NTSC == m_VideoFormat)
                *pHeight = NTSC_DVENCODER_HEIGHT/4;
            break;

        case DVRESOLUTION_DC:
            *pWidth = 88;
            if (DVENCODERVIDEOFORMAT_PAL == m_VideoFormat)
               *pHeight = PAL_DVENCODER_HEIGHT/8;
            else if (DVENCODERVIDEOFORMAT_NTSC == m_VideoFormat)
               *pHeight = NTSC_DVENCODER_HEIGHT/8;
            break;
    }

    return hr;
}



static long setAudioDeviceInput(REALcontrolInstance instance, long inputIndex)
{
    
    ControlData(captureControl, instance, captureData, data);
    
	if(data->pACap == NULL)
		return -1;

	int 				counter = 0;
	IAMAudioInputMixer 	*mixer = NULL;
    IPin 				*pP;
    ULONG 				u;
    IEnumPins 			*pins = NULL;
    PIN_INFO 			pininfo;
    HRESULT 			hr = data->pACap->EnumPins(&pins);

    pins->Reset();
        
    while(hr == NOERROR)
        {
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
                {
                        hr = pP->QueryPinInfo(&pininfo);
                        if(hr == NOERROR)
                        {
                                if(pininfo.dir == PINDIR_INPUT)
                                {
                                        pP->QueryInterface(IID_IAMAudioInputMixer, (void **)&mixer);
                                        if(mixer)
                                        {
                                                BOOL mEnabled = false;
                                                if(inputIndex == counter) mEnabled = true;

                                                mixer->put_Enable(mEnabled);
                                                
                                                mixer->Release();
                                        }

                                        counter++;
                                }
                                if(pininfo.pFilter)
                                        pininfo.pFilter->Release();
                        }
                        
            pP->Release();
        }
    }
    if(pins)
        pins->Release();

        return 0;
}


static long getAudioPinCount(REALcontrolInstance instance)
{
	ControlData(captureControl, instance, captureData, data);
    
	if(data->pACap == NULL)
		return -1;

	int 				counter = 0;
	IAMAudioInputMixer 	*mixer = NULL;
    IPin 				*pP;
    ULONG 				u;
    IEnumPins 			*pins = NULL;
    PIN_INFO 			pininfo;
    HRESULT 			hr = data->pACap->EnumPins(&pins);

    pins->Reset();
        
    while(hr == NOERROR)
        {
        hr = pins->Next(1, &pP, &u);
        if(hr == S_OK && pP)
                {
                        hr = pP->QueryPinInfo(&pininfo);
                        if(hr == NOERROR)
                        {
                                if(pininfo.dir == PINDIR_INPUT)
                                {
                                        counter++;
                                }
                                if(pininfo.pFilter)
                                        pininfo.pFilter->Release();
                        }
                        
            pP->Release();
        }
    }
    if(pins)
        pins->Release();

	return counter;
}

/*
static REALstring getAudioPinName(REALcontrolInstance instance, int pinIndex)
{
	
}
*/



#pragma mark -
//********************************************************************************************************
//********************************************************************************************************

REALproperty captureProperties[] = {
	{ "Appearance", "PreviewPicture", "Picture", REALpropInvalidate, REALstandardGetter, REALstandardSetter, FieldOffset(captureData, theNoPreviewPicture)},
	{ "InitialState", "EnableVideo", "Boolean", 0, (REALproc) captureGetEnableVideo, (REALproc) captureSetEnableVideo, 0 },
	{ "InitialState", "EnableSound", "Boolean", 0, (REALproc) captureGetEnableSound, (REALproc) captureSetEnableSound, 0 },
	{ nil, "UserSettings", "String", REALpropRuntimeOnly, (REALproc) captureGetSettings, (REALproc) captureSetSettings, 0 },
	{ nil, "PreviewMode", "Integer", REALpropRuntimeOnly, (REALproc) captureGetPreviewMode, (REALproc) captureSetPreviewMode, 0 },
	//{ "Behavior", "Preview", "Boolean", 0, REALstandardGetter, REALstandardSetter, FieldOffset(captureData, previewState)},
	{ "Behavior", "Preview", "Boolean", 0, (REALproc) captureGetPreviewState, (REALproc) captureSetPreviewState, 0 },
	//{ "Behavior", "PreviewWhileRecording", "Boolean", 0, REALstandardGetter, REALstandardSetter, FieldOffset(captureData, previewWhileRecording)},
	{ "Behavior", "PreviewWhileRecording", "Boolean", 0, (REALproc) captureGetPreviewWhileRecordingState, (REALproc) captureSetPreviewWhileRecordingState, 0 },
	{ nil, "Pause", "Boolean", REALpropRuntimeOnly, (REALproc) captureGetPause, (REALproc) captureSetPause, 0 },
	{ nil, "LevelMeterActive", "Boolean", REALpropRuntimeOnly, (REALproc) captureGetMeterState, (REALproc) captureSetMeterState, 0 },
	{ nil, "AGCActive", "Boolean", REALpropRuntimeOnly, (REALproc) captureGetAGCState, (REALproc) captureSetAGCState, 0 },
	{ nil, "SoundInputGain", "Integer", REALpropRuntimeOnly, (REALproc) captureGetGain, (REALproc) captureSetGain, 0 },
	{ nil, "SoundVolume", "Integer", REALpropRuntimeOnly, (REALproc) captureGetSoundVolume, (REALproc) captureSetSoundVolume, 0 },
	{ nil, "SampleRate", "Integer", REALpropRuntimeOnly, (REALproc) captureGetSampleRate, (REALproc) captureSetSampleRate, 0 },
	{ nil, "SampleSize", "Integer", REALpropRuntimeOnly, (REALproc) captureGetSampleSize, (REALproc) captureSetSampleSize, 0 },
	{ nil, "SoundChannelCount", "Integer", REALpropRuntimeOnly, (REALproc) captureGetNumChan, (REALproc) captureSetNumChan, 0 },
	{ nil, "SoundCompressionType", "String", REALpropRuntimeOnly, (REALproc) captureGetSoundCompressionType, (REALproc) captureSetSoundCompressionType, 0 },
	{ nil, "VideoCompressionType", "String", REALpropRuntimeOnly, (REALproc) captureGetVideoCompressionType, (REALproc) captureSetVideoCompressionType, 0 },
	{ nil, "VideoBlackLevel", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoBlackLevelValue, (REALproc) captureSetVideoBlackLevelValue, 0 }, // BJS 11/12/02
	{ nil, "VideoBrightness", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoBrightness, (REALproc) captureSetVideoBrightness, 0 }, // BJS 11/12/02
	{ nil, "VideoContrast", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoContrast, (REALproc) captureSetVideoContrast, 0 }, // BJS 11/12/02
	{ nil, "VideoHue", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoHue, (REALproc) captureSetVideoHue, 0 }, // BJS 11/12/02
	{ nil, "VideoSaturation", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSaturation, (REALproc) captureSetVideoSaturation, 0 }, // BJS 11/12/02
	{ nil, "VideoSharpness", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSharpness, (REALproc) captureSetVideoSharpness, 0 }, // BJS 11/12/02
	{ nil, "VideoWhiteLevel", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoWhiteLevelValue, (REALproc) captureSetVideoWhiteLevelValue, 0 }, // BJS 11/12/02
	{ nil, "FrameRate", "Double", REALpropRuntimeOnly, (REALproc) captureGetFrameRate, (REALproc) captureSetFrameRate, 0 },
	{ nil, "KeyFrameRate", "Integer", REALpropRuntimeOnly, (REALproc) captureGetKeyFrameRate, (REALproc) captureSetKeyFrameRate, 0 },
	{ nil, "VideoDepth", "Integer", REALpropRuntimeOnly, (REALproc) captureGetDepth, (REALproc) captureSetDepth, 0 },
	{ nil, "SpatialQuality", "Integer", REALpropRuntimeOnly, (REALproc) captureGetSpatialQuality, (REALproc) captureSetSpatialQuality, 0 },
	{ nil, "TemporalQuality", "Integer", REALpropRuntimeOnly, (REALproc) captureGetTemporalQuality, (REALproc) captureSetTemporalQuality, 0 },
	{ nil, "VideoWidth", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoWidth },
	{ nil, "VideoHeight", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoHeight },

//NEW PROPS - WE NEED TO ADD THESE TO MAC SIDE TOO
	{ nil, "VideoBrightnessMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoBrightnessMax },
	{ nil, "VideoBrightnessMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoBrightnessMin },
	{ nil, "VideoContrastMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoContrastMax },
	{ nil, "VideoContrastMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoContrastMin },
	{ nil, "VideoHueMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoHueMax },
	{ nil, "VideoHueMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoHueMin },
	{ nil, "VideoSaturationMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSaturationMax },
	{ nil, "VideoSaturationMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSaturationMin },
	{ nil, "VideoSharpnessMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSharpnessMax },
	{ nil, "VideoSharpnessMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoSharpnessMin },
	{ nil, "VideoWhiteLevelMax", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoWhiteLevelMax },
	{ nil, "VideoWhiteLevelMin", "Integer", REALpropRuntimeOnly, (REALproc) captureGetVideoWhiteLevelMin },
};


REALmethodDefinition captureMethods[] = {
	{ (REALproc) captureShowVideoSettingsDialog, REALnoImplementation, "ShowVideoSettings() As Boolean" },
	
//static Boolean captureShowVideoSettingsPinDialog(REALcontrolInstance instance)
	{ (REALproc) captureShowVideoSettingsPinDialog, REALnoImplementation, "ShowVideoPinSettings() As Boolean" },
	
	{ (REALproc) captureGetSoundDeviceCount, REALnoImplementation, "SoundDeviceCount() As Integer" },
	{ (REALproc) captureGetIndexedSoundDeviceName, REALnoImplementation, "SoundDevice(index As Integer) As String" },
	{ (REALproc) captureGetIndexedSoundDeviceAvailable, REALnoImplementation, "SoundDeviceAvailable(index As Integer) As Boolean" },
	{ (REALproc) captureGetSoundDeviceCurrent, REALnoImplementation, "SelectedSoundDevice() As Integer" },
	{ (REALproc) captureSetSoundDeviceName, REALnoImplementation, "SetSoundDevice(name As String)" },//no good on windows... probably...
	
	{ (REALproc) captureGetCurrentSoundDeviceSourceCount, REALnoImplementation, "SelectedSoundDeviceInputCount() As Integer" },//get # of pins from current sound device
	{ (REALproc) captureGetIndexedSoundDeviceSource, REALnoImplementation, "SoundInput(index As Integer) As String" },//get name of a pin from current sound device
	
	{ (REALproc) captureGetLeftLevel, REALnoImplementation, "LeftSoundLevelMeter() As Integer" },
	{ (REALproc) captureGetRightLevel, REALnoImplementation, "RightSoundLevelMeter() As Integer" },
	
	{ (REALproc) captureSetSoundDeviceSourceIndex, REALnoImplementation, "SetSoundInput(index As Integer)" },//selects a sound input


//{ (REALproc) setAudioDeviceInput, REALnoImplementation, "SetSoundInputPin(index As Integer) as integer" },
//{ (REALproc) getAudioPinCount, REALnoImplementation, "SoundInputPinCount() as integer" },
//static long getAudioPinCount(REALcontrolInstance instance)


	{ (REALproc) captureGetCurrentSoundDeviceSource, REALnoImplementation, "SelectedSoundInput() As Integer" },

	{ (REALproc) captureGetVideoDeviceCount, REALnoImplementation, "VideoDeviceCount() As Integer" },
	{ (REALproc) captureGetIndexedVideoDeviceName, REALnoImplementation, "VideoDevice(index As Integer) As String" },
	{ (REALproc) captureGetIndexedVideoDeviceAvailable, REALnoImplementation, "VideoDeviceAvailable(index As Integer) As Boolean" },
	{ (REALproc) captureGetVideoDeviceCurrent, REALnoImplementation, "SelectedVideoDevice() As Integer" },
	{ (REALproc) captureSetVideoDeviceName, REALnoImplementation, "SetVideoDevice(name As String)" },

	{ (REALproc) captureSetVideoDeviceSourceIndex, REALnoImplementation, "SetVideoInput(index As Integer)" },//this is the one I'm using so far... EJT 17 FEB 2004
	
	{ (REALproc) captureShowSoundSettingsDialog, REALnoImplementation, "ShowSoundSettings() As Boolean" },
	{ (REALproc) captureIsRecording, REALnoImplementation, "Recording() As Boolean" },
	{ (REALproc) captureStartRecordingAsync, REALnoImplementation, "RecordAsync(theMovieFile As FolderItem)" },
	{ (REALproc) captureStartRecordingAsyncTime, REALnoImplementation, "RecordAsync(theMovieFile As FolderItem, recordTicks As Integer)" },
	{ (REALproc) captureStartRecordingSync, REALnoImplementation, "RecordSync(theMovieFile As FolderItem)" },
	{ (REALproc) captureStartRecordingSyncTime, REALnoImplementation, "RecordSync(theMovieFile As FolderItem, recordTicks As Integer)" },
	{ (REALproc) captureStop, REALnoImplementation, "Stop()" },
	{ (REALproc) captureGrabPict, REALnoImplementation, "GrabPicture() As Picture" },
	
	
	{ (REALproc) captureDeviceControlShuttle, REALnoImplementation, "DeviceControlShuttle(Speed As Integer)" },
	{ (REALproc) captureDeviceControlPlayReverse, REALnoImplementation, "DeviceControlReversePlay()" },
	{ (REALproc) captureDeviceControlPlay, REALnoImplementation, "DeviceControlPlay()" },
	{ (REALproc) captureDeviceControlStop, REALnoImplementation, "DeviceControlStop()" },
	{ (REALproc) captureDeviceControlFreeze, REALnoImplementation, "DeviceControlPause()" },
	{ (REALproc) captureDeviceControlFastForward, REALnoImplementation, "DeviceControlFastForward()" },
	{ (REALproc) captureDeviceControlRewind, REALnoImplementation, "DeviceControlRewind()" },


	{ (REALproc) captureDeviceControlRecord, REALnoImplementation, "DeviceControlRecord()" },
	{ (REALproc) captureDeviceControlRecordFreeze, REALnoImplementation, "DeviceControlRecordPause()" },
	{ (REALproc) captureDeviceControlGetMode, REALnoImplementation, "DeviceControlGetMode() as integer" },

	
};

REALcontrolBehaviour captureBehaviour = {
	captureInit, 
	captureDispose,
	captureDraw, //the method called to redraw the control
	nil,
	nil,
	nil,
	nil,
	nil,
	nil,
	captureOpen,
	captureClose
};

REALcontrol captureControl = {
	kCurrentREALControlVersion,
	"BESTCapture",              // name of control
	sizeof(captureData),
	0,							// for invisible controls like Timer, use: REALinvisibleControl
	128,						//PICT resource for toolbar 
	129,						//PICT resource for toolbar (depressed)
	320, 240,					//the default size of the control when dragged to a window
	captureProperties,
	sizeof(captureProperties) / sizeof(REALproperty),
	captureMethods,
	sizeof(captureMethods) / sizeof(REALmethodDefinition),
	captureEvents,
	sizeof(captureEvents) / sizeof(REALevent),
	&captureBehaviour
};

static REALstring gCaptureGetIDPath(int index)
{
	char str[50];
	int i;

	if (REALinRuntime())
	{
	REALMessageBoxx(REALBuildString("GetIDPath",9));
	
	switch (index)
		{
		case 0:
			i = sprintf(str, "bestDeviceDefaultPath = %s",(wtoa(bestDeviceDefaultPath,lstrlenW(bestDeviceDefaultPath))));
			return REALBuildString(str,i);
			break;
		case 1:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice1Path,lstrlenW(bestDevice1Path))));
			return REALBuildString(str,i);
			break;
		case 2:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice2Path,lstrlenW(bestDevice2Path))));
			return REALBuildString(str,i);
			break;
		case 3:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice3Path,lstrlenW(bestDevice3Path))));
			return REALBuildString(str,i);
			break;
		case 4:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice4Path,lstrlenW(bestDevice4Path))));
			return REALBuildString(str,i);
			break;
		case 5:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice5Path,lstrlenW(bestDevice5Path))));
			return REALBuildString(str,i);
			break;
		case 6:
			i = sprintf(str, "bestDevice1Path = %s",(wtoa(bestDevice6Path,lstrlenW(bestDevice6Path))));
			return REALBuildString(str,i);
			break;
		}
	}
	return NULL;
	
	/*
	switch (index)
		{
		case 0:
			i = sprintf(str, "bestDeviceDefault = %s",(wtoa(bestDeviceDefault,lstrlenW(bestDeviceDefault))));
			return REALBuildString(str,i);
			break;
		case 1:
			i = sprintf(str, "bestDeviceID1 = %s",(wtoa(bestDeviceID1,lstrlenW(bestDeviceID1))));
			return REALBuildString(str,i);
			break;
		case 2:
			i = sprintf(str, "bestDeviceID2 = %s",(wtoa(bestDeviceID2,lstrlenW(bestDeviceID2))));
			return REALBuildString(str,i);
			break;
		case 3:
			i = sprintf(str, "bestDeviceID3 = %s",(wtoa(bestDeviceID3,lstrlenW(bestDeviceID3))));
			return REALBuildString(str,i);
			break;
		case 4:
			i = sprintf(str, "bestDeviceID4 = %s",(wtoa(bestDeviceID4,lstrlenW(bestDeviceID4))));
			return REALBuildString(str,i);
			break;
		case 5:
			i = sprintf(str, "bestDeviceID5 = %s",(wtoa(bestDeviceID5,lstrlenW(bestDeviceID5))));
			return REALBuildString(str,i);
			break;
		case 6:
			i = sprintf(str, "bestDeviceID6 = %s",(wtoa(bestDeviceID6,lstrlenW(bestDeviceID6))));
			return REALBuildString(str,i);
			break;
		}
	}
	return NULL;
	*/
}





REALmethodDefinition gCaptureGetIDDef = {(REALproc) gCaptureGetIDPath, REALnoImplementation, "BESTGetDevicePath(index As Integer) As String" };

void PluginEntry(void)
{
	REALRegisterControl(&captureControl);
	REALRegisterMethod(&gCaptureGetIDDef);

	if (REALinRuntime())
		{
		REALMessageBoxx(REALBuildString("Plugin Entry", 12));
		
		/*
		SysAllocString(bestDeviceDefault);
		SysAllocString(bestDeviceID1);
		SysAllocString(bestDeviceID2);
		SysAllocString(bestDeviceID3);
		SysAllocString(bestDeviceID4);
		SysAllocString(bestDeviceID5);
		SysAllocString(bestDeviceID6);
		
		bestDeviceDefault = L"Unused Device";
		bestDeviceID1 = L"Unused Device";
		bestDeviceID2 = L"Unused Device";
		bestDeviceID3 = L"Unused Device";
		bestDeviceID4 = L"Unused Device";
		bestDeviceID5 = L"Unused Device";
		bestDeviceID6 = L"Unused Device";
		*/
		
		bestDeviceDefault = SysAllocString(L"Unused Device");
		bestDeviceID1 = SysAllocString(L"Unused Device");
		bestDeviceID2 = SysAllocString(L"Unused Device");
		bestDeviceID3 = SysAllocString(L"Unused Device");
		bestDeviceID4 = SysAllocString(L"Unused Device");
		bestDeviceID5 = SysAllocString(L"Unused Device");
		bestDeviceID6 = SysAllocString(L"Unused Device");
		
		//a26d code - EJT
		// bestDevice1Path
		
		bestDeviceDefaultPath = SysAllocString(L"Unused Device");
		bestDevice1Path = SysAllocString(L"Unused Device");
		bestDevice2Path = SysAllocString(L"Unused Device");
		bestDevice3Path = SysAllocString(L"Unused Device");
		bestDevice4Path = SysAllocString(L"Unused Device");
		bestDevice5Path = SysAllocString(L"Unused Device");
		bestDevice6Path = SysAllocString(L"Unused Device");
		//  EJT D-VERSION
		/*
				bestDevice1Path, 
				bestDevice2Path, 
				bestDevice3Path, 
				bestDevice4Path, 
				bestDevice5Path, 
				bestDevice6Path, 
				bestDeviceDefaultPath;

				bestDevice1Name, 
				bestDevice2Name, 
				bestDevice3Name, 
				bestDevice4Name, 
				bestDevice5Name, 
				bestDevice6Name, 
				bestDeviceDefaultName;				

				bestDevice1Active, 
				bestDevice2Active, 
				bestDevice3Active, 
				bestDevice4Active, 
				bestDevice5Active, 
				bestDevice6Active, 
				bestDeviceActive;
		*/
		//  EJT D-VERSION

		}
}
